DECLARE SUB mc.ix (rg AS ANY)
DECLARE SUB mc.iy (rg AS ANY)
DECLARE SUB mc.zx (rg AS ANY)
DECLARE SUB codes (I%)
DECLARE FUNCTION exec6502% ()
DECLARE FUNCTION m.dec% (a%)
DECLARE SUB mc.ab (a AS ANY)
DECLARE SUB mc.ay (a AS ANY)
DECLARE SUB mc.zp (rg AS ANY)
DECLARE SUB mc.zy (rg AS ANY)
DECLARE SUB wr6502 (a%, B%)
DECLARE FUNCTION both% (a AS ANY)
DECLARE SUB mc.ax (a AS ANY)
DECLARE FUNCTION m.inc% (a%)
DECLARE SUB M.JR ()
DECLARE SUB m.pop (a AS INTEGER)
DECLARE FUNCTION low% (a%)
DECLARE FUNCTION high% (a%)
DECLARE SUB lows (a%, B%)
DECLARE FUNCTION Op6502! (a%)
DECLARE SUB highs (a%, B%)
DECLARE SUB m.push (a%)
DECLARE SUB m.ldword (a AS ANY)
DECLARE FUNCTION rd6502% (a%)
DECLARE SUB m.fl (a%)
DECLARE SUB mr.zp (a%)
DECLARE SUB m.bit (a%)
DECLARE SUB mr.ab (a%)
DECLARE SUB m.ora (a%)
DECLARE SUB mm.zp (a%)
DECLARE SUB m.and (a%)
DECLARE SUB m.eor (a%)
DECLARE SUB m.adc (a%)
DECLARE SUB mw.zp (a%)
DECLARE SUB m.cmp (a%, B%)
DECLARE SUB m.sbc (a%)
DECLARE SUB mm.ab (a%)
DECLARE SUB mw.ab (a%)
DECLARE SUB mr.im (a%)
DECLARE SUB mr.zx (a%)
DECLARE SUB mm.zx (a%)
DECLARE SUB mw.zx (a%)
DECLARE SUB mw.zy (a%)
DECLARE SUB mr.zy (a%)
DECLARE SUB mr.ay (a%)
DECLARE SUB mr.ax (a%)
DECLARE SUB mm.ax (a%)
DECLARE SUB mw.ay (a%)
DECLARE SUB mw.ax (a%)
DECLARE SUB mr.ix (a%)
DECLARE SUB mr.iy (a%)
DECLARE SUB mw.ix (a%)
DECLARE SUB mw.iy (a%)
DECLARE SUB m.asll (a%)
DECLARE SUB m.roll (a%)
DECLARE SUB m.lsrr (a%)
DECLARE SUB m.rorr (a%)
DEFINT A-Z


TYPE bb  'change this around for lsb fists, last
l AS INTEGER
h AS INTEGER
END TYPE


TYPE pcc
 w AS INTEGER
 B AS bb
END TYPE
TYPE regg
 P AS INTEGER        'on byte register
 a AS INTEGER
 x AS INTEGER
 y AS INTEGER
 s AS INTEGER
 PC AS pcc
 IRequest AS INTEGER
 icount AS INTEGER
 IBackup AS INTEGER
 AfterCLI AS INTEGER
END TYPE


'byte = unsigned char (1)
'word = unsigned short (2)
'offset = signed char

'type pair
' word w
' int b {byte l,h}
'end type
' n
' n.w
' n.b (n.b.l,n.b.h)


                       '       /* 6502 status flags:         */
CONST c.flag = &H1     '       /* 1: Carry occured           */
CONST z.flag = &H2     '       /* 1: Result is zero          */
CONST I.FLAG = &H4     '       /* 1: Interrupts disabled     */
CONST d.flag = &H8     '       /* 1: Decimal mode            */
CONST B.FLAG = &H10    '       /* Break [0 on stk after int] */
CONST R.FLAG = &H20    '       /* Always 1                   */
CONST v.flag = &H40    '       /* 1: Overflow occured        */
CONST n.flag = &H80    '       /* 1: Result is negative      */

'                      '       /* Loop6502() returns:        */
CONST INT.NONE = 0     '       /* No interrupt required      */
CONST INT.IRQ = 1      '       /* Standard IRQ interrupt     */
CONST INT.NMI = 2      '       /* Non-maskable interrupt     */
CONST INT.QUIT = 3     '       /* Exit the emulation         */


DIM SHARED reg AS regg, k AS pcc, j AS pcc, cycles%(255), zntable%(255), I

RESTORE cycledata
FOR ii = 0 TO 255: READ cycles%(ii): NEXT ii
RESTORE zntabledata
FOR ii = 0 TO 255: READ zntable%(ii): NEXT ii
END


cycledata:
'static byte Cycles[256] =
DATA  7,6,2,8,3,3,5,5,3,2,2,2,4,4,6,6
DATA  2,5,2,8,4,4,6,6,2,4,2,7,5,5,7,7
DATA  6,6,2,8,3,3,5,5,4,2,2,2,4,4,6,6
DATA  2,5,2,8,4,4,6,6,2,4,2,7,5,5,7,7
DATA  6,6,2,8,3,3,5,5,3,2,2,2,3,4,6,6
DATA  2,5,2,8,4,4,6,6,2,4,2,7,5,5,7,7
DATA  6,6,2,8,3,3,5,5,4,2,2,2,5,4,6,6
DATA  2,5,2,8,4,4,6,6,2,4,2,7,5,5,7,7
DATA  2,6,2,6,3,3,3,3,2,2,2,2,4,4,4,4
DATA  2,6,2,6,4,4,4,4,2,5,2,5,5,5,5,5
DATA  2,6,2,6,3,3,3,3,2,2,2,2,4,4,4,4
DATA  2,5,2,5,4,4,4,4,2,4,2,5,4,4,4,4
DATA  2,6,2,8,3,3,5,5,2,2,2,2,4,4,6,6
DATA  2,5,2,8,4,4,6,6,2,4,2,7,5,5,7,7
DATA  2,6,2,8,3,3,5,5,2,2,2,2,4,4,6,6
DATA  2,5,2,8,4,4,6,6,2,4,2,7,5,5,7,7



zntabledata:
'byte ZNTable[256] =

'DATA  Z.FLAG,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA  2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

DATA  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

'new
DATA  128,128,128,128,128,128,128,128
DATA  128,128,128,128,128,128,128,128
DATA  128,128,128,128,128,128,128,128
DATA  128,128,128,128,128,128,128,128
DATA  128,128,128,128,128,128,128,128
DATA  128,128,128,128,128,128,128,128
DATA  128,128,128,128,128,128,128,128
DATA  128,128,128,128,128,128,128,128
DATA  128,128,128,128,128,128,128,128
DATA  128,128,128,128,128,128,128,128
DATA  128,128,128,128,128,128,128,128
DATA  128,128,128,128,128,128,128,128
DATA  128,128,128,128,128,128,128,128
DATA  128,128,128,128,128,128,128,128
DATA  128,128,128,128,128,128,128,128
DATA  128,128,128,128,128,128,128,128









'old
'DATA  N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG
'DATA  N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG
'DATA  N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG
'DATA  N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG
'DATA  N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG
'DATA  N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG
'DATA  N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG
'DATA  N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG
'DATA  N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG
'DATA  N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG
'DATA  N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG
'DATA  N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG
'DATA  N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG
'DATA  N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG
'DATA  N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG
'DATA  N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG

FUNCTION both (a AS bb)
both% = CVI(CHR$(ASC(MKI$(a.l))) + CHR$(ASC(MKI$(a.h))))
END FUNCTION

SUB codes (I)
SELECT CASE I
CASE &H10': if(R->P&N_FLAG) R->PC.W++; else { M_JR; } break; /* BPL * REL */
  IF reg.P AND n.flag THEN reg.PC.w = reg.PC.w + 1:  ELSE : M.JR


CASE &H30': if(R->P&N_FLAG) { M_JR; } else R->PC.W++; break; /* BMI * REL */
  IF NOT (P.R AND n.flag) THEN : PC.W.R = PC.W.R + 1:  ELSE : M.JR

CASE &HD0': if(R->P&Z_FLAG) R->PC.W++; else { M_JR; } break; /* BNE * REL */
  IF reg.P AND z.flag THEN reg.PC.w = reg.PC.w + 1:  ELSE : M.JR

CASE &HF0': if(R->P&Z_FLAG) { M_JR; } else R->PC.W++; break; /* BEQ * REL */
  IF NOT (reg.P AND z.flag) THEN reg.PC.w = reg.PC.w + 1:   ELSE : M.JR


CASE &H90': if(R->P&C_FLAG) R->PC.W++; else { M_JR; } break; /* BCC * REL */
  IF reg.P AND c.flag THEN reg.PC.w = reg.PC.w + 1:  ELSE : M.JR


CASE &HB0': if(R->P&C_FLAG) { M_JR; } else R->PC.W++; break; /* BCS * REL */
  IF NOT (reg.P AND c.flag) THEN reg.PC.w = reg.PC.w + 1:  ELSE : M.JR


CASE &H50': if(R->P&V_FLAG) R->PC.W++; else { M_JR; } break; /* BVC * REL */
  IF reg.P AND v.flag THEN reg.PC.w = reg.PC.w + 1:  ELSE : M.JR




CASE &H70': if(R->P&V_FLAG) { M_JR; } else R->PC.W++; break; /* BVS * REL */
  IF NOT (reg.P AND v.flag) THEN : reg.PC.w = reg.PC.w + 1:  ELSE : M.JR


'/* RTI */
CASE &H40:  '  M_POP(R->P);R->P|=R_FLAG;M_POP(R->PC.B.l);M_POP(R->PC.B.h);
  m.pop reg.P
  reg.P = reg.P OR R.FLAG
  m.pop reg.PC.B.l
  m.pop reg.PC.B.h


'/* RTS */
CASE &H60:
'  M_POP(R->PC.B.l);M_POP(R->PC.B.h);R->PC.W++;break;
   m.pop reg.PC.B.l
   m.pop reg.PC.B.h
   reg.PC.w = reg.PC.w + 1


'/* JSR $ssss ABS */
CASE &H20: '  K.B.l=Op6502(R->PC.W++);'  K.B.h=Op6502(R->PC.W);'  M_PUSH(R->PC.B.h);'  M_PUSH(R->PC.B.l);'  R->PC=K;break;
   reg.PC.w = reg.PC.w + 1
   k.B.l = Op6502(reg.PC.w)
   k.B.h = Op6502(reg.PC.w)
   m.push reg.PC.B.h
   m.push reg.PC.B.l
   reg.PC = k

'/* JMP $ssss ABS */
CASE &H4C': M_LDWORD(K);R->PC=K;break;
 m.ldword k
 reg.PC = k


'/* JMP ($ssss) ABDINDIR */
CASE &H6C: '  M_LDWORD(K);'  R->PC.B.l=Rd6502(K.W++);'  R->PC.B.h=Rd6502(K.W);'  break;
   m.ldword k
   k.w = k.w + 1
   reg.PC.B.l = rd6502(k.w)
   reg.PC.B.h = rd6502(k.w)

'/* BRK */
CASE &H0: '  R->PC.W++;'  M_PUSH(R->PC.B.h);M_PUSH(R->PC.B.l);'  M_PUSH(R->P|B_FLAG);'  R->P=(R->P|I_FLAG)&~D_FLAG;'  R->PC.B.l=Rd6502(&HFFFE);'  R->PC.B.h=Rd6502(&HFFFF);'  break;
   reg.PC.w = reg.PC.w + 1
   m.push reg.PC.B.h
   m.push reg.PC.B.l
   reg.P = (reg.P OR I.FLAG) AND NOT (d.flag)
   reg.PC.B.l = rd6502(&HFFFE)
   reg.PC.B.h = rd6502(&HFFFF)


'/* CLI */
CASE &H58:
'  if((R->IRequest!=INT_NONE)&&(R->P&I_FLAG))
'  {
'    R->AfterCLI=1;
'    R->IBackup=R->ICount;
'    R->ICount=1;
'  }
'  R->P&=~I_FLAG;
'  break;

   IF (reg.IRequest <> INT.NONE) AND ((reg.P AND I.FLAG) <> 0) THEN
   reg.AfterCLI = 1
   reg.IBackup = reg.icount
   END IF
   reg.P = reg.P AND NOT (I.FLAG)


'/* PLP */
CASE &H28:
'  M_POP(I);
'  if((R->IRequest!=INT_NONE)&&((I^R->P)&~I&I_FLAG))
'  {
'    R->AfterCLI=1;
'    R->IBackup=R->ICount;
'    R->ICount=1;
'  }
'  R->P=I|R_FLAG;
'  break;
'
   m.pop I
   IF (reg.IRequest <> int.mode) AND ((I ^ reg.P) AND NOT (I) AND I.FLAG) THEN
     reg.AfterCLI = 1
     reg.IBackup = r.icound
     reg.icount = 1
   END IF
   reg.P = I OR R.FLAG



CASE &H8 ': M_PUSH(R->P);break;               /* PHP */
            m.push reg.P


CASE &H18': R->P&=~C_FLAG;break;              /* CLC */
            reg.P = reg.P AND NOT (c.flag)

CASE &HB8': R->P&=~V_FLAG;break;              /* CLV */
            reg.P = reg.P AND NOT (v.flag)

CASE &HD8': R->P&=~D_FLAG;break;              /* CLD */
            reg.P = reg.P AND NOT (d.flag)

CASE &H38': R->P|=C_FLAG;break;               /* SEC */
            reg.P = reg.P OR c.flag

CASE &HF8': R->P|=D_FLAG;break;               /* SED */
            reg.P = reg.P OR d.flag

CASE &H78': R->P|=I_FLAG;break;               /* SEI */
            reg.P = reg.P OR I.FLAG


CASE &H48': M_PUSH(R->A);break;               /* PHA */
            m.push reg.a
CASE &H68': M_POP(R->A);M_FL(R->A);break;     /* PLA */
            m.pop reg.a: m.fl reg.a
CASE &H98': R->A=R->Y;M_FL(R->A);break;       /* TYA */
            reg.a = reg.y: m.fl reg.a
CASE &HA8': R->Y=R->A;M_FL(R->Y);break;       /* TAY */
            reg.y = reg.a: m.fl reg.y
CASE &HC8': R->Y++;M_FL(R->Y);break;          /* INY */
            reg.y = reg.y + 1: m.fl reg.y
CASE &H88': R->Y--;M_FL(R->Y);break;          /* DEY */
            reg.y = reg.y - 1: m.fl reg.y
CASE &H8A': R->A=R->X;M_FL(R->A);break;       /* TXA */
            reg.a = reg.x: m.fl reg.a
CASE &HAA': R->X=R->A;M_FL(R->X);break;       /* TAX */
            reg.x = reg.a: m.fl reg.x
CASE &HE8': R->X++;M_FL(R->X);break;          /* INX */
            reg.x = reg.x + 1: m.fl reg.x
CASE &HCA': R->X--;M_FL(R->X);break;          /* DEX */
            reg.x = reg.x - 1: m.fl reg.x

CASE &HEA': break;                            /* NOP */

CASE &H9A': R->S=R->X;break;                  /* TXS */
            ref.s = reg.x
CASE &HBA': R->X=R->S;break;                  /* TSX */
            reg.x = reg.s
CASE &H24': MR_Zp(I);M_BIT(I);break;       /* BIT $ss ZP */
            mr.zp I: m.bit I
CASE &H2C': MR_Ab(I);M_BIT(I);break;       /* BIT $ssss ABS */
            mr.ab I: m.bit I

CASE &H5 ': MR_Zp(I);M_ORA(I);break;       /* ORA $ss ZP */
            mr.zp I: m.ora I

CASE &H6 ': MM_Zp(M_ASL);break;            /* ASL $ss ZP */
            mm.zp m.asl

CASE &H25': MR_Zp(I);M_AND(I);break;       /* AND $ss ZP */
            mr.zp I: m.and I

CASE &H26': MM_Zp(M_ROL);break;            /* ROL $ss ZP */
            mr.zp m.rol

CASE &H45': MR_Zp(I);M_EOR(I);break;       /* EOR $ss ZP */
            mr.zp I: m.eor I

CASE &H46': MM_Zp(M_LSR);break;            /* LSR $ss ZP */
            mm.zp m.lsr

CASE &H65': MR_Zp(I);M_ADC(I);break;       /* ADC $ss ZP */
            mr.zp I: m.adc I


CASE &H66': MM_Zp(M_ROR);break;            /* ROR $ss ZP */
            mm.zp m.ror

CASE &H84': MW_Zp(R->Y);break;             /* STY $ss ZP */
            mw.zp reg.y

CASE &H85': MW_Zp(R->A);break;             /* STA $ss ZP */
            mw.zp reg.a

CASE &H86': MW_Zp(R->X);break;             /* STX $ss ZP */
            mw.zp reg.x

CASE &HA4': MR_Zp(R->Y);M_FL(R->Y);break;  /* LDY $ss ZP */
            mr.zp reg.y

CASE &HA5': MR_Zp(R->A);M_FL(R->A);break;  /* LDA $ss ZP */
            mr.zp reg.a: m.fl reg.a

CASE &HA6': MR_Zp(R->X);M_FL(R->X);break;  /* LDX $ss ZP */
            mr.zp reg.x: m.fl reg.x

CASE &HC4': MR_Zp(I);M_CMP(R->Y,I);break;  /* CPY $ss ZP */
            mr.zp I: m.cmp reg.y, I

CASE &HC5': MR_Zp(I);M_CMP(R->A,I);break;  /* CMP $ss ZP */
            mr.zp I: m.cmp reg.a, I

CASE &HC6': MM_Zp(M_DEC);break;            /* DEC $ss ZP */
'error
'            mr.zp m.dec

CASE &HE4': MR_Zp(I);M_CMP(R->X,I);break;  /* CPX $ss ZP */
            mr.zp I: m.cmp reg.x, I

CASE &HE5': MR_Zp(I);M_SBC(I);break;       /* SBC $ss ZP */
            mr.zp I: m.sbc I

CASE &HE6': MM_Zp(M_INC);break;            /* INC $ss ZP */
'            mm.zp m.inc
'error
CASE &HD ': MR_Ab(I);M_ORA(I);break;       /* ORA $ssss ABS */
            mr.ab I: m.ora I

CASE &HE ': MM_Ab(M_ASL);break;            /* ASL $ssss ABS */
            mm.ab m.asl
CASE &H2D': MR_Ab(I);M_AND(I);break;       /* AND $ssss ABS */
            mr.ab I: m.and I

CASE &H2E': MM_Ab(M_ROL);break;            /* ROL $ssss ABS */
            mm.ab m.rol
CASE &H4D': MR_Ab(I);M_EOR(I);break;       /* EOR $ssss ABS */
            mr.ab I: m.eor I
CASE &H4E': MM_Ab(M_LSR);break;            /* LSR $ssss ABS */
            mm.ab m.lsr

CASE &H6D': MR_Ab(I);M_ADC(I);break;       /* ADC $ssss ABS */
            mr.ab I: m.adc I
CASE &H6E': MM_Ab(M_ROR);break;            /* ROR $ssss ABS */
            mm.ab m.ror
CASE &H8C': MW_Ab(R->Y);break;             /* STY $ssss ABS */
            mw.ab reg.y
CASE &H8D': MW_Ab(R->A);break;             /* STA $ssss ABS */
            mw.ab reg.a
CASE &H8E': MW_Ab(R->X);break;             /* STX $ssss ABS */
            mw.ab reg.x

CASE &HAC': MR_Ab(R->Y);M_FL(R->Y);break;  /* LDY $ssss ABS */
            mr.ab reg.y: m.fl reg.y
CASE &HAD': MR_Ab(R->A);M_FL(R->A);break;  /* LDA $ssss ABS */
            mr.ab reg.a: m.fl reg.a

CASE &HAE': MR_Ab(R->X);M_FL(R->X);break;  /* LDX $ssss ABS */
            mr.ab reg.x: m.fl reg.x

CASE &HCC': MR_Ab(I);M_CMP(R->Y,I);break;  /* CPY $ssss ABS */
            mr.ab I: m.cmp reg.y, I

CASE &HCD': MR_Ab(I);M_CMP(R->A,I);break;  /* CMP $ssss ABS */
            mr.ab I: m.cmp reg.a, I

CASE &HCE': MM_Ab(M_DEC);break;            /* DEC $ssss ABS */
'error
'            mr.ab m.dec

CASE &HEC': MR_Ab(I);M_CMP(R->X,I);break;  /* CPX $ssss ABS */
            mr.ab I: m.cmp reg.x, I

CASE &HED': MR_Ab(I);M_SBC(I);break;       /* SBC $ssss ABS */
            mr.ab I: m.sbc I

CASE &HEE': MM_Ab(M_INC);break;            /* INC $ssss ABS */
'error
'            mm.ab m.inc

CASE &H9 ': MR_Im(I);M_ORA(I);break;       /* ORA #$ss IMM */
            mr.im I: m.ora I
CASE &H29': MR_Im(I);M_AND(I);break;       /* AND #$ss IMM */
            mr.im I: m.and I
CASE &H49': MR_Im(I);M_EOR(I);break;       /* EOR #$ss IMM */
            mr.im I: m.eor I
CASE &H69': MR_Im(I);M_ADC(I);break;       /* ADC #$ss IMM */
            mr.im I: m.adc I

CASE &HA0': MR_Im(R->Y);M_FL(R->Y);break;  /* LDY #$ss IMM */
            mr.im reg.y: m.fl reg.y
CASE &HA2': MR_Im(R->X);M_FL(R->X);break;  /* LDX #$ss IMM */
            mr.im reg.x: m.fl reg.x

CASE &HA9': MR_Im(R->A);M_FL(R->A);break;  /* LDA #$ss IMM */
            mr.im reg.a: m.fl reg.a

CASE &HC0': MR_Im(I);M_CMP(R->Y,I);break;  /* CPY #$ss IMM */
            mr.im I: m.cmp reg.y, I
CASE &HC9': MR_Im(I);M_CMP(R->A,I);break;  /* CMP #$ss IMM */
            mr.im I: m.cmp reg.a, I

CASE &HE0': MR_Im(I);M_CMP(R->X,I);break;  /* CPX #$ss IMM */
            mr.im I: m.cmp reg.x, I

CASE &HE9': MR_Im(I);M_SBC(I);break;       /* SBC #$ss IMM */
            mr.im I: m.sbc I
CASE &H15': MR_Zx(I);M_ORA(I);break;       /* ORA $ss,x ZP,x */
            mr.zx I: m.ora I
CASE &H16': MM_Zx(M_ASL);break;            /* ASL $ss,x ZP,x */
            mr.zx m.asl

CASE &H35': MR_Zx(I);M_AND(I);break;       /* AND $ss,x ZP,x */
            mr.zx I: m.and I

CASE &H36': MM_Zx(M_ROL);break;            /* ROL $ss,x ZP,x */
            mm.zx m.rol
CASE &H55': MR_Zx(I);M_EOR(I);break;       /* EOR $ss,x ZP,x */
            mr.zx I: m.eor I
CASE &H56': MM_Zx(M_LSR);break;            /* LSR $ss,x ZP,x */
            mm.zx m.lsr
CASE &H75': MR_Zx(I);M_ADC(I);break;       /* ADC $ss,x ZP,x */
            mr.zx I: m.adc I
CASE &H76': MM_Zx(M_ROR);break;            /* ROR $ss,x ZP,x */
            mm.zx m.ror
CASE &H94': MW_Zx(R->Y);break;             /* STY $ss,x ZP,x */
            mw.zx reg.y
CASE &H95': MW_Zx(R->A);break;             /* STA $ss,x ZP,x */
            mw.zx reg.a
CASE &H96': MW_Zy(R->X);break;             /* STX $ss,y ZP,y */
            mw.zy reg.x
CASE &HB4': MR_Zx(R->Y);M_FL(R->Y);break;  /* LDY $ss,x ZP,x */
            mr.zx reg.y: m.fl reg.y
CASE &HB5': MR_Zx(R->A);M_FL(R->A);break;  /* LDA $ss,x ZP,x */
            mr.zx reg.a: m.fl reg.a

CASE &HB6': MR_Zy(R->X);M_FL(R->X);break;  /* LDX $ss,y ZP,y */
            mr.zy reg.x: m.fl reg.x

CASE &HD5': MR_Zx(I);M_CMP(R->A,I);break;  /* CMP $ss,x ZP,x */
            mr.zx I: m.cmp reg.a, I

CASE &HD6': MM_Zx(M_DEC);break;            /* DEC $ss,x ZP,x */
'error
'            mm.zx m.dec

CASE &HF5': MR_Zx(I);M_SBC(I);break;       /* SBC $ss,x ZP,x */
            mr.zx I: m.sbc I
CASE &HF6': MM_Zx(M_INC);break;            /* INC $ss,x ZP,x */
'error
'            mm.zx m.inc

CASE &H19': MR_Ay(I);M_ORA(I);break;       /* ORA $ssss,y ABS,y */
            mr.ay I: m.ora I
CASE &H1D': MR_Ax(I);M_ORA(I);break;       /* ORA $ssss,x ABS,x */
            mr.ax I: m.ora I
CASE &H1E': MM_Ax(M_ASL);break;            /* ASL $ssss,x ABS,x */
            mm.ax m.asl
CASE &H39': MR_Ay(I);M_AND(I);break;       /* AND $ssss,y ABS,y */
            mr.ay I: m.and I
CASE &H3D': MR_Ax(I);M_AND(I);break;       /* AND $ssss,x ABS,x */
            mr.ax I: m.and I
CASE &H3E': MM_Ax(M_ROL);break;            /* ROL $ssss,x ABS,x */
            mm.ax m.rol
CASE &H59': MR_Ay(I);M_EOR(I);break;       /* EOR $ssss,y ABS,y */
            mr.ay I: m.eor I
CASE &H5D': MR_Ax(I);M_EOR(I);break;       /* EOR $ssss,x ABS,x */
            mr.ax I: m.eor I
CASE &H5E': MM_Ax(M_LSR);break;            /* LSR $ssss,x ABS,x */
            mm.ax m.lsr
CASE &H79': MR_Ay(I);M_ADC(I);break;       /* ADC $ssss,y ABS,y */
            mr.ay I: m.adc I
CASE &H7D': MR_Ax(I);M_ADC(I);break;       /* ADC $ssss,x ABS,x */
            mr.ax I: m.adc I
CASE &H7E': MM_Ax(M_ROR);break;            /* ROR $ssss,x ABS,x */
            mm.ax m.ror
CASE &H99': MW_Ay(R->A);break;             /* STA $ssss,y ABS,y */
            mw.ay reg.a
CASE &H9D': MW_Ax(R->A);break;             /* STA $ssss,x ABS,x */
            mw.ax reg.a
CASE &HB9': MR_Ay(R->A);M_FL(R->A);break;  /* LDA $ssss,y ABS,y */
            mr.ay reg.a: m.fl reg.a
CASE &HBC': MR_Ax(R->Y);M_FL(R->Y);break;  /* LDY $ssss,x ABS,x */
            mr.ax reg.y: m.fl reg.y

CASE &HBD': MR_Ax(R->A);M_FL(R->A);break;  /* LDA $ssss,x ABS,x */
            mr.ax reg.a: m.fl reg.a

CASE &HBE': MR_Ay(R->X);M_FL(R->X);break;  /* LDX $ssss,y ABS,y */
            mr.ay reg.x: m.fl reg.x

CASE &HD9': MR_Ay(I);M_CMP(R->A,I);break;  /* CMP $ssss,y ABS,y */
            mr.ay I: m.cmp reg.a, I

CASE &HDD': MR_Ax(I);M_CMP(R->A,I);break;  /* CMP $ssss,x ABS,x */
            mr.ax I: m.cmp reg.a, I

CASE &HDE': MM_Ax(M_DEC);break;            /* DEC $ssss,x ABS,x */
'error
'            mm.ax m.dec

CASE &HF9': MR_Ay(I);M_SBC(I);break;       /* SBC $ssss,y ABS,y */
            mr.ay I: m.sbc I
CASE &HFD': MR_Ax(I);M_SBC(I);break;       /* SBC $ssss,x ABS,x */
            mr.ax I: m.sbc I
CASE &HFE': MM_Ax(M_INC);break;            /* INC $ssss,x ABS,x */
'error
'            mm.ax m.inc
CASE &H1 ': MR_Ix(I);M_ORA(I);break;       /* ORA ($ss,x) INDEXINDIR */
            mr.ix I: m.ora I
CASE &H11': MR_Iy(I);M_ORA(I);break;       /* ORA ($ss),y INDIRINDEX */
            mr.iy I: m.ora I
CASE &H21': MR_Ix(I);M_AND(I);break;       /* AND ($ss,x) INDEXINDIR */
            mr.ix I: m.and I
CASE &H31': MR_Iy(I);M_AND(I);break;       /* AND ($ss),y INDIRINDEX */
            mr.iy I: m.and I
CASE &H41': MR_Ix(I);M_EOR(I);break;       /* EOR ($ss,x) INDEXINDIR */
            mr.ix I: m.eor I
CASE &H51': MR_Iy(I);M_EOR(I);break;       /* EOR ($ss),y INDIRINDEX */
            mr.iy I: m.eor I
CASE &H61': MR_Ix(I);M_ADC(I);break;       /* ADC ($ss,x) INDEXINDIR */
            mr.ix I: m.adc I
CASE &H71': MR_Iy(I);M_ADC(I);break;       /* ADC ($ss),y INDIRINDEX */
            mr.iy I: m.adc I
CASE &H81': MW_Ix(R->A);break;             /* STA ($ss,x) INDEXINDIR */
            mw.ix reg.a
CASE &H91': MW_Iy(R->A);break;             /* STA ($ss),y INDIRINDEX */
            mw.iy reg.a
CASE &HA1': MR_Ix(R->A);M_FL(R->A);break;  /* LDA ($ss,x) INDEXINDIR */
            mr.ix reg.a: m.fl reg.a
CASE &HB1': MR_Iy(R->A);M_FL(R->A);break;  /* LDA ($ss),y INDIRINDEX */
            mr.iy reg.a: m.fl reg.a

CASE &HC1': MR_Ix(I);M_CMP(R->A,I);break;  /* CMP ($ss,x) INDEXINDIR */
            mr.ix I: m.cmp reg.a, I

CASE &HD1': MR_Iy(I);M_CMP(R->A,I);break;  /* CMP ($ss),y INDIRINDEX */
            mr.ix I: m.cmp reg.a, I

CASE &HE1': MR_Ix(I);M_SBC(I);break;       /* SBC ($ss,x) INDEXINDIR */
            mr.ix I: m.sbc I

CASE &HF1': MR_Iy(I);M_SBC(I);break;       /* SBC ($ss),y INDIRINDEX */
            mr.iy I: m.sbc I


CASE &HA ': M_ASL(R->A);break;             /* ASL a ACC */
'error
            m.asll reg.a
CASE &H2A': M_ROL(R->A);break;             /* ROL a ACC */
'error
            m.roll reg.a
CASE &H4A': M_LSR(R->A);break;             /* LSR a ACC */
'error
            m.lsrr reg.a
CASE &H6A': M_ROR(R->A);break;             /* ROR a ACC */
'error
            m.rorr reg.a

CASE ELSE
'default:
'  if(R->TrapBadOps)
'    printf
'    (
'      "[M6502 %lX] Unrecognized instruction: $%02X at PC=$%04X\n",
'      R->User,Op6502(R->PC.W-1),(word)(R->PC.W-1)
'    );
'  break;
END SELECT

END SUB

FUNCTION exec6502 ()
'int sub ?

'/** Exec6502() ***********************************************/
'/** This function will execute a single 6502 opcode. It     **/
'/** will then return next PC, and current register values   **/
'/** in R.                                                   **/
'/*************************************************************/
'word exec6502(M6502 * R)
'{
'  register pair J,K;
'  register byte I;
'
'  I=Op6502(R->PC.W++);
reg.PC.w = reg.PC.w + 1
I = Op6502(reg.PC.w)


'  R->ICount-=Cycles[I];
reg.icount = reg.icount - cycles%(I)

'  switch (I)
'  {
'#include "Codes.h"
'  }
codes I

'
'  /* We are done */
'  return(R->PC.W);
'}
'
exec6502 = reg.PC.w

END FUNCTION

DEFSNG A-Z
FUNCTION high% (a%)
high% = ASC(MID$(MKI$(a%), 2))

END FUNCTION

DEFINT A-Z
SUB highs (a%, B%)
END SUB

SUB int6502 ()
'/** Int6502() ************************************************/
'/** This function will generate interrupt of a given type.  **/
'/** INT_NMI will cause a non-maskable interrupt. INT_IRQ    **/
'/** will cause a normal interrupt, unless I_FLAG set in R.  **/
'/*************************************************************/
'void Int6502(M6502 *R,byte Type)
'{
'  register pair J;
'
'  if((Type==INT_NMI)||((Type==INT_IRQ)&&!(R->P&I_FLAG)))
'  {
'    R->ICount-=7;
'    M_PUSH(R->PC.B.h);
'    M_PUSH(R->PC.B.l);
'    M_PUSH(R->P&~B_FLAG);
'    R->P&=~D_FLAG;
'    if(Type==INT_NMI) J.W=0xFFFA; else { R->P|=I_FLAG;J.W=0xFFFE; }
'    R->PC.B.l=Rd6502(J.W++);
'    R->PC.B.h=Rd6502(J.W);
'  }
'}


END SUB

DEFSNG A-Z
FUNCTION low% (a%)
low% = ASC(MKI$(a%))

END FUNCTION

SUB lows (a%, B%)
END SUB

DEFINT A-Z
SUB m.adc (a%)
'#define M_ADC(Rg) \
'  if(R->P&D_FLAG) \
IF reg.P AND d.flag THEN

'  { \
'    K.B.l=(R->A&0x0F)+(Rg&0x0F)+(R->P&C_FLAG); \
lk.b.l = (r.a AND &HF) + (a% AND &HF)
'    K.B.h=(R->A>>4)+(Rg>>4)+(K.B.l>15? 1:0); \

     tmp = 0: IF k.B.l > 15 THEN tmp = 1
k.B.h = (reg.a \ 4) + (a% \ 4) + tmp

'    if(K.B.l>9) { K.B.l+=6;K.B.h++; } \
IF k.B.l > 9 THEN k.B.l = k.B.l + 1: k.B.h = k.B.h + 6

 

'    if(K.B.h>9) K.B.h+=6; \
     IF k.B.h > 9 THEN k.B.h = k.B.h + 6
    
'    R->A=(K.B.l&0x0F)|(K.B.h<<4); \
     reg.a = (k.B.l AND &HF) OR (k.B.h \ 4)


'    R->P=(R->P&~C_FLAG)|(K.B.h>15? C_FLAG:0); \
     tmp = 0: IF k.B.h > 15 THEN tmp = c.flag


     reg.P = (reg.P AND NOT (c.flag)) OR tmp

'  } \
'  else \
   ELSE
'  { \
'    K.W=R->A+Rg+(R->P&C_FLAG); \
     k.w = reg.a + a% + (reg.P AND c.flag)

'    R->P&=~(N_FLAG|V_FLAG|Z_FLAG|C_FLAG); \
     reg.P = reg.P AND NOT (n.flag OR v.flag OR z.flag OR c.dlag)


'    R->P|=(~(R->A^Rg)&(R->A^K.B.l)&0x80? V_FLAG:0)| \
     tmp = 0
     IF NOT (reg.a ^ a%) AND (reg.a ^ k.B.l) AND &H80 THEN tmp = v.flag
     reg.P = reg.P OR tmp
     tmp = 0
     IF k.B.h THEN tmp = c.flag
     reg.P = reg.P OR tmp OR zntable(k.B.l)


'          (K.B.h? C_FLAG:0)|ZNTable[K.B.l]; \
'    R->A=K.B.l; \
     r.a = k.B.l
'  }
   END IF

END SUB

SUB m.and (a%)
'#define M_AND(Rg)   R->A&=Rg;M_FL(R->A)
reg.a = reg.a AND a%
m.fl reg.a
END SUB

SUB m.asll (a%)
'#define M_ASL(Rg)   R->P&=~C_FLAG;R->P|=Rg>>7;Rg<<=1;M_FL(Rg)
END SUB

SUB m.bit (a%)
'#define M_BIT(Rg) \
'  R->P&=~(N_FLAG|V_FLAG|Z_FLAG); \
reg.P = reg.P AND NOT (n.flag OR v.flag OR z.flag)

'  R->P|=(Rg&(N_FLAG|V_FLAG))|(Rg&R->A? 0:Z_FLAG)
 tmp = 0: IF a% AND reg.a THEN tmp = z.flag
reg.P = reg.P OR (a% AND (n.flag OR v.flag)) OR tmp


END SUB

SUB m.cmp (a%, B%)
'#define M_CMP(Rg1,Rg2) \
'  K.W=Rg1-Rg2; \
   k.w = a% - B%

  reg.P = reg.P AND NOT (n.flag OR z.flag OR c.flag)

  tmp = c.flag: IF k.B.h THEN tmp = 0
  reg.P = reg.P OR zntable(k.B.l) OR tmp


'  R->P&=~(N_FLAG|Z_FLAG|C_FLAG); \
'  R->P|=ZNTable[K.B.l]|(K.B.h? 0:C_FLAG)
END SUB

FUNCTION m.dec (a%)
'#define M_DEC(Rg)   Rg--;M_FL(Rg)
a% = a% - 1
m.fl a%

END FUNCTION

SUB m.eor (a%)
'#define M_EOR(Rg)   R->A^=Rg;M_FL(R->A)
reg.a = reg.a ^ a%
m.fl reg.a


END SUB

SUB m.fl (a%)
'#define M_FL(Rg)    R->P=(R->P&~(Z_FLAG|N_FLAG))|ZNTable[Rg]

reg.P = (reg.P AND NOT (z.flag OR n.flag)) OR zntable(a%)



END SUB

FUNCTION m.inc (a%)
'#define M_INC(Rg)   Rg++;M_FL(Rg)
a% = a% + 1
m.fl a%

END FUNCTION

DEFSNG A-Z
SUB M.JR ()
'#define M_JR        R->PC.W+=(offset)Op6502(R->PC.W)+1;R->ICount--
'error
' op6502 output to offset (signed char)


reg.PC.w = reg.PC.w + (offset) * Op6502(reg.PC.w) + 1
reg.icount = reg.icount - 1


END SUB

DEFINT A-Z
SUB m.ldword (a AS pcc)
'#define M_LDWORD(Rg)    Rg.B.l=Op6502(R->PC.W++);Rg.B.h=Op6502(R->PC.W++)

reg.PC.w = reg.PC.w + 1
a.B.l = Op6502(reg.PC.w)

reg.PC.w = reg.PC.w + 1
a.B.h = Op6502(r.pc.w)



END SUB

SUB m.lsrr (a%)
'#define M_LSR(Rg)   R->P&=~C_FLAG;R->P|=Rg&C_FLAG;Rg>>=1;M_FL(Rg)
END SUB

SUB m.ora (a%)
'#define M_ORA(Rg)   R->A|=Rg;M_FL(R->A)
reg.a = reg.a OR a%
m.fl reg.a

END SUB

DEFSNG A-Z
SUB m.pop (a AS INTEGER)
'#define M_POP(Rg)   R->S++;Rg=Op6502(0x0100|R->S)
reg.s = reg.s + 1
a = Op6502(&H100 OR reg.s)

END SUB

DEFINT A-Z
SUB m.push (a%)
'#define M_PUSH(Rg)  Wr6502(0x0100|R->S,Rg);R->S--
wr6502 &H100 OR reg.s, a%
reg.s = reg.s - 1

END SUB

SUB m.roll (a%)
'#define M_ROL(Rg)   K.B.l=(Rg<<1)|(R->P&C_FLAG); \
'            R->P&=~C_FLAG;R->P|=Rg>>7;Rg=K.B.l; \
'            M_FL (Rg)
END SUB

SUB m.rorr (a%)
'#define M_ROR(Rg)   K.B.l=(Rg>>1)|(R->P<<7); \
'            R->P&=~C_FLAG;R->P|=Rg&C_FLAG;Rg=K.B.l; \
'            M_FL (Rg)
END SUB

SUB m.sbc (a%)
'/* Warning! C_FLAG is inverted before SBC and after it */
'#define M_SBC(Rg) \
'  if(R->P&D_FLAG) \
'  { \
'    K.B.l=(R->A&0x0F)-(Rg&0x0F)-(~R->P&C_FLAG); \
'    if(K.B.l&0x10) K.B.l-=6; \
'    K.B.h=(R->A>>4)-(Rg>>4)-(K.B.l&0x10); \
'    if(K.B.h&0x10) K.B.h-=6; \
'    R->A=(K.B.l&0x0F)|(K.B.h<<4); \
'    R->P=(R->P&~C_FLAG)|(K.B.h>15? 0:C_FLAG); \
'  } \
'  else \
'  { \
'    K.W=R->A-Rg-(~R->P&C_FLAG); \
'    R->P&=~(N_FLAG|V_FLAG|Z_FLAG|C_FLAG); \
'    R->P|=((R->A^Rg)&(R->A^K.B.l)&0x80? V_FLAG:0)| \
'          (K.B.h? 0:C_FLAG)|ZNTable[K.B.l]; \
'    R->A=K.B.l; \
'  }
END SUB

SUB mc.ab (a AS pcc)
'#define MC_Ab(Rg)   M_LDWORD(Rg)
m.ldword a

END SUB

SUB mc.ax (a AS pcc)
'#define MC_Ax(Rg)   M_LDWORD(Rg);Rg.W+=R->X
m.ldword a
a.w = a.w + reg.x

END SUB

SUB mc.ay (a AS pcc)
'#define MC_Ay(Rg)   M_LDWORD(Rg);Rg.W+=R->Y
m.ldword a
a.w = a.w + reg.y

END SUB

SUB mc.ix (rg AS pcc)
'#define MC_Ix(Rg)   K.B.l=Op6502(R->PC.W++)+R->X;K.B.h=0; \
'            Rg.B.l=Op6502(K.W++);Rg.B.h=Op6502(K.W)

END SUB

SUB mc.iy (rg AS pcc)
'#define MC_Iy(Rg)   K.B.l=Op6502(R->PC.W++);K.B.h=0; \
'            Rg.B.l=Op6502(K.W++);Rg.B.h=Op6502(K.W); \
'            Rg.W+=R->Y

END SUB

SUB mc.zp (rg AS pcc)
'#define MC_Zp(Rg)   Rg.B.l=Op6502(R->PC.W++);Rg.B.h=0
reg.PC.w = reg.PC.w + 1
rg.B.l = Op6502(reg.PC.w)
rg.B.h = 0
END SUB

SUB mc.zx (rg AS pcc)
'#define MC_Zx(Rg)   Rg.B.l=Op6502(R->PC.W++)+R->X;Rg.B.h=0

reg.PC.w = reg.PC.w + 1
rg.B.l = Op6502(reg.PC.w) + reg.x
rg.B.h = 0

END SUB

SUB mc.zy (rg AS pcc)
'#define MC_Zy(Rg)   Rg.B.l=Op6502(R->PC.W++)+R->Y;Rg.B.h=0
reg.PC.w = reg.PC.w + 1
rg.B.l = Op6502(reg.PC.w) + reg.y

rg.B.h = 0

END SUB

SUB mm.ab (a%)
'#define MM_Ab(Cmd)  MC_Ab(J);I=Rd6502(J.W);Cmd(I);Wr6502(J.W,I)
mc.ab j
I = rd6502(j.w)

'error
'cmd i
'error

wr6502 j.w, I


END SUB

SUB mm.ax (a%)
'#define MM_Ax(Cmd)  MC_Ax(J);I=Rd6502(J.W);Cmd(I);Wr6502(J.W,I)
mc.ax j
I = rd6502(j.w)

'error
'cmd I
'

wr6502 j.w, I

END SUB

SUB mm.zp (a%)
'#define MM_Zp(Cmd)  MC_Zp(J);I=Rd6502(J.W);Cmd(I);Wr6502(J.W,I)
mc.zp j
I = rd6502(j.w)

'error
'cmd i

wr6502 j.w, I


END SUB

SUB mm.zx (a%)
'#define MM_Zx(Cmd)  MC_Zx(J);I=Rd6502(J.W);Cmd(I);Wr6502(J.W,I)

mc.zx j
I = rd6502(j.w)

'error
'cmd i

wr6502 j.w, I


END SUB

SUB mr.ab (a%)
'#define MR_Ab(Rg)   MC_Ab(J);Rg=Rd6502(J.W)
mc.ab j
a% = rd6502(j.w)


END SUB

SUB mr.ax (a%)
'#define MR_Ax(Rg)   MC_Ax(J);Rg=Rd6502(J.W)
mc.ax j
a% = rd6502(j.w)

END SUB

SUB mr.ay (a%)
'#define MR_Ay(Rg)   MC_Ay(J);Rg=Rd6502(J.W)
mc.ay j
a% = rd6502(j.w)

END SUB

SUB mr.im (a%)
'#define MR_Im(Rg)   Rg=Op6502(R->PC.W++)
reg.PC.w = reg.PC.w + 1
a% = Op6502(reg.PC.w)

END SUB

SUB mr.ix (a%)
'#define MR_Ix(Rg)   MC_Ix(J);Rg=Rd6502(J.W)

mc.ix j

a% = rd6502(j.w)



END SUB

SUB mr.iy (a%)
'#define MR_Iy(Rg)   MC_Iy(J);Rg=Rd6502(J.W)

mc.iy j

a% = rd6502(j.w)



END SUB

SUB mr.zp (a%)
'#define MR_Zp(Rg)   MC_Zp(J);Rg=Rd6502(J.W)
END SUB

SUB mr.zx (a%)
'#define MR_Zx(Rg)   MC_Zx(J);Rg=Rd6502(J.W)
END SUB

SUB mr.zy (a%)
'#define MR_Zy(Rg)   MC_Zy(J);Rg=Rd6502(J.W)
END SUB

SUB mw.ab (a%)
'#define MW_Ab(Rg)   MC_Ab(J);Wr6502(J.W,Rg)
END SUB

SUB mw.ax (a%)
'#define MW_Ax(Rg)   MC_Ax(J);Wr6502(J.W,Rg)
END SUB

SUB mw.ay (a%)
'#define MW_Ay(Rg)   MC_Ay(J);Wr6502(J.W,Rg)
END SUB

SUB mw.ix (a%)
'#define MW_Ix(Rg)   MC_Ix(J);Wr6502(J.W,Rg)
END SUB

SUB mw.iy (a%)
'#define MW_Iy(Rg)   MC_Iy(J);Wr6502(J.W,Rg)
END SUB

SUB mw.zp (a%)
'#define MW_Zp(Rg)   MC_Zp(J);Wr6502(J.W,Rg)
END SUB

SUB mw.zx (a%)
'#define MW_Zx(Rg)   MC_Zx(J);Wr6502(J.W,Rg)
END SUB

SUB mw.zy (a%)
'#define MW_Zy(Rg)   MC_Zy(J);Wr6502(J.W,Rg)
mc.zy j
wr6502 j.w, a%

END SUB

DEFSNG A-Z
FUNCTION Op6502 (a%)
END FUNCTION

DEFINT A-Z
FUNCTION rd6502 (a%)
END FUNCTION

SUB reset6502 ()
'/** Reset6502() **********************************************/
'/** This function can be used to reset the registers before **/
'/** starting execution with Run6502(). It sets registers to **/
'/** their initial values.                                   **/
'/*************************************************************/
'void reset6502(M6502 * R)
'{
'  R->A=R->X=R->Y=0x00;
'  R->P=Z_FLAG|R_FLAG;
'  R->S=0xFF;
'  R->PC.B.l=Rd6502(0xFFFC);
'  R->PC.B.h=Rd6502(0xFFFD);
'  R->ICount=R->IPeriod;
'  R->IRequest=INT_NONE;
'  R->AfterCLI=0;
'}

END SUB

SUB run6502 ()
'/** Run6502() ************************************************/
'/** This function will run 6502 code until Loop6502() call  **/
'/** returns INT_QUIT. It will return the PC at which        **/
'/** emulation stopped, and current register values in R.    **/
'/*************************************************************/
'
'word run6502(M6502 * R)
'{
'  register pair J,K;
'  register byte I;
'
'  for(;;)
'  {
'#ifdef DEBUG
'    /* Turn tracing on when reached trap address */
'    if(R->PC.W==R->Trap) R->Trace=1;
'    /* Call single-step debugger, exit if requested */
'    if(R->Trace)
'      if(!Debug6502(R)) return(R->PC.W);
'#endif
'
'    I=Op6502(R->PC.W++);
'    R->ICount-=Cycles[I];
'    switch (I)
'    {
'#include "Codes.h"
'    }
'
'    /* If cycle counter expired... */
'    if(R->ICount<=0)
'    {
'      /* If we have come after CLI, get INT_? from IRequest */
'      /* Otherwise, get it from the loop handler            */
'      if(R->AfterCLI)
'      {
'        I=R->IRequest;            /* Get pending interrupt     */
'        R->ICount+=R->IBackup-1;  /* Restore the ICount        */
'        R->AfterCLI=0;            /* Done with AfterCLI state  */
'      }
'      ELSE
'      {
'        I=Loop6502(R);            /* Call the periodic handler */
'        R->ICount=R->IPeriod;     /* Reset the cycle counter   */
'      }
'
'      if(I==INT_QUIT) return(R->PC.W); /* Exit if INT_QUIT     */
'      if(I) Int6502(R,I);              /* Interrupt if needed  */
'    }
'  }
'
'  /* Execution stopped */
'  return(R->PC.W);
'}
END SUB

SUB wr6502 (a%, B%)
END SUB

