DECLARE SUB CODES (I%)
DECLARE SUB RESET6502 ()
DECLARE SUB RUN6502 ()
DECLARE SUB M.DEC (RG%)
DECLARE SUB M.INC (RG%)
DECLARE SUB TRB (RG%)
DECLARE SUB TSB (RG%)
DECLARE SUB CmdE (RG%, CMD%)
DECLARE SUB M.ASL (RG%)
DECLARE SUB M.LSR (RG%)
DECLARE SUB M.ROL (RG%)
DECLARE SUB M.ROR (RG%)
DECLARE SUB MC.Ab (RG AS ANY)
DECLARE SUB MC.Ax (RG AS ANY)
DECLARE SUB MC.Ay (RG AS ANY)
DECLARE SUB MC.Ix (RG AS ANY)
DECLARE SUB MC.Iy (RG AS ANY)
DECLARE SUB WRRAM (A%, B%)
DECLARE FUNCTION OP6502W% (A%)
DECLARE FUNCTION RDRAMW% (A%)
DECLARE FUNCTION MCAB% ()
DECLARE FUNCTION MCAX% ()
DECLARE FUNCTION MCAY% ()
DECLARE FUNCTION MCIX% ()
DECLARE FUNCTION MCIY% ()
DECLARE FUNCTION MCZY% ()
DECLARE SUB M.ADC (RG%)
DECLARE SUB M.AND (RG%)
DECLARE SUB M.BIT (RG%)
DECLARE SUB M.CMP (RG1%, RG2%)
DECLARE SUB M.EOR (RG%)
DECLARE SUB M.FL (RG%)
DECLARE SUB M.JR ()
DECLARE SUB M.LDWORD (RG AS ANY)
DECLARE SUB M.ORA (RG%)
DECLARE SUB M.POP (RG%)
DECLARE SUB M.POP.P (RG%)
DECLARE SUB M.PUSH (RG%)
DECLARE SUB M.PUSH.P (RG%)
DECLARE SUB M.SBC (RG%)
DECLARE SUB MC.ID (RG AS ANY)
DECLARE FUNCTION MCZp% ()
DECLARE FUNCTION MCZx% ()
DECLARE SUB MM.Ab (RG%)
DECLARE SUB mm.ax (RG%)
DECLARE SUB MM.Zp (RP%)
DECLARE SUB mm.zx (RG%)
DECLARE SUB MR.Ax (RG%)
DECLARE SUB MR.Ay (RG%)
DECLARE SUB MR.ID (RG%)
DECLARE SUB MR.Im (RG%)
DECLARE SUB MR.Ix (RG%)
DECLARE SUB MR.Iy (RG%)
DECLARE SUB MR.Zp (RG%)
DECLARE SUB MR.Zx (RG%)
DECLARE SUB mr.zy (RG%)
DECLARE SUB MW.Ab (RG%)
DECLARE SUB MW.Ax (RG%)
DECLARE SUB mw.ay (RG%)
DECLARE SUB mw.ix (RG%)
DECLARE SUB mw.iy (RG%)
DECLARE SUB MW.Zp (RG%)
DECLARE SUB MW.Zx (RG%)
DECLARE SUB mw.zy (RG%)
DECLARE FUNCTION op6502% (A%)
DECLARE SUB Wr6502 (A%, B%)
DECLARE SUB M.ADCx (RG%)
DECLARE SUB MR.Ab (RG%)
DECLARE SUB M.ANDx (RG%)
DECLARE SUB M.EORx (RG%)
DECLARE SUB M.ORAx (RG%)
DECLARE SUB IO.write (A%, B%)
DECLARE SUB BANK.SET (A%, B%)
DECLARE SUB T_INIT ()
DECLARE FUNCTION rd6502% (A%)
DECLARE SUB M.RMB (RG%)
DECLARE SUB M.SMB (RG%)
DEFINT A-Z

TYPE bb  'change this around for lsb fists, last
l AS INTEGER
H AS INTEGER
END TYPE


TYPE PCC
 W AS INTEGER
 B AS bb
END TYPE
TYPE regg
 P AS INTEGER        'on byte register
 A AS INTEGER
 X AS INTEGER
 Y AS INTEGER
 S AS INTEGER
 PC AS PCC
 NF AS INTEGER
 VF AS INTEGER
 ZF AS INTEGER
 mpr(7) AS INTEGER
 IRequest AS INTEGER
 ICount AS INTEGER
 IBackup AS INTEGER
 AfterCLI AS INTEGER
 IPeriod AS INTEGER
 USER AS INTEGER
END TYPE


'byte = unsigned char (1)
'word = unsigned short (2)
'offset = signed char

'type pair
' word w
' int b {byte l,h}
'end type
' n
' n.w
' n.b (n.b.l,n.b.h)


                       '       /* 6502 status flags:         */
CONST C.FLAG = &H1     '       /* 1: Carry occured           */
CONST Z.FLAG = &H2     '       /* 1: Result is zero          */
CONST I.FLAG = &H4     '       /* 1: Interrupts disabled     */
CONST D.FLAG = &H8     '       /* 1: Decimal mode            */
CONST b.flag = &H10    '       /* Break [0 on stk after int] */
CONST r.flag = &H20    '       /* Always 1                   */
CONST V.FLAG = &H40    '       /* 1: Overflow occured        */
CONST N.FLAG = &H80    '       /* 1: Result is negative      */

'                      '       /* Loop6502() returns:        */
CONST INT.NONE = 0     '       /* No interrupt required      */
CONST INT.IRQ = 1      '       /* Standard IRQ interrupt     */
CONST INT.NMI = 2      '       /* Non-maskable interrupt     */
CONST INT.QUIT = 3     '       /* Exit the emulation         */

CONST INT.TIMER = 4
CONST INT.IRQ2 = 8
CONST VEC.RESET = &HFFFE
CONST VER.NMI = &HFFFC
CONST VEC.TIMER = &HFFFA
CONST VEC.IRQ = &HFFF8
CONST VER.IRQ2 = &HFFF6
CONST VEC.BRK = &HFFFE





DIM SHARED REG AS regg, K AS PCC, J AS PCC, CYCLES%(255), zntable%(255), I
DIM SHARED RdRAM(32766), AdrRAM(), CYCLE
OPEN "BONK3.PCE" FOR BINARY ACCESS READ AS #1



RESTORE cycledata
FOR ii = 0 TO 255: READ CYCLES%(ii): NEXT ii
RESTORE zntabledata
FOR ii = 0 TO 255: READ zntable%(ii): NEXT ii
RUN6502
END


cycledata:
'static byte Cycles[256] =
DATA     8,7,3, 4,6,4,6,7,3,2,2,0,7,5,7,6
DATA     2,7,7, 4,6,4,6,7,2,5,2,0,7,5,7,6
DATA     7,7,3, 4,4,4,6,7,3,2,2,0,5,5,7,6
DATA     2,7,7, 0,4,4,6,7,2,5,2,0,5,5,7,6
DATA     7,7,3, 4,8,4,6,7,3,2,2,0,4,5,7,6
DATA     2,7,7, 5,0,4,6,7,2,5,3,0,0,5,7,6
DATA     7,7,2, 0,4,4,6,7,3,2,2,0,7,5,7,6
DATA     2,7,7,17,4,4,6,7,2,5,3,0,7,5,7,6
DATA     4,7,2, 7,4,4,4,7,2,2,2,0,5,5,5,6
DATA     2,7,7, 8,4,4,4,7,2,5,2,0,5,5,5,6
DATA     2,7,2, 7,4,4,4,7,2,2,2,0,5,5,5,6
DATA     2,7,7, 8,4,4,4,7,2,5,2,0,5,5,5,6
DATA     2,7,2,17,4,4,6,7,2,2,2,0,5,5,7,6
DATA     2,7,7,17,0,4,6,7,2,5,3,0,0,5,7,6
DATA     2,7,0,17,4,4,6,7,2,2,2,0,5,5,7,6
DATA     2,7,7,17,2,4,6,7,2,5,3,0,0,5,7,0









'DATA  7,6,2,8,3,3,5,5,3,2,2,2,4,4,6,6
'DATA  2,5,2,8,4,4,6,6,2,4,2,7,5,5,7,7
'DATA  6,6,2,8,3,3,5,5,4,2,2,2,4,4,6,6
'DATA  2,5,2,8,4,4,6,6,2,4,2,7,5,5,7,7
'DATA  6,6,2,8,3,3,5,5,3,2,2,2,3,4,6,6
'DATA  2,5,2,8,4,4,6,6,2,4,2,7,5,5,7,7
'DATA  6,6,2,8,3,3,5,5,4,2,2,2,5,4,6,6
'DATA  2,5,2,8,4,4,6,6,2,4,2,7,5,5,7,7
'DATA  2,6,2,6,3,3,3,3,2,2,2,2,4,4,4,4
'DATA  2,6,2,6,4,4,4,4,2,5,2,5,5,5,5,5
'DATA  2,6,2,6,3,3,3,3,2,2,2,2,4,4,4,4
'DATA  2,5,2,5,4,4,4,4,2,4,2,5,4,4,4,4
'DATA  2,6,2,8,3,3,5,5,2,2,2,2,4,4,6,6
'DATA  2,5,2,8,4,4,6,6,2,4,2,7,5,5,7,7
'DATA  2,6,2,8,3,3,5,5,2,2,2,2,4,4,6,6
'DATA  2,5,2,8,4,4,6,6,2,4,2,7,5,5,7,7
'


zntabledata:
'byte ZNTable[256] =

'DATA  Z.FLAG,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA  2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

DATA  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
DATA  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

'new
DATA  128,128,128,128,128,128,128,128
DATA  128,128,128,128,128,128,128,128
DATA  128,128,128,128,128,128,128,128
DATA  128,128,128,128,128,128,128,128
DATA  128,128,128,128,128,128,128,128
DATA  128,128,128,128,128,128,128,128
DATA  128,128,128,128,128,128,128,128
DATA  128,128,128,128,128,128,128,128
DATA  128,128,128,128,128,128,128,128
DATA  128,128,128,128,128,128,128,128
DATA  128,128,128,128,128,128,128,128
DATA  128,128,128,128,128,128,128,128
DATA  128,128,128,128,128,128,128,128
DATA  128,128,128,128,128,128,128,128
DATA  128,128,128,128,128,128,128,128
DATA  128,128,128,128,128,128,128,128



 





'old
'DATA  N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG
'DATA  N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG
'DATA  N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG
'DATA  N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG
'DATA  N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG
'DATA  N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG
'DATA  N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG
'DATA  N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG
'DATA  N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG
'DATA  N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG
'DATA  N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG
'DATA  N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG
'DATA  N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG
'DATA  N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG
'DATA  N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG
'DATA  N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG,N.FLAG

CONST MNUL = 0, minc = 1, MDEC = 2, MROR = 3, MROL = 4, MLSR = 5, MASL = 6, MTRB = 7, MTSB = 8

SUB BANK.SET (A%, B%)
END SUB

SUB CmdE (RG, CMD)
SELECT CASE CMD
CASE MNUL:
CASE minc: M.INC RG
CASE MDEC: M.DEC RG
CASE MROR: M.ROR RG
CASE MROL: M.ROL RG
CASE MLSR: M.LSR RG
CASE MASL: M.ASL RG
CASE MTRB: TRB RG
CASE MTSB: TSB RG
END SELECT



END SUB

SUB CODES (I)
SELECT CASE I
CASE &HD4'/* CSH set clock highspeed */
CASE &H54'/* CSL set clock lowspeed */

CASE &H44: '/* BSR * REL */
           M.PUSH REG.PC.B.H
           M.PUSH REG.PC.B.l

CASE &H80: '/* BRA * REL */
          REG.PC.W = REG.PC.W + (offset) * op6502(REG.PC.W) + 1


CASE &H7C: '/* JMP ($ssss,x) */
        M.LDWORD K: K.W = K.W + REG.X
        REG.PC.B.l = op6502(K.W)
        REG.PC.B.H = op6502(K.W + 1)

CASE &HDA: M.PUSH REG.X  '  /* PHX */

CASE &H5A: M.PUSH REG.Y '               /* PHY */
CASE &HFA: M.POP REG.X: M.FL REG.X '    /* PLX */
CASE &H7A: M.POP REG.Y: M.FL REG.Y'      /* PLY */

CASE &H62: REG.A = 0' /* CLA */
CASE &H82: REG.X = 0' /* CLX */
CASE &HC2: REG.Y = 0' /* CLY */

CASE &H2: I = REG.X: REG.X = REG.Y: REG.Y = I'  /* SXY */
CASE &H22: I = REG.A: REG.A = REG.X: REG.X = I'  /* SAX */
CASE &H42: I = REG.A: REG.A = REG.Y: REG.Y = I'  /* SAY */

CASE &H3A: M.DEC REG.A                  ' /* DEC A */

CASE &H1A: M.INC REG.A                  ' /* INC A */


CASE &H72: MR.ID I: M.ADC I               '/* ADC ($ss) INDIR */
CASE &H32: MR.ID I: M.AND I               '/* AND ($ss) INDIR */
CASE &HD2: MR.ID I: M.CMP REG.A, I        '/* CMP ($ss) INDIR */
CASE &H52: MR.ID I: M.EOR I               '/* EOR ($ss) INDIR */
CASE &HB2: MR.ID REG.A: M.FL REG.A        '/* LDA ($ss) INDIR */
CASE &H12: MR.ID I: M.ORA I               '/* ORA ($ss) INDIR */
CASE &H92: MC.ID J: Wr6502 J.W, REG.A     '/* STA ($ss) INDIR */
CASE &HF2: MR.ID I: M.SBC I             '  /* SBC ($ss) INDIR */

CASE &H89: MR.Im I: M.BIT I  '              /* BIT #$ss IMM */
CASE &H34: MR.Zx I: M.BIT I  '              /* BIT $ss,x ZP,x */
CASE &H3C: MR.Ax I: M.BIT I  '              /* BIT $ssss,x ABS,x */

CASE &H64: MW.Zp &H0            '          /* STZ $ss ZP */
CASE &H74: MW.Zx &H0            '          /* STZ $ss,x ZP,x */
CASE &H9C: MW.Ab &H0            '          /* STZ $ssss ABS */
CASE &H9E: MW.Ax &H0            '          /* STZ $ssss,x ABS,x */

CASE &HF4: ' /* SET */
        I = op6502(REG.PC.W)
        REG.PC.W = REG.PC.W + 1
        CYCLE = CYCLE + CYCLES(I) + 3
        SELECT CASE I
        CASE &H65: MR.Zp I: M.ADCx I'       /* ADC $ss ZP */
        CASE &H6D: MR.Ab I: M.ADCx I'       /* ADC $ssss ABS */
        CASE &H69: MR.Im I: M.ADCx I'       /* ADC #$ss IMM */
        CASE &H75: MR.Zx I: M.ADCx I'       /* ADC $ss,x ZP,x */
        CASE &H79: MR.Ay I: M.ADCx I'       /* ADC $ssss,y ABS,y */
        CASE &H7D: MR.Ax I: M.ADCx I'       /* ADC $ssss,x ABS,x */
        CASE &H61: MR.Ix I: M.ADCx I'       /* ADC ($ss,x) INDEXINDIR */
        CASE &H71: MR.Iy I: M.ADCx I'       /* ADC ($ss),y INDIRINDEX */
        CASE &H72: MR.ID I: M.ADCx I'       /* ADC ($ss) INDIR */

        CASE &H25: MR.Zp I: M.ANDx I'       /* AND $ss ZP */
        CASE &H2D: MR.Ab I: M.ANDx I'       /* AND $ssss ABS */
        CASE &H29: MR.Im I: M.ANDx I'       /* AND #$ss IMM */
        CASE &H35: MR.Zx I: M.ANDx I'       /* AND $ss,x ZP,x */
        CASE &H39: MR.Ay I: M.ANDx I'       /* AND $ssss,y ABS,y */
        CASE &H3D: MR.Ax I: M.ANDx I'       /* AND $ssss,x ABS,x */
        CASE &H21: MR.Ix I: M.ANDx I'       /* AND ($ss,x) INDEXINDIR */
        CASE &H31: MR.Iy I: M.ANDx I'       /* AND ($ss),y INDIRINDEX */
        CASE &H32: MR.ID I: M.ANDx I'       /* AND ($ss) INDIR */

        CASE &H45: MR.Zp I: M.EORx I '       /* EOR $ss ZP */
        CASE &H4D: MR.Ab I: M.EORx I '       /* EOR $ssss ABS */
        CASE &H49: MR.Im I: M.EORx I '       /* EOR #$ss IMM */
        CASE &H55: MR.Zx I: M.EORx I '       /* EOR $ss,x ZP,x */
        CASE &H59: MR.Ay I: M.EORx I '       /* EOR $ssss,y ABS,y */
        CASE &H5D: MR.Ax I: M.EORx I '       /* EOR $ssss,x ABS,x */
        CASE &H41: MR.Ix I: M.EORx I '       /* EOR ($ss,x) INDEXINDIR */
        CASE &H51: MR.Iy I: M.EORx I '       /* EOR ($ss),y INDIRINDEX */
        CASE &H52: MR.ID I: M.EORx I '       /* EOR ($ss) INDIR */

        CASE &H5: MR.Zp I: M.ORAx I  '       /* ORA $ss ZP */
        CASE &HD: MR.Ab I: M.ORAx I  '       /* ORA $ssss ABS */
        CASE &H9: MR.Im I: M.ORAx I  '       /* ORA #$ss IMM */
        CASE &H15: MR.Zx I: M.ORAx I '       /* ORA $ss,x ZP,x */
        CASE &H19: MR.Ay I: M.ORAx I '       /* ORA $ssss,y ABS,y */
        CASE &H1D: MR.Ax I: M.ORAx I '       /* ORA $ssss,x ABS,x */
        CASE &H1: MR.Ix I: M.ORAx I  '       /* ORA ($ss,x) INDEXINDIR */
        CASE &H11: MR.Iy I: M.ORAx I '       /* ORA ($ss),y INDIRINDEX */
        CASE &H12: MR.ID I: M.ORAx I '       /* ORA ($ss) INDIR */

        CASE ELSE
        PRINT ERR, "no sense SET"
        CYCLE = CYCLE - CYCLES(I)


        END SELECT

CASE &H3: IO.write 0, op6502(REG.PC.W): REG.PC.W = REG.PC.W + 1'/* ST0 */
CASE &H13: IO.write 2, op6502(REG.PC.W): REG.PC.W = REG.PC.W + 1'/* ST1 */
CASE &H23: IO.write 3, op6502(REG.PC.W): REG.PC.W = REG.PC.W + 1'/* ST2 */

CASE &H43: '/* TMAi */
        I = op6502(REG.PC.W): REG.PC.W = REG.PC.W + 1

          FOR ii = 0 TO 7
              I = I \ 2 ^ 1

              IF (I AND 1) THEN EXIT FOR

          '//reg.a = Reg.MPR[ii]
          '//reg.a = Reg.MPR[ii]
          REG.A = REG.mpr(ii)
          NEXT ii

CASE &H53: '/* TAMi */
        I = op6502(REG.PC.W): REG.PC.W = REG.PC.W + 1

         FOR ii = 0 TO 7
                I = I * 2 ^ 1
                IF (I AND 11) THEN
                        '//R->MPR[ii]=reg.a;
                        '//R.MPR[ii]=reg.a;
                        REG.mpr(ii) = REG.A
                        BANK.SET ii, REG.A
                END IF
         NEXT ii

CASE &HC3: ' /* TDD */
        T_INIT
        DO
        Wr6502 dist, rd6502(src)
        dist = dist - 1

        src = src - 1
        length = length - 1
        LOOP WHILE length
'        } while(--length);




CASE &H73: ' /* TII */
        T_INIT
        DO
             Wr6502 dist, rd6502(src)
             dist = dist + 1
                src = src + 1
        length = length - 1
        LOOP WHILE length
'        } while(--length);


CASE &HE3: ' /* TIA */
        T_INIT
        DO
                Wr6502 dist, rd6502(src)
                src = src + 1

                IF NOT length THEN EXIT DO
                ' if (!(--length)):break
                length = length - 1
                Wr6502 dist + 1, rd6502(src)
                src = src + 1
'        } while(--length);
        lenght = length - 1
        LOOP WHILE length


CASE &HF3: ' /* TAI */
        T_INIT
        DO
                Wr6502 dist, rd6502(src)
                dist = dist + 1
                'if (!(--length)) break;
                length = length - 1
                IF NOT length THEN EXIT DO
                Wr6502 dist, rd6502(src + 1)
                dist = dist + 1

         length = length - 1
         LOOP WHILE length
'        } while(--length);

CASE &HD3: ' /* TIN */
        T_INIT
        DO
                Wr6502 dist, rd6502(src)
                src = src + 1
        length = length - 1
        LOOP WHILE length

CASE &H14: MM.Zp MTRB '      /* TRB $ss ZP */

CASE &H1C: MM.Ab MTRB '      /* TRB $ssss ABS */
CASE &H4: MM.Zp MTSB  '      /* TSB $ss ZP */

CASE &HC: MM.Ab MTSB  '      /* TSB $ssss ABS */

CASE &H83: '/* TST #$ss,$ss IMM,ZP */
        I = op6502(REG.PC.W): J.B.l = RdRAM(MCZp())
        REG.PC.W = REG.PC.W + 1
'error    NF = VF = J.B.L
        REG.NF = J.B.l
        REG.VF = J.B.l: REG.ZF = I AND J.B.l

CASE &HA3: '/* TST #$ss,$ss,x IMM,ZP,x */
        I = op6502(regPC.w): J.B.l = RdRAM(MCZx())
        REG.PC.W = REG.PC.W + 1

'error REG,NF = REG.VF = J.B.L
        REG.NF = J.B.l
        REG.VF = J.B.l: REG.ZF = I AND J.B.l
CASE &H93: '/* TST #$ss,$ssss IMM,ABS */
        I = op6502(REG.PC.W): MR.Ab J.B.l
        REG.PC.W = REG.PC.W + 1
'error
        REG.NF = J.B.l
         REG.VF = J.B.l: REG.ZF = I AND J.B.l

CASE &HB3: '/* TST #$ss,$ssss,x IMM,ABS,x */
        I = op6502(REG.PC.W): MR.Ax J.B.l
        REG.PC.W = REG.PC.W + 1
'error
        REG.NF = J.B.l
        REG.VF = J.B.l: REG.ZF = I AND J.B.l

CASE &HF: IF RdRAM(MCZp()) AND &H1 THEN REG.PC.W = REG.PC.W + REG.PC.W + 1:  ELSE M.JR          '      /* BBRi */
CASE &H1F: IF RdRAM(MCZp()) AND &H2 THEN REG.PC.W = REG.PC.W + REG.PC.W + 1:  ELSE M.JR
CASE &H2F: IF RdRAM(MCZp()) AND &H4 THEN REG.PC.W = REG.PC.W + REG.PC.W + 1:  ELSE M.JR
CASE &H3F: IF RdRAM(MCZp()) AND &H8 THEN REG.PC.W = REG.PC.W + REG.PC.W + 1:  ELSE M.JR
CASE &H4F: IF RdRAM(MCZp()) AND &H10 THEN REG.PC.W = REG.PC.W + REG.PC.W + 1:  ELSE M.JR
CASE &H5F: IF RdRAM(MCZp()) AND &H20 THEN REG.PC.W = REG.PC.W + REG.PC.W + 1:  ELSE M.JR
CASE &H6F: IF RdRAM(MCZp()) AND &H40 THEN REG.PC.W = REG.PC.W + REG.PC.W + 1:  ELSE M.JR
CASE &H7F: IF RdRAM(MCZp()) AND &H80 THEN REG.PC.W = REG.PC.W + REG.PC.W + 1:  ELSE M.JR

CASE &H8F: IF RdRAM(MCZp()) AND &H1 THEN M.JR:         ELSE REG.PC.W = REG.PC.W + REG.PC.W + 1  '      /* BBSi */
CASE &H9F: IF RdRAM(MCZp()) AND &H2 THEN M.JR:         ELSE REG.PC.W = REG.PC.W + REG.PC.W + 1
CASE &HAF: IF RdRAM(MCZp()) AND &H4 THEN M.JR:         ELSE REG.PC.W = REG.PC.W + REG.PC.W + 1
CASE &HBF: IF RdRAM(MCZp()) AND &H8 THEN M.JR:         ELSE REG.PC.W = REG.PC.W + REG.PC.W + 1
CASE &HCF: IF RdRAM(MCZp()) AND &H10 THEN M.JR:        ELSE REG.PC.W = REG.PC.W + REG.PC.W + 1
CASE &HDF: IF RdRAM(MCZp()) AND &H20 THEN M.JR:        ELSE REG.PC.W = REG.PC.W + REG.PC.W + 1
CASE &HEF: IF RdRAM(MCZp()) AND &H40 THEN M.JR:        ELSE REG.PC.W = REG.PC.W + REG.PC.W + 1
CASE &HFF: IF RdRAM(MCZp()) AND &H80 THEN M.JR:        ELSE REG.PC.W = REG.PC.W + REG.PC.W + 1


CASE &H7: M.RMB &H1   '        /* RMBi */
CASE &H17: M.RMB &H2  '        /* RMBi */
CASE &H27: M.RMB &H4  '        /* RMBi */
CASE &H37: M.RMB &H8  '        /* RMBi */
CASE &H47: M.RMB &H10 '        /* RMBi */
CASE &H57: M.RMB &H20 '        /* RMBi */
CASE &H67: M.RMB &H40 '        /* RMBi */
CASE &H77: M.RMB &H80 '        /* RMBi */

CASE &H87: M.SMB &H1  '        /* SMBi */
CASE &H97: M.SMB &H2  '        /* SMBi */
CASE &HA7: M.SMB &H4  '        /* SMBi */
CASE &HB7: M.SMB &H8  '        /* SMBi */
CASE &HC7: M.SMB &H10 '        /* SMBi */
CASE &HD7: M.SMB &H20 '        /* SMBi */
CASE &HE7: M.SMB &H40 '        /* SMBi */
CASE &HF7: M.SMB &H80 '        /* SMBi */




CASE &H10: IF (REG.NF AND N.FLAG) THEN REG.PC.W = REG.PC.W + 1:  ELSE M.JR'/* BPL * REL */
CASE &H30: IF (REG.NF AND N.FLAG) THEN M.JR:  ELSE REG.PC.W = REG.PC.W + 1'/* BMI * REL */
CASE &HD0: IF (NOT REG.ZF) THEN REG.PC.W = REG.PC.W + 1 ELSE : M.JR      '/* BNE * REL */
CASE &HF0: IF (NOT REG.ZF) THEN M.JR ELSE : REG.PC.W = REG.PC.W + 1      '/* BEQ * REL */
CASE &H90: IF (REG.P AND C.FLAG) THEN REG.PC.W = REG.PC.W + 1 ELSE : M.JR'/* BCC * REL */
CASE &HB0: IF (REG.P AND C.FLAG) THEN M.JR ELSE : REG.PC.W = REG.PC.W + 1'/* BCS * REL */
CASE &H50: IF (REG.VF AND V.FLAG) THEN REG.PC.W = REG.PC.W + 1 ELSE M.JR'/* BVC * REL */
CASE &H70: IF (REG.VF AND V.FLAG) THEN M.JR ELSE : REG.PC.W = REG.PC.W + 1'/* BVS * REL */


CASE &H40: '/* RTI */

  I = REG.P


  M.POP.P REG.P

  IF ((REG.IRequest <> INT.NONE) AND (I AND I.FLAG) <> 0 AND NOT (REG.P AND I.FLAG) <> 0) THEN
     REGAfterCLI = 1
    REG.IBackup = REG.ICount
    REG.ICount = 0
    END IF
    M.POP REG.PC.B.l
    M.POP REG.PC.B.H



CASE &H60: '/* RTS */
  M.POP REG.PC.B.l: M.POP REG.PC.B.H: REG.PC.W = REG.PC.W + 1


CASE &H20: '/* JSR $ssss ABS */
  K.B.l = op6502(REG.PC.W)
  REG.PC.W = REG.PC.W + 1
  K.B.H = op6502(REG.PC.W)
  M.PUSH REG.PC.B.H
  M.PUSH REG.PC.B.l
  REG.PC = K


CASE &H4C: M.LDWORD K: REG.PC = K'/* JMP $ssss ABS */


CASE &H6C: '/* JMP ($ssss) ABDINDIR */
  M.LDWORD K
  REG.PC.B.l = op6502(K.W)
  K.W = K.W + 1
  REG.PC.B.H = op6502(K.W)



CASE &H0: '/* BRK */
  REG.PC.W = REG.PC.W + 1
  M.PUSH REG.PC.B.H: M.PUSH REG.PC.B.l
  M.PUSH.P REG.P AND NOT (T.FLAG) OR (b.flag)
  REG.P = (REG.P OR I.FLAG) AND NOT (D.FLAG)
  REG.PC.B.l = op6502(VEC.BRK)
  REG.PC.B.H = op6502(VEC.BRK + 1)

  PRINT ERR, "BRK instruction"
  END



CASE &H58: '/* CLI */
  IF ((REG.IRequest <> INT.NONE) AND (REG.P AND I.FLAG) <> 0) THEN
  
    REG.AfterCLI = 1
    REG.IBackup = REG.ICount
    REG.ICount = 0

  END IF
  REG.P = REG.P AND NOT (I.FLAG)



CASE &H28: '/* PLP */
  M.POP.P I

  IF ((REG.IRequest <> INT.NONE) AND ((I XOR REG.P) AND NOT (I) AND I.FLAG) <> 0) THEN

    REG.AfterCLI = 1
    REG.IBackup = REG.ICount
    REG.ICount = 0

  END IF
  REG.P = I



CASE &H8: M.PUSH.P REG.P AND NOT (T.FLAG) OR b.flag'     /* PHP */
CASE &H18: REG.P = REG.P AND NOT (C.FLAG)          '     /* CLC */
CASE &HB8: REG.VF = 0                              '     /* CLV */
CASE &HD8: REG.P = REG.P AND NOT (D.FLAG)          '     /* CLD */
CASE &H38: REG.P = REG.P OR C.FLAG                 '     /* SEC */
CASE &HF8: REG.P = REG.P OR D.FLAG                 '     /* SED */
CASE &H78: REG.P = REG.P OR I.FLAG                 '     /* SEI */
CASE &H48: M.PUSH REG.A          '             /* PHA */
CASE &H68: M.POP REG.A: M.FL REG.A       '     /* PLA */
CASE &H98: REG.A = REG.Y: M.FL REG.A     '     /* TYA */
CASE &HA8: REG.Y = REG.A: M.FL REG.Y     '     /* TAY */
CASE &HC8: REG.Y = REG.Y + 1: M.FL REG.Y '     /* INY */
CASE &H88: REG.Y = REG.Y - 1: M.FL REG.Y '     /* DEY */
CASE &H8A: REG.A = REG.X: M.FL REG.A     '     /* TXA */
CASE &HAA: REG.X = REG.A: M.FL REG.X     '     /* TAX */
CASE &HE8: REG.X = REG.X + 1: M.FL REG.X '     /* INX */
CASE &HCA: REG.X = REG.X - 1: M.FL REG.X '     /* DEX */
CASE &HEA:  '                                  /* NOP */
CASE &H9A: REG.S = REG.X                 '     /* TXS */
CASE &HBA: REG.X = REG.S: M.FL REG.X     '     /* TSX */

CASE &H24: MR.Zp I: M.BIT I            '  /* BIT $ss ZP */
CASE &H2C: MR.Ab I: M.BIT I            '  /* BIT $ssss ABS */

CASE &H5: MR.Zp I: M.ORA I             '  /* ORA $ss ZP */
CASE &H6: MM.Zp MASL                 '  /* ASL $ss ZP */
CASE &H25: MR.Zp I: M.AND I            '  /* AND $ss ZP */
CASE &H26: MM.Zp MROL                '  /* ROL $ss ZP */
CASE &H45: MR.Zp I: M.EOR I            '  /* EOR $ss ZP */
CASE &H46: MM.Zp MLSR                '  /* LSR $ss ZP */
CASE &H65: MR.Zp I: M.ADC I          '  /* ADC $ss ZP */
CASE &H66: MM.Zp MROR                '  /* ROR $ss ZP */
CASE &H84: MW.Zp REG.Y                 '  /* STY $ss ZP */
CASE &H85: MW.Zp REG.A                 '  /* STA $ss ZP */
CASE &H86: MW.Zp REG.X                 '  /* STX $ss ZP */
CASE &HA4: MR.Zp REG.Y: M.FL REG.Y     '  /* LDY $ss ZP */
CASE &HA5: MR.Zp REG.A: M.FL REG.A     '  /* LDA $ss ZP */
'/BaH
'/case &HA5: R.A = RAM[ (Op6502(R.PC.W++)) ]  ;break;
'/CAUTION ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
CASE &HA6: MR.Zp REG.X: M.FL REG.X     '  /* LDX $ss ZP */
CASE &HC4: MR.Zp I: M.CMP REG.Y, I     '  /* CPY $ss ZP */
CASE &HC5: MR.Zp I: M.CMP REG.A, I     '  /* CMP $ss ZP */
CASE &HC6: MM.Zp MDEC                '  /* DEC $ss ZP */
CASE &HE4: MR.Zp I: M.CMP REG.X, I     '  /* CPX $ss ZP */
CASE &HE5: MR.Zp I: M.SBC I            '  /* SBC $ss ZP */
CASE &HE6: MM.Zp minc                '  /* INC $ss ZP */
CASE &HD: MR.Ab I: M.ORA I             '  /* ORA $ssss ABS */
CASE &HE: MM.Ab MASL                 '  /* ASL $ssss ABS */
CASE &H2D: MR.Ab I: M.AND I            '  /* AND $ssss ABS */
CASE &H2E: MM.Ab MROL                '  /* ROL $ssss ABS */

CASE &H4D: MR.Ab I: M.EOR I            '  /* EOR $ssss ABS */
CASE &H4E: MM.Ab MLSR                '  /* LSR $ssss ABS */

CASE &H6D: MR.Ab I: M.ADC I            '  /* ADC $ssss ABS */
CASE &H6E: MM.Ab MROR                '  /* ROR $ssss ABS */

CASE &H8C: MW.Ab REG.Y                 '  /* STY $ssss ABS */
CASE &H8D: MW.Ab REG.A                 '  /* STA $ssss ABS */
CASE &H8E: MW.Ab REG.X                 '  /* STX $ssss ABS */
CASE &HAC: MR.Ab REG.Y: M.FL REG.Y     '  /* LDY $ssss ABS */
CASE &HAD: MR.Ab REG.A: M.FL REG.A     '  /* LDA $ssss ABS */
CASE &HAE: MR.Ab REG.X: M.FL REG.X     '  /* LDX $ssss ABS */
CASE &HCC: MR.Ab I: M.CMP REG.Y, I     '  /* CPY $ssss ABS */
CASE &HCD: MR.Ab I: M.CMP REG.A, I     '  /* CMP $ssss ABS */
CASE &HCE: MM.Ab MDEC                '  /* DEC $ssss ABS */

CASE &HEC: MR.Ab I: M.CMP REG.X, I     '  /* CPX $ssss ABS */
CASE &HED: MR.Ab I: M.SBC I            '  /* SBC $ssss ABS */
CASE &HEE: MM.Ab minc                '  /* INC $ssss ABS */

CASE &H9: MR.Im I: M.ORA I             '  /* ORA #$ss IMM */
CASE &H29: MR.Im I: M.AND I            '  /* AND #$ss IMM */
CASE &H49: MR.Im I: M.EOR I            '  /* EOR #$ss IMM */
CASE &H69: MR.Im I: M.ADC I            '  /* ADC #$ss IMM */
CASE &HA0: MR.Im REG.Y: M.FL REG.Y     '  /* LDY #$ss IMM */
CASE &HA2: MR.Im REG.X: M.FL REG.X     '  /* LDX #$ss IMM */
CASE &HA9: MR.Im REG.A: M.FL REG.A     '  /* LDA #$ss IMM */
CASE &HC0: MR.Im I: M.CMP REG.Y, I     '  /* CPY #$ss IMM */
CASE &HC9: MR.Im I: M.CMP REG.A, I     '  /* CMP #$ss IMM */
CASE &HE0: MR.Im I: M.CMP REG.X, I     '  /* CPX #$ss IMM */
CASE &HE9: MR.Im I: M.SBC I            '  /* SBC #$ss IMM */

CASE &H15: MR.Zx I: M.ORA I            '  /* ORA $ss,x ZP,x */
CASE &H16: mm.zx MASL                '  /* ASL $ss,x ZP,x */
CASE &H35: MR.Zx I: M.AND I            '  /* AND $ss,x ZP,x */
CASE &H36: mm.zx MROL                '  /* ROL $ss,x ZP,x */
CASE &H55: MR.Zx I: M.EOR (I)          '  /* EOR $ss,x ZP,x */
CASE &H56: mm.zx MLSR                '  /* LSR $ss,x ZP,x */
CASE &H75: MR.Zx I: M.ADC I            '  /* ADC $ss,x ZP,x */
CASE &H76: mm.zx M_ROR                 '  /* ROR $ss,x ZP,x */
CASE &H94: MW.Zx REG.Y                 '  /* STY $ss,x ZP,x */
CASE &H95: MW.Zx REG.A                 '  /* STA $ss,x ZP,x */
CASE &H96: mw.zy REG.X                 '  /* STX $ss,y ZP,y */
CASE &HB4: MR.Zx REG.Y: M.FL REG.Y     '  /* LDY $ss,x ZP,x */
CASE &HB5: MR.Zx REG.A: M.FL REG.A     '  /* LDA $ss,x ZP,x */
CASE &HB6: mr.zy REG.X: M.FL REG.X     '  /* LDX $ss,y ZP,y */
CASE &HD5: MR.Zx I: M.CMP REG.A, I     '  /* CMP $ss,x ZP,x */
CASE &HD6: mm.zx MDEC                '  /* DEC $ss,x ZP,x */
CASE &HF5: MR.Zx I: M.SBC (I)          '  /* SBC $ss,x ZP,x */
CASE &HF6: mm.zx minc                '  /* INC $ss,x ZP,x */
CASE &H19: MR.Ay I: M.ORA I            '  /* ORA $ssss,y ABS,y */
CASE &H1D: MR.Ax I: M.ORA I            '  /* ORA $ssss,x ABS,x */
CASE &H1E: mm.ax MASL                '  /* ASL $ssss,x ABS,x */
CASE &H39: MR.Ay I: M.AND I            '  /* AND $ssss,y ABS,y */
CASE &H3D: MR.Ax I: M.AND I            '  /* AND $ssss,x ABS,x */
CASE &H3E: mm.ax MROL                '  /* ROL $ssss,x ABS,x */
CASE &H59: MR.Ay I: M.EOR I            '  /* EOR $ssss,y ABS,y */
CASE &H5D: MR.Ax I: M.EOR I            '  /* EOR $ssss,x ABS,x */
CASE &H5E: mm.ax MLSR                '  /* LSR $ssss,x ABS,x */
CASE &H79: MR.Ay I: M.ADC I            '  /* ADC $ssss,y ABS,y */
CASE &H7D: MR.Ax I: M.ADC I            '  /* ADC $ssss,x ABS,x */
CASE &H7E: mm.ax MROR                '  /* ROR $ssss,x ABS,x */
CASE &H99: mw.ay REG.A                 '  /* STA $ssss,y ABS,y */
CASE &H9D: MW.Ax REG.A                 '  /* STA $ssss,x ABS,x */
CASE &HB9: MR.Ay REG.A: M.FL REG.A     '  /* LDA $ssss,y ABS,y */
CASE &HBC: MR.Ax REG.Y: M.FL REG.Y     '  /* LDY $ssss,x ABS,x */
CASE &HBD: MR.Ax REG.A: M.FL REG.A     '  /* LDA $ssss,x ABS,x */
CASE &HBE: MR.Ay REG.X: M.FL REG.X     '  /* LDX $ssss,y ABS,y */
CASE &HD9: MR.Ay I: M.CMP REG.A, I     '  /* CMP $ssss,y ABS,y */
CASE &HDD: MR.Ax I: M.CMP REG.A, I     '  /* CMP $ssss,x ABS,x */
CASE &HDE: mm.ax MDEC                '  /* DEC $ssss,x ABS,x */
CASE &HF9: MR.Ay I: M.SBC I            '  /* SBC $ssss,y ABS,y */
CASE &HFD: MR.Ax I: M.SBC I            '  /* SBC $ssss,x ABS,x */
CASE &HFE: mm.ax minc                '  /* INC $ssss,x ABS,x */
CASE &H1: MR.Ix I: M.ORA I             '  /* ORA ($ss,x) INDEXINDIR */
CASE &H11: MR.Iy I: M.ORA I            '  /* ORA ($ss),y INDIRINDEX */
CASE &H21: MR.Ix I: M.AND I            '  /* AND ($ss,x) INDEXINDIR */
CASE &H31: MR.Iy I: M.AND I            '  /* AND ($ss),y INDIRINDEX */
CASE &H41: MR.Ix I: M.EOR I            '  /* EOR ($ss,x) INDEXINDIR */
CASE &H51: MR.Iy I: M.EOR I            '  /* EOR ($ss),y INDIRINDEX */
CASE &H61: MR.Ix I: M.ADC I            '  /* ADC ($ss,x) INDEXINDIR */
CASE &H71: MR.Iy I: M.ADC I            '  /* ADC ($ss),y INDIRINDEX */
CASE &H81: mw.ix REG.A                 '  /* STA ($ss,x) INDEXINDIR */
CASE &H91: mw.iy REG.A                 '  /* STA ($ss),y INDIRINDEX */
CASE &HA1: MR.Ix REG.A: M.FL REG.A     '  /* LDA ($ss,x) INDEXINDIR */
CASE &HB1: MR.Iy REG.A: M.FL REG.A     '  /* LDA ($ss),y INDIRINDEX */
CASE &HC1: MR.Ix I: M.CMP REG.A, I     '  /* CMP ($ss,x) INDEXINDIR */
CASE &HD1: MR.Iy I: M.CMP REG.A, I     '  /* CMP ($ss),y INDIRINDEX */
CASE &HE1: MR.Ix I: M.SBC I            '  /* SBC ($ss,x) INDEXINDIR */
CASE &HF1: MR.Iy I: M.SBC I            '  /* SBC ($ss),y INDIRINDEX */
CASE &HA: M.ASL REG.A                 '  /* ASL a ACC */
CASE &H2A: M.ROL REG.A                '  /* ROL a ACC */
CASE &H4A: M.LSR REG.A                '  /* LSR a ACC */
CASE &H6A: M.ROR REG.A                '  /* ROR a ACC */

CASE ELSE
PRINT REG.PC.W, I: END
'default:
'  if(_TrapBadOps) {
'    fprintf
'    ( stderr,
'      "[M6502 %lX] Unrecognized instruction: $%02X at PC=$%04X\n",
'      (unsigned)_User,Op6502(REG.PC.W-1),(word)(REG.PC.W-1)
'    );
'
'    _Trace=1;
'
'  }
'
'  break;
END SELECT



END SUB

SUB IO.write (A%, B%)
END SUB

SUB M.ADC (RG)
  IF (REG.P AND D.FLAG) THEN
  
  K.B.l = (REG.A AND &HF) + (RG AND &HF) + (REG.P AND C.FLAG)
  K.B.H = (REG.A \ 2 ^ 4) + (RG \ 2 ^ 4)
    IF (K.B.l > 9) THEN K.B.l = K.B.l + 6: K.B.H = K.B.H + 1
    IF (K.B.H > 9) THEN K.B.H = K.B.H + 6
    REG.A = (K.B.l AND &HF) OR (K.B.H * 2 ^ 4)
    IF K.B.H > 15 THEN TMP = C.FLAG:  ELSE TMP = 0
    REG.P = (REG.P AND NOT (C.FLAG)) OR TMP
    'ZF = NF = A
    REG.ZF = REG.A
    REG.NF = REG.A
                CYCLE = CYCLE + 1
  
  ELSE
  
    K.W = REG.A + RG + (REG.P AND C.FLAG)
    REG.P = REG.P AND NOT (C.FLAG)
    IF K.B.H THEN TMP = C.FLAG:  ELSE TMP = 0
    REG.P = REG.P OR TMP
    'ZF=NF=K.B.L
    REG.ZF = K.B.l
    REG.NF = K.B.l
    REG.A = K.B.l
   END IF

END SUB

SUB M.ADCx (RG)

 MX = AdrRAM(REG.X + ZP)
  IF (REG.P AND D.FLAG) THEN
  
    K.B.l = (MX AND &HF) + (RG AND &HF) + (REG.P AND C.FLAG)
    K.B.H = (MX \ 2 ^ 4) + (RG \ 2 ^ 4)';/*+(K.B.l>>4);*/ \
    IF (K.B.l > 9) THEN K.B.l = K.B.l + 6: K.B.H = K.B.H + 1
    IF (K.B.H > 9) THEN K.B.H = K.B.H + 6
    MX = (K.B.l AND &HF) OR (K.B.H * 2 ^ 4)
            CYCLE = CYCLE + 1
  
  ELSE
  
    K.W = MX + RG + (REG.P AND C.FLAG)
                    MX = K.B.l
  
 END IF
 AdrRAM(REG.X + ZP) = MX
END SUB

SUB M.AND (RG)
REG.A = REG.A AND RG
M.FL REG.A
END SUB

SUB M.ANDx (RG)
AdrRAM(REG.X + ZP) = AdrRAM(REG.X + ZP) AND RG
M.FL RdRAM(REG.X + ZP)
END SUB

SUB M.ASL (RG)
REG.P = REG.P AND NOT (C.FLAG)
REG.P = REG.P OR RG \ 2 ^ 7
RG = RG * 2 ^ 1
M.FL RG
END SUB

SUB M.BIT (RG)
REG.NF = RG
REG.VF = RG
REG.ZF = RG AND REG.A

END SUB

SUB M.CMP (RG1, RG2)
K.W = RG1 - RG2
REG.P = REG.P AND NOT (C.FLAG)
IF K.B.H THEN TMP = 0 ELSE TMP = C.FLAG
REG.P = REG.P OR TMP
'ZF = NF = K.B.L
REG.ZF = K.B.l
REG.NF = K.B.l

END SUB

SUB M.DEC (RG)
RG = RG - 1
M.FL RG
END SUB

SUB M.EOR (RG)
REG.A = REG.A XOR RG
M.FL REG.A
END SUB

SUB M.EORx (RG)
AdrRAM(REG.X + ZP) = AdrRAM(REG.X + ZP) XOR RG
M.FL RdRAM(REG.X + ZP)

END SUB

SUB M.FL (RG)
'ZF=NF=RG
REG.ZF = RG
REG.NF = RG
END SUB

SUB M.INC (RG)
RG = RG + 1
M.FL RG
END SUB

DEFSNG A-Z
SUB M.JR ()
END SUB

DEFINT A-Z
SUB M.LDWORD (RG AS PCC)
RG.B.l = op6502(REG.PC.W)
RG.B.H = op6502(REG.PC.W + 1)
REG.PC.W = REG.PC.W + 2
END SUB

SUB M.LSR (RG)
REG.P = REG.P AND NOT (C.FLAG)
REG.P = REG.P OR (RG AND C.FLAG)
RG = RG \ 2 ^ 1
M.FL RG

END SUB

SUB M.ORA (RG)
REG.A = REG.A OR RG
M.FL REG.A
END SUB

SUB M.ORAx (RG)
AdrRAM(REG.X + ZP) = AdrRAM(REG.X + ZP) OR RG
M.FL RdRAM(REG.X + ZP)

END SUB

SUB M.POP (RG)
REG.S = REG.S + 1
RG = RdRAM(SP + 6)
END SUB

SUB M.POP.P (RG)
'NF=VF=RG
M.POP RG
REG.NF = RG
REG.VF = RG
IF RG AND Z.FLAG THEN TMP = 0 ELSE TMP = 1
REG.ZF = RG AND TMP
END SUB

SUB M.PUSH (RG)
WRRAM SP + REG.S, RG
REG.S = REG.S - 1

END SUB

SUB M.PUSH.P (RG)
IF REG.ZF THEN TMP = 0 ELSE TMP = Z.FLAG
M.PUSH ((RG) AND NOT (N.FLAG OR V.FLAG OR Z.FLAG)) OR (REG.NF AND N.FLAG) OR (REG.VF AND V.FLAG) OR TMP
END SUB

SUB M.RMB (N)
AdrRAM(MCZp()) = AdrRAM(MCZp()) AND NOT (N)
END SUB

SUB M.ROL (RG)
K.B.l = (RG * 2 ^ 1) OR (REG.P AND C.FLAG)
REG.P = REG.P AND NOT (C.FLAG)
REG.P = REG.P OR (RG \ 2 ^ 7)
RG = K.B.l
M.FL RG
END SUB

SUB M.ROR (RG)
K.B.l = (RG \ 2 ^ 1) OR (REG.P * 2 ^ 7)
REG.P = REGT.P AND NOT (C.FLAG)
REG.P = REG.P OR (RG AND C.FLAG)
RG = K.B.l
M.FL RG
END SUB

SUB M.SBC (RG)
'/* Warning! C_FLAG is inverted before SBC and after it */
  IF (REG.P AND D.FLAG) THEN
  
    K.B.l = (REG.A AND &HF) - (RG AND &HF) - (NOT (REG.P) AND C.FLAG)
    IF (K.B.l AND &H10) THEN K.B.l = K.B.l - 6
    K.B.H = (REG.A \ 2 ^ 4) - (RG \ 2 ^ 4) - ((K.B.l AND &H10) = &H10)
    IF (K.B.H AND &H10) THEN K.B.H = K.B.H - 6
                CYCLE = CYCLE + 1
  
  ELSE
  
    K.W = REG.A - RG - (NOT (REG.P) AND C.FLAG)
  END IF

END SUB

SUB M.SMB (N)
AdrRAM(MCZp()) = AdrRAM(MCZp()) OR N
END SUB

SUB MC.Ab (RG AS PCC)
M.LDWORD RG

END SUB

SUB MC.Ax (RG AS PCC)
M.LDWORD RG
RG.W = RG.W + REG.X
END SUB

SUB MC.Ay (RG AS PCC)
M.LDWORD RG
RG.W = RG.W + REG.Y
END SUB

SUB MC.ID (RG AS PCC)
K.W = MCZp()
RG.B.l = RdRAM(K.W)
RG.B.H = RdRAM(K.W + 1)
END SUB

SUB MC.Ix (RG AS PCC)
K.W = MCZx()
RG.B.l = RdRAM(K.W)
RG.B.H = RdRAM(K.W + 1)
END SUB

SUB MC.Iy (RG AS PCC)
K.W = MCZp()
RG.B.l = RdRAM(K.W): RG.B.H = RdRAM(K.W + 1)
RG.W = RG.W + REG.Y
END SUB

SUB mc.zp (RG AS PCC)
RG.B.l = op6502(REG.PC.W)
REG.PC.W = REG.PC.W + 1
RG.B.H = ZP \ 2 ^ 8

END SUB

DEFSNG A-Z
SUB mc.zx (RG AS PCC)
RG.B.l = op6502(REG.PC.W) + REG.X
REG.PC.W = REG.PC.W + 1
RG.B.H = ZP \ 2 ^ 8

END SUB

SUB mc.zy (RG AS PCC)
RG.B.l = op6502(REG.PC.W) + REG.Y
REG.PC.W = REG.PC.W + 1
RG.B.H = ZP \ 2 ^ 8

END SUB

FUNCTION MCAB% ()
MCAB% = OP6502W(REG.PC.W)

END FUNCTION

FUNCTION MCAX% ()
MCAX% = OP6502W(REG.PC.W) + REG.X
END FUNCTION

FUNCTION MCAY% ()
MCAY% = OP6502W(REG.PC.W) + REG.Y
END FUNCTION

FUNCTION MCIX% ()
MCIX% = RDRAMW(MCZx)

END FUNCTION

FUNCTION MCIY% ()
MCIY% = RDRAMW(MCZp) + REG.Y
END FUNCTION

DEFINT A-Z
FUNCTION MCZp ()
MCZp = op6502(REG.PC.W) + ZP
REG.PC.W = REG.PC.W + 1

END FUNCTION

FUNCTION MCZx ()
MCZx = (byte) * op6502(REG.PC.W) + REG.X + ZP
REG.PC.W = REG.PC.W + 1

END FUNCTION

FUNCTION MCZY ()
MCZY = (byte) * op6502(REG.PC.W) + REG.Y + ZP
REG.PC.W = REG.PC.W + 1
END FUNCTION

SUB MM.Ab (CMD)
MC.Ab J
I = rd6502(J.W)

CmdE I, CMD

Wr6502 J.W, I

END SUB

SUB mm.ax (CMD)
MC.Ax J
I = rd6502(J.W)

CmdE I, CMD

Wr6502 J.W, I

END SUB

SUB MM.Zp (CMD)
J.W = MCZp()
I = RdRAM(J.W)

CmdE I, CMD

WRRAM J.W, I
END SUB

SUB mm.zx (CMD)
J.W = MCZx()
I = RdRAM(J.W)

CmdE I, CMD

WRRAM J.W, I
END SUB

SUB MR.Ab (RG)
MC.Ab J
RG = rd6502(J.W)

END SUB

SUB MR.Ax (RG)
MC.Ax J
RG = rd6502(J.W)
END SUB

SUB MR.Ay (RG)
MC.Ay J
RG = rd6502(J.W)
END SUB

SUB MR.ID (RG)
MC.ID J
RG = rd6502(J.W)

END SUB

SUB MR.Im (RG)
RG = op6502(REG.PC.W)
REG.PC.W = REG.PC.W + 1
END SUB

SUB MR.Ix (RG)
MC.Ix J
RG = rd6502(J.W)
END SUB

SUB MR.Iy (RG)
MC.Iy J
RG = rd6502(J.W)
END SUB

SUB MR.Zp (RG)
RG = RdRAM(MCZp())

END SUB

SUB MR.Zx (RG)
RG = RdRAM(MCZx())
END SUB

SUB mr.zy (RG)
RG = RdRAM(MCZY())
END SUB

SUB MW.Ab (RG)
MC.Ab J
Wr6502 J.W, RG
END SUB

SUB MW.Ax (RG)
MC.Ax J
Wr6502 J.W, RG
END SUB

SUB mw.ay (RG)
MC.Ay J
Wr6502 J.W, RG
END SUB

SUB mw.ix (RG)
MC.Ix J
Wr6502 J.W, RG
END SUB

SUB mw.iy (RG)
MC.Iy J
Wr6502 J.W, RG
END SUB

SUB MW.Zp (RG)
WRRAM MCZp(), RG
END SUB

SUB MW.Zx (RG)
WRRAM MCZx(), RG
END SUB

SUB mw.zy (RG)
WRRAM MCZY(), RG
END SUB

FUNCTION op6502 (A%)
SEEK #1, A% + 513
B$ = INPUT$(1, 1)
op6502 = ASC(B$)
END FUNCTION

FUNCTION OP6502W (A%)
END FUNCTION

FUNCTION rd6502 (A%)
END FUNCTION

FUNCTION RDRAMW (A%)
END FUNCTION

SUB RESET6502 ()
  REG.mpr(7) = &H0: BANK.SET 7, &H0

   REG.mpr(6) = &H5: BANK.SET 6, &H5

   REG.mpr(5) = &H4: BANK.SET 5, &H4

   REG.mpr(4) = &H3: BANK.SET 4, &H3

   REG.mpr(3) = &H2: BANK.SET 3, &H2

   REG.mpr(2) = &H1: BANK.SET 2, &H1

   REG.mpr(1) = &HF8: BANK.SET 1, &HF8

   REG.mpr(0) = &HFF: BANK.SET 0, &HFF
  REG.A = 0: REG.X = 0: REG.Y = 0
  REG.P = I.FLAG

  REG.NF = 0: REG.VF = 0

  REG.ZF = &HFF
  REG.S = &HFF

  REG.PC.B.l = op6502(VEC.RESET)
  REG.PC.B.H = op6502(VEC.RESET + 1)
  REG.ICount = REG.IPeriod
  REG.IRequest = INT.NONE
  REG.AfterCLI = 0
  '//_CycleCount=0;
  '(int)(R->User)=0;
  REG.USER = 0
END SUB

SUB RUN6502 ()
RESET6502
DO
I = op6502(REG.PC.W)
PRINT REG.PC.W;
REG.PC.W = REG.PC.W + 1
CYCLE = CYCLES(I)
CODES I
LOOP
END SUB

SUB TRB (RG)
'NF=VF=RG
REG.NF = RG
REG.VF = RG
RG = RG AND NOT (REG.A)
REG.ZF = RG

END SUB

SUB TSB (RG)
'NF=VF=RG
REG.NF = RG
REG.VF = RG
RG = RG OR REG.A
REG.ZF = RG

END SUB

SUB T_INIT ()
END SUB

SUB Wr6502 (A%, B%)
END SUB

SUB WRRAM (A%, B%)
END SUB

