DECLARE SUB ENDPROG ()
DECLARE SUB VMMEND ()
DECLARE SUB INITVMM (SIZE%)
DECLARE SUB lockvmm (A&, b&)
DECLARE SUB WRVMMB (A&, b%)
DECLARE FUNCTION vramg% (A%)
DECLARE SUB VRAMp (A%, b%)
DECLARE SUB MOVLEN (S&, d&, L&)
DECLARE SUB cmdd (cmd1%, cmd2%)
DECLARE FUNCTION cmdrr% (cmd%)
DECLARE FUNCTION notb% (A%)
DECLARE SUB cmdc (cmd%, rg AS ANY)
DECLARE SUB T_INIT (SRC&, DIST&, LENGTH&)
DECLARE FUNCTION rdvmmb% (A&)
DECLARE SUB loadpce (f%)
DECLARE FUNCTION allocvmm& (SIZE&)
DECLARE SUB WRVMM (adr&, d$)
DECLARE FUNCTION io_read% (A&)
DECLARE SUB REGINC (rg AS ANY)
DECLARE SUB instr.init ()
DECLARE FUNCTION opcode$ (I AS INTEGER)
DECLARE FUNCTION op6502i% (rg AS ANY)
DECLARE SUB BANK.SET (A%, b%)
DECLARE SUB CODES (I%)
DECLARE SUB io_write (A&, b%)
DECLARE SUB M.LDWORD (rg AS ANY)
DECLARE FUNCTION MCZp% ()
DECLARE FUNCTION MCZx% ()
DECLARE FUNCTION MCZY% ()
DECLARE FUNCTION nop6502% (rg AS ANY)
DECLARE FUNCTION op6502% (A&)
DECLARE FUNCTION OP6502W& (A&)
DECLARE FUNCTION Rd6502% (A&)
DECLARE FUNCTION RdRAM% (A&)
DECLARE SUB RESET6502 ()
DECLARE SUB RUN6502 ()
DECLARE FUNCTION word& (rg AS ANY)
DECLARE SUB WORDS (rg AS ANY, A&)
DECLARE SUB Wr6502 (A&, b%)
DECLARE SUB wrRAM (A&, b%)
DECLARE SUB CMDR (cmd%, rg%)
DECLARE SUB M.CMP (rg1%, rg2%)
DECLARE SUB M.JR ()
DEFINT A-Z




'TYPE bb  'change this around for lsb fists, last
'L AS INTEGER
'H AS INTEGER
'END TYPE


'TYPE PCC
' W AS INTEGER
' B AS bb
'END TYPE

TYPE PCC
 L AS INTEGER
 H AS INTEGER
END TYPE

TYPE regg
 p AS INTEGER        'one byte register
 A AS INTEGER        '
 x AS INTEGER        '
 y AS INTEGER        '
 S AS INTEGER        '
 PC AS PCC           'word
 NF AS INTEGER 'one byte flag (last set)
 VF AS INTEGER '
 ZF AS INTEGER '
 MPR(7) AS INTEGER   'memory mapping registers pagr<->mmap (byte)
 IRequest AS INTEGER
 ICount AS INTEGER
 IBackup AS INTEGER
 AfterCLI AS INTEGER
 IPeriod AS INTEGER
 USER AS INTEGER
END TYPE

TYPE ioo
 VDC(32) AS PCC              'pair
 VCE(&H200) AS PCC
 vce_reg AS PCC
 'vdc
 vdc_inc AS LONG             'word
 vdc_raster_count AS LONG
 vdc_reg AS INTEGER          'byte
 vdc_status AS INTEGER
 VDC_ratch AS INTEGER
 vce_ratch AS INTEGER
 vdc_satb AS INTEGER
 vdc_pendvsync AS INTEGER
 bg_h AS INTEGER             'integer
 bg_w AS INTEGER
 scroll_y AS INTEGER
 minline AS INTEGER
 MaxLine AS INTEGER
 'joypad
 JOY(16) AS INTEGER          'byte
 joy_select AS INTEGER
 joy_counter AS INTEGER
 'psg
  PSG(6, 8) AS INTEGER
  wave(6, 32) AS INTEGER
  wavofs(6) AS INTEGER

  '// PSG STRUCTURE
  '// 0 : dda_out
  '// 2 : freq (lo byte)  In reality it's a divisor
  '// 3 : freq (hi byte)
  '// 4 : dda_ctrl
  '//     000XXXXX
  '//     ^^  ^
  '//     ||  ch. vol
  '//     ||
  '//     |direct access (everything at byte 0)
  '//     |
  '//    enable
  '// 5 : pan (left vol = hi nibble, right vol = low nibble)
  '// 7 : noise_ctrl
  psg_ch AS INTEGER         'byte
  psg_volume AS INTEGER
  psg_lfo_freq AS INTEGER
  psg_lfo_ctrl AS INTEGER
  '/* TIMER */
  timer_reload AS INTEGER  'byte
  timer_start AS INTEGER
  timer_counter AS INTEGER
  '/* IRQ */
    irq_mask AS INTEGER    'byte
    irq_status AS INTEGER
  '/* CDROM extention */
   backup AS INTEGER          'integer
   adpcm_firstread AS INTEGER 'integwer
   adpcm AS PCC               'pair
   adpcm_rptr AS LONG         'word
   adpcm_wptr AS LONG
 END TYPE





'byte = unsigned char (1)
'word = unsigned short (2)
'offset = signed char

'UNION pair
' word w
' int b {byte l,h}
'end type
' n
' n.w
' n.b (n.b.l,n.b.h)


                       '       /* 6502 status flags:         */
CONST c.flag = &H1     '       /* 1: Carry occured           */
CONST cn.flag = NOT c.flag AND &HFF
                       '       /* notb c.flag
CONST Z.FLAG = &H2     '       /* 1: Result is zero          */
CONST I.FLAG = &H4     '       /* 1: Interrupts disabled     */
CONST d.flag = &H8     '       /* 1: Decimal mode            */
CONST b.flag = &H10    '       /* Break [0 on stk after int] */
CONST r.flag = &H20    '       /* Always 1                   */
CONST V.FLAG = &H40    '       /* 1: Overflow occured        */
CONST N.FLAG = &H80    '       /* 1: Result is negative      */

CONST byt = &HFF       '       /* byte
CONST wrd = &HFFFF     '       /* word

'                      '       /* Loop6502() returns:        */
CONST INT.NONE = 0     '       /* No interrupt required      */
CONST INT.IRQ = 1      '       /* Standard IRQ interrupt     */
CONST INT.NMI = 2      '       /* Non-maskable interrupt     */
CONST INT.QUIT = 3     '       /* Exit the emulation         */

CONST INT.TIMER = 4
CONST INT.IRQ2 = 8
CONST VEC.RESET = &HFFFE
CONST VER.NMI = &HFFFC
CONST vec.timer = &HFFFA
CONST VEC.IRQ = &HFFF8
CONST VER.IRQ2 = &HFFF6
CONST VEC.BRK = &HFFFE
CONST zp = 0              'stack page
CONST sp = &H100          'zero page





DIM SHARED REG AS regg, K AS PCC, j AS PCC, CYCLES%(255), I, laststr
DIM SHARED CYCLE&, page&(7), ROMMAP&(255), Vram&, ram&, popram&, ROM&, ioarea&, io AS ioo
DIM SHARED ta AS PCC, COUNTER&, TS!, Pal(512)
DIM SHARED JUMPSTA(255) AS PCC, JS, JSS, JUMPSTAA(255)
DIM SHARED CMDSET1(255), CMDSET2(255)


CONST file1 = "neutop1.pce", file2 = "bonk3.pce", file3 = "BOMB94.PCE"
OPEN file3 FOR BINARY ACCESS READ AS #1
CLS
INITVMM 2048
loadpce 1

RESTORE cycledata
FOR II = 0 TO 255: READ CYCLES%(II): NEXT II
RESTORE CMDDSETDATA
FOR II = 0 TO 255: READ CMDSET1(II), CMDSET2(II)
NEXT II



CLS
RUN6502
ENDPROG



cycledata:
'static byte Cycles[256] =
DATA     8,7,3, 4,6,4,6,7,3,2,2,0,7,5,7,6
DATA     2,7,7, 4,6,4,6,7,2,5,2,0,7,5,7,6
DATA     7,7,3, 4,4,4,6,7,3,2,2,0,5,5,7,6
DATA     2,7,7, 0,4,4,6,7,2,5,2,0,5,5,7,6
DATA     7,7,3, 4,8,4,6,7,3,2,2,0,4,5,7,6
DATA     2,7,7, 5,0,4,6,7,2,5,3,0,0,5,7,6
DATA     7,7,2, 0,4,4,6,7,3,2,2,0,7,5,7,6
DATA     2,7,7,17,4,4,6,7,2,5,3,0,7,5,7,6
DATA     4,7,2, 7,4,4,4,7,2,2,2,0,5,5,5,6
DATA     2,7,7, 8,4,4,4,7,2,5,2,0,5,5,5,6
DATA     2,7,2, 7,4,4,4,7,2,2,2,0,5,5,5,6
DATA     2,7,7, 8,4,4,4,7,2,5,2,0,5,5,5,6
DATA     2,7,2,17,4,4,6,7,2,2,2,0,5,5,7,6
DATA     2,7,7,17,0,4,6,7,2,5,3,0,0,5,7,6
DATA     2,7,0,17,4,4,6,7,2,2,2,0,5,5,7,6
DATA     2,7,7,17,2,4,6,7,2,5,3,0,0,5,7,0
 
CONST MNUL = 0, minc = 1, MDEC = 2, MROR = 3, MROL = 4, MLSR = 5, masl = 6, MTRB = 7, MTSB = 8
CONST M.NUL = 0, m.inc = 1, M.DEC = 2, M.ROR = 3, M.ROL = 4, M.LSR = 5, m.asl = 6, TRB = 7, TSB = 8
CONST m.adc = 9, m.and = 10, m.andx = 11, m.bit = 12, m.eor = 13, m.eorx = 14
CONST m.fl = 15, m.ora = 16, m.orax = 17, m.pop = 18, m.push = 19, M.RMB = 20
CONST mm.zx = 21, MM.Zp = 22, mm.ax = 23, MM.Ab = 24
CONST mr.ab = 25, mr.ax = 26, mr.ay = 27, mr.id = 28, mr.im = 29, mr.ix = 30, mr.iy = 31, mr.zp = 32, mr.zx = 33, mr.zy = 34
CONST mw.ab = 35, mw.ax = 36, mw.ay = 37, mw.ix = 38, mw.iy = 39, mw.zp = 40, mw.zx = 41, mw.zy = 42
CONST m.sbc = 43
CONST M.SMB = 44
CONST m.adcx = 45
CONST mc.ab = 46, mc.ax = 47, mc.ay = 48, mc.id = 49, mc.ix = 50, mc.iy = 51, mc.zp = 52, mc.zx = 53, mc.zy = 54
CONST m.pop.p = 55, m.push.p = 56
'148KHZ with DEBUG OFF
'152KHZ with CMDDSETDATA
'25MHZ MAX SPEED (LONG INC)

CMDDSETDATA: 'SET(F4) COMMANDS(0-FF):CMDD CMD1,CMD2  00,00 = NULL
DATA 00,00, 30,17, 00,00, 00,00, 00,00, 32,17, 00,00, 00,00, 00,00, 29,17
DATA 00,00, 00,00, 00,00, 25,17, 00,00, 00,00, 00,00, 31,17, 28,17, 00,00
DATA 00,00, 33,17, 00,00, 00,00, 00,00, 27,17, 00,00, 00,00, 00,00, 26,17
DATA 00,00, 00,00, 00,00, 30,11, 00,00, 00,00, 00,00, 32,11, 00,00, 00,00
DATA 00,00, 29,11, 00,00, 00,00, 00,00, 25,11, 00,00, 00,00, 00,00, 31,11
DATA 28,11, 00,00, 00,00, 33,11, 00,00, 00,00, 00,00, 27,11, 00,00, 00,00
DATA 00,00, 26,11, 00,00, 00,00, 00,00, 30,14, 00,00, 00,00, 00,00, 32,14
DATA 00,00, 00,00, 00,00, 29,14, 00,00, 00,00, 00,00, 25,14, 00,00, 00,00
DATA 00,00, 31,14, 28,14, 00,00, 00,00, 33,14, 00,00, 00,00, 00,00, 27,14
DATA 00,00, 00,00, 00,00, 26,14, 00,00, 00,00, 00,00, 30,45, 00,00, 00,00
DATA 00,00, 32,45, 00,00, 00,00, 00,00, 29,45, 00,00, 00,00, 00,00, 25,45
DATA 00,00, 00,00, 00,00, 31,45, 28,45, 00,00, 00,00, 33,45, 00,00, 00,00
DATA 00,00, 27,45, 00,00, 00,00, 00,00, 26,45, 00,00, 00,00, 00,00, 00,00
DATA 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00
DATA 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00
DATA 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00
DATA 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00
DATA 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00
DATA 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00
DATA 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00
DATA 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00
DATA 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00
DATA 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00
DATA 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00
DATA 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00
DATA 00,00, 00,00, 00,00, 00,00, 00,00, 00,00

SUB BANK.SET (p, V)

IF ROMMAP&(V) = ioarea& THEN
page&(p) = ioarea&
ELSE

page&(p) = ROMMAP&(V) - p * 8192&


END IF
END SUB

SUB cmdc (cmd, rg AS PCC)
SELECT CASE cmd
CASE 0: PRINT "error cmdc": ENDPROG

CASE mc.ab
   M.LDWORD rg
CASE mc.ax
  M.LDWORD rg
  WORDS rg, word(rg) + REG.x

CASE mc.ay
  M.LDWORD rg
  WORDS rg, word(rg) + REG.y

CASE mc.id
  WORDS K, MCZp()
  rg.L = RdRAM(word(K))
  rg.H = RdRAM(word(K) + 1)
CASE mc.ix
  WORDS K, MCZx()
  rg.L = RdRAM(word(K))
  rg.H = RdRAM(word(K) + 1)
CASE mc.iy
  WORDS K, MCZp()
  rg.L = RdRAM(word(K)): rg.H = RdRAM(word(K) + 1)
  WORDS rg, word(rg) + REG.y
CASE mc.zp
  rg.L = nop6502(REG.PC)
  rg.H = zp \ 2 ^ 8
CASE mc.zx
  rg.L = nop6502(REG.PC) + REG.x
  rg.H = zp \ 2 ^ 8
CASE mc.zy
  rg.L = nop6502(REG.PC) + REG.y
  rg.H = zp \ 2 ^ 8
CASE ELSE
  PRINT "Invalid CmdC"; cmd: ENDPROG
END SELECT


END SUB

SUB cmdd (cmd1, cmd2)
CMDR cmd1, I
CMDR cmd2, I

END SUB

SUB CMDR (cmd, rg)
SELECT CASE cmd
CASE M.NUL:
PRINT "error: CmdRg Null": ENDPROG
CASE m.adc 'm.adc

  IF (REG.p AND d.flag) THEN

  K.L = (REG.A AND &HF) + (rg AND &HF) + (REG.p AND c.flag)
  K.H = (REG.A \ 2 ^ 4) + (rg \ 2 ^ 4)
    IF (K.L > 9) THEN K.L = K.L + 6: K.H = K.H + 1
    IF (K.H > 9) THEN K.H = K.H + 6
    REG.A = ((K.L AND &HF) OR (K.H * 2 ^ 4)) AND &HFF

    IF K.H > 15 THEN REG.p = REG.p OR c.flag ELSE REG.p = REG.p AND cn.flag
    
    
    'ZF = NF = A
    REG.ZF = REG.A
    REG.NF = REG.A
                CYCLE& = CYCLE& + 1

  ELSE

    WORDS K, REG.A + rg + (REG.p AND c.flag)

    REG.p = REG.p AND cn.flag
    IF K.H THEN tmp = c.flag:  ELSE tmp = 0
    REG.p = REG.p OR tmp
    'ZF=NF=K.L
    REG.ZF = (notb(REG.A XOR rg) AND (REG.A XOR K.L)) \ 2 ^ 1
    REG.ZF = K.L
    REG.NF = K.L
    REG.A = K.L
   END IF
CASE m.adcx
 'MX = AdrRAM(reg.X + ZP)
  MX = RdRAM(REG.x + zp)
  IF (REG.p AND d.flag) THEN

    K.L = (MX AND &HF) + (rg AND &HF) + (REG.p AND c.flag)
    K.H = (MX \ 2 ^ 4) + (rg \ 2 ^ 4)';/*+(K.l>>4);*/ \
    IF (K.L > 9) THEN K.L = K.L + 6: K.H = K.H + 1
    IF (K.H > 9) THEN K.H = K.H + 6
    MX = ((K.L AND &HF) OR (K.H * 2 ^ 4)) AND &HFF

    IF K.H > 15 THEN REG.p = REG.p OR c.flag ELSE REG.p = REG.p AND cn.flag
    'ZF = NF = A
    REG.ZF = MX
    REG.NF = MX


    CYCLE& = CYCLE& + 1

  ELSE

    WORDS K, MX + rg + (REG.p AND c.flag)
    REG.p = REG.p AND cn.flag
    IF K.H THEN tmp = c.flag ELSE tmp = 0
    REG.p = REG.p OR tmp
    REG.VF = (notb(MX XOR rg) AND (MX XOR K.L)) \ 2 ^ 1
    REG.ZF = K.L
    REG.NF = K.L

    MX = K.L

 END IF
 'AdrRAM(reg.X + ZP) = MX
  wrRAM REG.x + zp, MX

CASE m.and
  REG.A = REG.A AND rg
  CMDR m.fl, REG.A
CASE m.andx
   'AdrRAM(reg.x + zp) = AdrRAM(reg.x + zp) AND RG
   wrRAM REG.x + zp, RdRAM(REG.x + zp) AND rg
   CMDR m.fl, RdRAM(REG.x + zp)

CASE m.asl
   REG.p = REG.p AND cn.flag
   REG.p = REG.p OR rg \ 2 ^ 7
   rg = (rg * 2 ^ 1) AND &HFF
   CMDR m.fl, rg

CASE m.bit
  REG.NF = rg
  REG.VF = rg
  REG.ZF = rg AND REG.A
CASE m.inc
  rg = rg + 1
  CMDR m.fl, rg

CASE M.DEC
  rg = rg - 1
  CMDR m.fl, rg


CASE M.ROR
  
  K.L = (rg \ 2 ^ 1) OR (REG.p * 2 ^ 7)
  REG.p = REG.p AND cn.flag
  REG.p = REG.p OR (rg AND c.flag)
  'rg = k.l     'to fix possible overflow
  CMDR m.fl, K.L
  rg = K.L
CASE M.ROL
  K.L = (rg * 2 ^ 1) OR (REG.p AND c.flag)
  REG.p = REG.p AND cn.flag
  REG.p = REG.p OR (rg \ 2 ^ 7)
  'rg = k.l to fix possible overflow
  CMDR m.fl, K.L
  rg = K.L
CASE M.LSR
  REG.p = REG.p AND cn.flag
  REG.p = REG.p OR (rg AND c.flag)
  rg = rg \ 2 ^ 1
  CMDR m.fl, rg

CASE TRB

  'NF=VF=RG
  REG.NF = rg
  REG.VF = rg
  rg = rg AND notb(REG.A)
  REG.ZF = rg

CASE TSB:
  'NF=VF=RG
  REG.NF = rg
  REG.VF = rg
  rg = rg OR REG.A
  REG.ZF = rg
CASE m.eor
  REG.A = REG.A XOR rg
  CMDR m.fl, REG.A
CASE m.eorx
  'AdrRAM(reg.x + zp) = AdrRAM(reg.x + zp) XOR RG
  wrRAM REG.x + zp, RdRAM(REG.x + zp) XOR rg
  CMDR m.fl, RdRAM(REG.x + zp)
CASE m.fl
  'ZF=NF=RG


  rg = rg AND &HFF  'flow control if needed 0 -> ff -> 0
  REG.ZF = rg
  REG.NF = rg
CASE m.ora
  REG.A = REG.A OR rg
  CMDR m.fl, REG.A
CASE m.orax
  'AdrRAM(reg.x + zp) = AdrRAM(reg.x + zp) OR RG
  wrRAM REG.x + zp, RdRAM(REG.x + zp) OR rg
  CMDR m.fl, RdRAM(REG.x + zp)
CASE m.pop
  REG.S = (REG.S + 1) AND &HFF      'does this fix overflow
  rg = RdRAM(sp + REG.S)
CASE m.push
  wrRAM sp + REG.S, rg
  REG.S = (REG.S - 1) AND &HFF      'does this fix overflow
CASE m.pop.p
'NF=VF=RG
CMDR m.pop, rg
REG.NF = rg
REG.VF = rg
IF rg AND Z.FLAG THEN tmp = 0 ELSE tmp = 1
REG.ZF = tmp
CASE m.push.p
IF REG.ZF THEN tmp = 0 ELSE tmp = Z.FLAG
CMDR m.push, ((rg) AND notb(N.FLAG OR V.FLAG OR Z.FLAG)) OR (REG.NF AND N.FLAG) OR (REG.VF AND V.FLAG) OR tmp

CASE M.RMB
  'AdrRAM(MCZp()) = AdrRAM(MCZp()) AND NOT (N)
  wrRAM MCZp(), RdRAM(MCZp()) AND notb(rg)
CASE m.sbc
  '/* Warning! C_FLAG is inverted before SBC and after it */
    IF (REG.p AND d.flag) THEN

      K.L = ((REG.A AND &HF) - (rg AND &HF) - (notb(REG.p) AND c.flag)) AND &HFF
      IF (K.L AND &H10) THEN K.L = K.L - 6
      K.H = ((REG.A \ 2 ^ 4) - (rg \ 2 ^ 4) + ((K.L AND &H10) = &H10)) AND &HFF
      IF (K.H AND &H10) THEN K.H = K.H - 6
      REG.A = (K.L AND &HF) OR (K.H * 2 ^ 4) AND &HFF
      IF K.H AND &H10 THEN tmp = 0 ELSE tmp = c.flag
      REG.p = REG.p AND cn.flag OR tmp

                  CYCLE& = CYCLE& + 1

    ELSE

      WORDS K, REG.A - rg - (notb(REG.p) AND c.flag)
      REG.p = REG.p AND cn.flag
      IF K.H THEN tmp = 0 ELSE tmp = c.flag
      REG.p = REG.p OR tmp
      REG.VF = ((REG.A XOR rg) AND (REG.A XOR K.L)) \ 2 ^ 1
      REG.ZF = K.L
      REG.NF = K.L
    END IF
CASE M.SMB
  'AdrRAM(MCZp()) = AdrRAM(MCZp()) OR N
  wrRAM MCZp(), RdRAM(MCZp()) OR rg
CASE MM.Ab
  cmdc mc.ab, j

  I = Rd6502(word(j))
  

  CMDR rg, I
  Wr6502 word(j), I
CASE mm.ax
  cmdc mc.ax, j
  I = Rd6502(word(j))
  CMDR rg, I
  Wr6502 word(j), I
CASE MM.Zp
  WORDS j, MCZp()
  I = RdRAM(word(j))
  CMDR rg, I
  wrRAM word(j), I
CASE mm.zx
  WORDS j, MCZx()
  I = RdRAM(word(j))
  CMDR rg, I
  wrRAM word(j), I

CASE mr.ab
 cmdc mc.ab, j
 rg = Rd6502(word(j))

CASE mr.ax
  cmdc mc.ax, j
  rg = Rd6502(word(j))
CASE mr.ay
  cmdc mc.ay, j
  rg = Rd6502(word(j))
CASE mr.id
  cmdc mc.id, j
  rg = Rd6502(word(j))
CASE mr.im
  rg = nop6502(REG.PC)

CASE mr.ix
  cmdc mc.ix, j
  rg = Rd6502(word(j))
CASE mr.iy
  cmdc mc.iy, j
  rg = Rd6502(word(j))
CASE mr.zp
  rg = RdRAM(MCZp())
CASE mr.zx
  rg = RdRAM(MCZx())
CASE mr.zy
  rg = RdRAM(MCZY())
CASE mw.ab
  cmdc mc.ab, j
  Wr6502 word(j), rg

CASE mw.ax
  cmdc mc.ax, j
  Wr6502 word(j), rg
CASE mw.ay
  cmdc mc.ay, j
  Wr6502 word(j), rg
CASE mw.ix
  cmdc mc.ix, j
  Wr6502 word(j), rg
CASE mw.iy
  cmdc mc.iy, j
  Wr6502 word(j), rg
CASE mw.zp
  wrRAM MCZp(), rg
CASE mw.zx
  wrRAM MCZx(), rg
CASE mw.zy
  wrRAM MCZY(), rg



CASE ELSE
PRINT "error: CmdRg not found(" + HEX$(cmd) + ")": ENDPROG
END SELECT
IF (rg AND byt) <> rg THEN PRINT "Error:byte overflow"; rg: ENDPROG



END SUB

FUNCTION cmdrr (cmd)
CMDR cmd, I
cmdrr = I
END FUNCTION

SUB CODES (I)
COUNTER& = COUNTER& + 1
laststr = I
'PRINT "PC="; HEX$(word(REG.PC) - 1); " A="; HEX$(REG.A); " X="; HEX$(REG.x); " Y="; HEX$(REG.y); " S="; HEX$(REG.S); " P="; HEX$(REG.p);
'PRINT " zf="; HEX$(REG.ZF); " vf="; HEX$(REG.VF); " nf="; HEX$(REG.NF); " ";
'PRINT CYCLE& / (TIMER - ts!);
'PRINT counter&;
'PRINT cycle&;
'PRINT opcode$(I); " "; 'HEX$(I), cycle&
'PRINT
'KK$ = INPUT$(1)

'LINE INPUT #3, f$
'PRINT f$

SELECT CASE I
CASE &HD4'/* CSH set clock highspeed */
CASE &H54'/* CSL set clock lowspeed */

CASE &H44: '/* BSR * REL */
           CMDR m.push, REG.PC.H
           CMDR m.push, REG.PC.L

CASE &H80: '/* BRA * REL */

          'error:convert op6502 to offset
          I = op6502i(REG.PC)


          I = I + (I > 127) * 256
          WORDS REG.PC, word(REG.PC) + I + 1
          'words reg.pc, WORD(reg.pc) + (offset)op6502i(reg.pc) + 1


CASE &H7C: '/* JMP ($ssss,x) */
        M.LDWORD K: WORDS K, word(K) + REG.x
        REG.PC.L = op6502i(K)
        REG.PC.H = op6502(word(K) + 1)
        
CASE &HDA: CMDR m.push, REG.x  '  /* PHX */
CASE &H5A: CMDR m.push, REG.y '               /* PHY */
CASE &HFA: CMDR m.pop, REG.x: CMDR m.fl, REG.x '    /* PLX */
CASE &H7A: CMDR m.pop, REG.y: CMDR m.fl, REG.y'      /* PLY */

CASE &H62: REG.A = 0' /* CLA */
CASE &H82: REG.x = 0' /* CLX */
CASE &HC2: REG.y = 0' /* CLY */

CASE &H2: I = REG.x: REG.x = REG.y: REG.y = I'  /* SXY */
CASE &H22: I = REG.A: REG.A = REG.x: REG.x = I'  /* SAX */
CASE &H42: I = REG.A: REG.A = REG.y: REG.y = I'  /* SAY */

CASE &H3A: CMDR M.DEC, REG.A                  ' /* DEC A */

CASE &H1A: CMDR m.inc, REG.A                  ' /* INC A */


CASE &H72: cmdd mr.id, m.adc                   '/* ADC ($ss) INDIR */
CASE &H32: cmdd mr.id, m.and                   '/* AND ($ss) INDIR */
CASE &HD2: CMDR mr.id, I: M.CMP REG.A, I       '/* CMP ($ss) INDIR */
CASE &H52: cmdd mr.id, m.eor                   '/* EOR ($ss) INDIR */
CASE &HB2: CMDR mr.id, REG.A: CMDR m.fl, REG.A '/* LDA ($ss) INDIR */
CASE &H12: cmdd mr.id, m.ora                   '/* ORA ($ss) INDIR */
CASE &H92: cmdc mc.id, j: Wr6502 word(j), REG.A'/* STA ($ss) INDIR */
CASE &HF2: cmdd mr.id, m.sbc                 '  /* SBC ($ss) INDIR */

CASE &H89: cmdd mr.im, m.bit  '              /* BIT #$ss IMM */
CASE &H34: cmdd mr.zx, m.bit  '              /* BIT $ss,x ZP,x */
CASE &H3C: cmdd mr.ax, m.bit  '              /* BIT $ssss,x ABS,x */

CASE &H64: CMDR mw.zp, &H0            '          /* STZ $ss ZP */
CASE &H74: CMDR mw.zx, &H0            '          /* STZ $ss,x ZP,x */
CASE &H9C: CMDR mw.ab, &H0            '          /* STZ $ssss ABS */
CASE &H9E: CMDR mw.ax, &H0            '          /* STZ $ssss,x ABS,x */

CASE &HF4: ' /* SET */
        I = op6502i(REG.PC)
        IF CMDSET1(I) <> CMDSET1(I) THEN
        CYCLE& = CYCLE& + CYCLES(I) + 3
        cmdd CMDSET1(I), CMDSET2(I)
        ELSE
        CYCLE& = CYCLE& + CYCLES(I)
        PRINT "NO SENCE SET " + HEX$(I): ENDPROG
        END IF


CASE &H3: io_write 0, nop6502(REG.PC)  '/* ST0 */

CASE &H13: io_write 2, nop6502(REG.PC) '/* ST1 */

CASE &H23: io_write 3, nop6502(REG.PC) '/* ST2 */

CASE &H43: '/* TMAi */
        I = nop6502(REG.PC)

          
          FOR II = 0 TO 7

              
              'note: or reg.a is only defined if (i and 1) = 0, no exit for
              '      note:exit after retrieve
              IF (I AND 2 ^ II) THEN EXIT FOR
              
              'i = i \ 2 ^ 1
          NEXT II
          REG.A = REG.MPR(II)
CASE &H53: '/* TAMi */

        I = nop6502(REG.PC)
        IF I AND &H10 THEN

         END IF
         FOR II = 0 TO 7
                'note: or exit if after bankset
                IF I AND 2 ^ II THEN

                
         
                        REG.MPR(II) = REG.A
                        BANK.SET II, REG.A
                'EXIT FOR
                END IF
                'I = I \ 2 ^ 1
         NEXT II

CASE &HC3: ' /* TDD */
        T_INIT SRC&, DIST&, LENGTH&
        DO
        Wr6502 DIST&, Rd6502(SRC&)
        DIST& = DIST& - 1

        SRC& = SRC& - 1
        LENGTH& = LENGTH& - 1
        LOOP WHILE LENGTH&
'        } while(--length);




CASE &H73: ' /* TII */
        T_INIT SRC&, DIST&, LENGTH&
        DO
             Wr6502 DIST&, Rd6502(SRC&)
             DIST& = DIST& + 1
                SRC& = SRC& + 1
        LENGTH& = LENGTH& - 1
        LOOP WHILE LENGTH&
'        } while(--length);


CASE &HE3: ' /* TIA */
        T_INIT SRC&, DIST&, LENGTH&
        DO
                Wr6502 DIST&, Rd6502(SRC&)
                SRC& = SRC& + 1

                IF NOT LENGTH& THEN EXIT DO
                ' if (!(--length)):break
                LENGTH& = LENGTH& - 1
                Wr6502 DIST& + 1, Rd6502(SRC&)
                SRC& = SRC& + 1
'        } while(--length);
        lenght& = LENGTH& - 1
        LOOP WHILE LENGTH&


CASE &HF3: ' /* TAI */

        T_INIT SRC&, DIST&, LENGTH&
        

         'note: why would this command l>2?
         'maybee for io(speed dependent)

         DO
                Wr6502 DIST&, Rd6502(SRC&)
                DIST& = DIST& + 1
                'if (!(--length)) break;
                LENGTH& = LENGTH& - 1
                
               IF LENGTH& = 0 THEN EXIT DO
               Wr6502 DIST&, Rd6502(SRC& + 1)
               DIST& = DIST& + 1

               LENGTH& = LENGTH& - 1
         LOOP WHILE LENGTH&
        '} while(--length);

CASE &HD3: ' /* TIN */
        T_INIT SRC&, DIST&, LENGTH&
        
        DO
                Wr6502 DIST&, Rd6502(SRC&)
                SRC& = SRC& + 1
        LENGTH& = LENGTH& - 1
        LOOP WHILE LENGTH&

CASE &H14: CMDR MM.Zp, TRB '      /* TRB $ss ZP */

CASE &H1C: CMDR MM.Ab, TRB '      /* TRB $ssss ABS */
CASE &H4: CMDR MM.Zp, TSB  '      /* TSB $ss ZP */

CASE &HC: CMDR MM.Ab, TSB  '      /* TSB $ssss ABS */

CASE &H83: '/* TST #$ss,$ss IMM,ZP */
        I = nop6502(REG.PC): j.L = RdRAM(MCZp())
        
'error    NF = VF = J.L
        REG.NF = j.L
        REG.VF = j.L: REG.ZF = I AND j.L

CASE &HA3: '/* TST #$ss,$ss,x IMM,ZP,x */
        I = nop6502(REG.PC): j.L = RdRAM(MCZx())
        

'error REG,NF = REG.VF = J.L
        REG.NF = j.L
        REG.VF = j.L: REG.ZF = I AND j.L
CASE &H93: '/* TST #$ss,$ssss IMM,ABS */
        I = nop6502(REG.PC): CMDR mr.ab, j.L
        
'error
        REG.NF = j.L
         REG.VF = j.L: REG.ZF = I AND j.L

CASE &HB3: '/* TST #$ss,$ssss,x IMM,ABS,x */
        I = nop6502(REG.PC): CMDR mr.ax, j.L
        
'error
        REG.NF = j.L
        REG.VF = j.L: REG.ZF = I AND j.L

CASE IS = (I AND &HF) XOR (I XOR &HF)
IF (RdRAM(MCZp()) AND 2 ^ (I \ 2 ^ 4)) <> 0 AND I < &H80 THEN REGINC REG.PC ELSE M.JR 'BBRI, BBSI

CASE IS = (I AND &H87) XOR (I XOR &H87)
 CMDR M.SMB, 2 ^ (I \ 2 ^ 4)
CASE IS = (I AND &H7) XOR (I XOR &H7)
 CMDR M.RMB, 2 ^ (I \ 2 ^ 4)


CASE &H10: IF (REG.NF AND N.FLAG) THEN REGINC REG.PC ELSE M.JR  '/* BPL * REL */
CASE &H30: IF (REG.NF AND N.FLAG) THEN M.JR ELSE REGINC REG.PC  '/* BMI * REL */
CASE &HD0: IF REG.ZF = 0 THEN REGINC REG.PC ELSE M.JR      '/* BNE * REL */
CASE &HF0: IF REG.ZF = 0 THEN M.JR ELSE REGINC REG.PC     '/* BEQ * REL */
CASE &H90: IF (REG.p AND c.flag) THEN REGINC REG.PC ELSE M.JR '/* BCC * REL */
CASE &HB0: IF (REG.p AND c.flag) THEN M.JR ELSE REGINC REG.PC '/* BCS * REL */
CASE &H50: IF (REG.VF AND V.FLAG) THEN REGINC REG.PC ELSE M.JR'/* BVC * REL */
CASE &H70: IF (REG.VF AND V.FLAG) THEN M.JR ELSE REGINC REG.PC '/* BVS * REL */


CASE &H40: '/* RTI */

  I = REG.p


  CMDR m.pop.p, REG.p

  IF ((REG.IRequest <> INT.NONE) AND (I AND I.FLAG) <> 0 AND NOT (REG.p AND I.FLAG) <> 0) THEN
     REGAfterCLI = 1
    REG.IBackup = REG.ICount
    REG.ICount = 0
    END IF
    CMDR m.pop, REG.PC.L
    CMDR m.pop, REG.PC.H



CASE &H60: '/* RTS */
  K = REG.PC
  CMDR m.pop, REG.PC.L: CMDR m.pop, REG.PC.H: REGINC REG.PC
  JS = JS - 1
  REGINC JUMPSTA(JS)
  JSS = JSS + 1
  IF (JUMPSTA(JS).L <> REG.PC.L) OR (REG.PC.H <> JUMPSTA(JS).H) THEN
  TT! = TIMER - TS!

  PRINT CYCLE& / TT!
  PRINT COUNTER& / TT!
  PRINT "RTS #        " + HEX$(JSS)
  PRINT "RTS STACK    " + HEX$(JS)
  PRINT "S= " + HEX$(REG.S); ":" + HEX$(JUMPSTAA(JS) + 2)
  PRINT "ERROR in RTS " + HEX$(word(K) - 1)
  PRINT "RETURNING TO " + HEX$(word(REG.PC))
  PRINT "SHOULD GOTO  " + HEX$(word(JUMPSTA(JS)))
  'REG.PC = JUMPSTA(JS)
  JUMPSTA(JS).L = 0
  JUMPSTA(JS).H = 0
  KK$ = INPUT$(1)
  
  END IF

  

CASE &H20: '/* JSR $ssss ABS */
  K.L = nop6502(REG.PC)
  K.H = op6502i(REG.PC)

  CMDR m.push, REG.PC.H
  CMDR m.push, REG.PC.L
  JUMPSTA(JS) = REG.PC
  JUMPSTAA(JS) = REG.S

  IF JSS >= &H23 THEN
  PRINT HEX$(word(REG.PC))

  END IF



  JS = JS + 1
  REG.PC = K

CASE &H4C: M.LDWORD K: REG.PC = K'/* JMP $ssss ABS */


CASE &H6C: '/* JMP ($ssss) ABDINDIR */
  M.LDWORD K
  REG.PC.L = nop6502(K)
  
  REG.PC.H = op6502i(K)



CASE &H0: '/* BRK */
  REGINC REG.PC
  CMDR m.push, REG.PC.H: CMDR m.push, REG.PC.L
  CMDR m.push.p, REG.p AND notb(T.FLAG) OR (b.flag)
  REG.p = (REG.p OR I.FLAG) AND notb(d.flag)
  K = REG.PC
  REG.PC.L = op6502(VEC.BRK)
  REG.PC.H = op6502(VEC.BRK + 1)


  PRINT ERR, "BRK instruction " + HEX$(word(K) - 1)
  ENDPROG



CASE &H58: '/* CLI */
  IF ((REG.IRequest <> INT.NONE) AND (REG.p AND I.FLAG) <> 0) THEN
  
    REG.AfterCLI = 1
    REG.IBackup = REG.ICount
    REG.ICount = 0

  END IF
  REG.p = REG.p AND notb(I.FLAG)



CASE &H28: '/* PLP */
  CMDR m.pop.p, I

  IF ((REG.IRequest <> INT.NONE) AND ((I XOR REG.p) AND notb(I) AND I.FLAG) <> 0) THEN

    REG.AfterCLI = 1
    REG.IBackup = REG.ICount
    REG.ICount = 0

  END IF
  REG.p = I



CASE &H8: CMDR m.push.p, REG.p AND notb(T.FLAG) OR b.flag'     /* PHP */
CASE &H18: REG.p = REG.p AND cn.flag          '     /* CLC */
CASE &HB8: REG.VF = 0                              '     /* CLV */
CASE &HD8: REG.p = REG.p AND notb(d.flag)          '     /* CLD */
CASE &H38: REG.p = REG.p OR c.flag                 '     /* SEC */
CASE &HF8: REG.p = REG.p OR d.flag                 '     /* SED */
CASE &H78: REG.p = REG.p OR I.FLAG                 '     /* SEI */
CASE &H48: CMDR m.push, REG.A          '             /* PHA */
CASE &H68: CMDR m.pop, REG.A: CMDR m.fl, REG.A       '     /* PLA */
CASE &H98: REG.A = REG.y: CMDR m.fl, REG.A     '     /* TYA */

'can i use cmdr m.inc, reg.y ?
CASE &HA8: REG.y = REG.A: CMDR m.fl, REG.y     '     /* TAY */
CASE &HC8: REG.y = REG.y + 1: CMDR m.fl, REG.y '     /* INY */
CASE &H88: REG.y = REG.y - 1: CMDR m.fl, REG.y '     /* DEY */
CASE &H8A: REG.A = REG.x: CMDR m.fl, REG.A     '     /* TXA */
CASE &HAA: REG.x = REG.A: CMDR m.fl, REG.x     '     /* TAX */
CASE &HE8: REG.x = REG.x + 1: CMDR m.fl, REG.x '     /* INX */
CASE &HCA: REG.x = REG.x - 1: CMDR m.fl, REG.x '     /* DEX */
CASE &HEA:  '                                  /* NOP */
CASE &H9A: REG.S = REG.x                 '     /* TXS */
CASE &HBA: REG.x = REG.S: CMDR m.fl, REG.x     '     /* TSX */
CASE &H24: cmdd mr.zp, m.bit            '  /* BIT $ss ZP */
CASE &H2C: cmdd mr.ab, m.bit            '  /* BIT $ssss ABS */

CASE &H5: cmdd mr.zp, m.ora             '  /* ORA $ss ZP */
CASE &H6: CMDR MM.Zp, m.asl                 '  /* ASL $ss ZP */
CASE &H25: cmdd mr.zp, m.and            '  /* AND $ss ZP */
CASE &H26: CMDR MM.Zp, M.ROL                '  /* ROL $ss ZP */
CASE &H45: cmdd mr.zp, m.eor            '  /* EOR $ss ZP */
CASE &H46: CMDR MM.Zp, M.LSR                '  /* LSR $ss ZP */
CASE &H65: cmdd mr.zp, m.adc          '  /* ADC $ss ZP */
CASE &H66: CMDR MM.Zp, M.ROR                '  /* ROR $ss ZP */
CASE &H84: CMDR mw.zp, REG.y                 '  /* STY $ss ZP */
CASE &H85: CMDR mw.zp, REG.A                 '  /* STA $ss ZP */
CASE &H86: CMDR mw.zp, REG.x                 '  /* STX $ss ZP */
CASE &HA4: CMDR mr.zp, REG.y: CMDR m.fl, REG.y    '  /* LDY $ss ZP */
CASE &HA5: CMDR mr.zp, REG.A: CMDR m.fl, REG.A    '  /* LDA $ss ZP */
'/BaH
'/case &HA5: R.A = RAM[ (Op6502(R.PC.W++)) ]  ;break;
'/CAUTION ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
CASE &HA6: CMDR mr.zp, REG.x: CMDR m.fl, REG.x     '  /* LDX $ss ZP */
CASE &HC4: CMDR mr.zp, I: M.CMP REG.y, I     '  /* CPY $ss ZP */
CASE &HC5: CMDR mr.zp, I: M.CMP REG.A, I     '  /* CMP $ss ZP */
CASE &HC6: CMDR MM.Zp, M.DEC                '  /* DEC $ss ZP */
CASE &HE4: CMDR mr.zp, I: M.CMP REG.x, I    '  /* CPX $ss ZP */
CASE &HE5: cmdd mr.zp, m.sbc            '  /* SBC $ss ZP */
CASE &HE6: CMDR MM.Zp, m.inc                '  /* INC $ss ZP */
CASE &HD: cmdd mr.ab, m.ora             '  /* ORA $ssss ABS */
CASE &HE: CMDR MM.Ab, m.asl                 '  /* ASL $ssss ABS */
CASE &H2D: cmdd mr.ab, m.and            '  /* AND $ssss ABS */
CASE &H2E: CMDR MM.Ab, M.ROL                '  /* ROL $ssss ABS */

CASE &H4D: cmdd mr.ab, m.eor            '  /* EOR $ssss ABS */
CASE &H4E: CMDR MM.Ab, M.LSR                '  /* LSR $ssss ABS */

CASE &H6D: cmdd mr.ab, m.adc            '  /* ADC $ssss ABS */
CASE &H6E: CMDR MM.Ab, M.ROR                '  /* ROR $ssss ABS */

CASE &H8C: CMDR mw.ab, REG.y                 '  /* STY $ssss ABS */
CASE &H8D: CMDR mw.ab, REG.A                '  /* STA $ssss ABS */
CASE &H8E: CMDR mw.ab, REG.x                '  /* STX $ssss ABS */
CASE &HAC: CMDR mr.ab, REG.y: CMDR m.fl, REG.y     '  /* LDY $ssss ABS */
CASE &HAD: CMDR mr.ab, REG.A: CMDR m.fl, REG.A    '  /* LDA $ssss ABS */
CASE &HAE: CMDR mr.ab, REG.x: CMDR m.fl, REG.x     '  /* LDX $ssss ABS */
CASE &HCC: CMDR mr.ab, I: M.CMP REG.y, I     '  /* CPY $ssss ABS */
CASE &HCD: CMDR mr.ab, I: M.CMP REG.A, I     '  /* CMP $ssss ABS */
CASE &HCE: CMDR MM.Ab, M.DEC               '  /* DEC $ssss ABS */

CASE &HEC: CMDR mr.ab, I: M.CMP REG.x, I    '  /* CPX $ssss ABS */
CASE &HED: cmdd mr.ab, m.sbc            '  /* SBC $ssss ABS */
CASE &HEE: CMDR MM.Ab, m.inc                '  /* INC $ssss ABS */

CASE &H9: cmdd mr.im, m.ora             '  /* ORA #$ss IMM */
CASE &H29: cmdd mr.im, m.and            '  /* AND #$ss IMM */
CASE &H49: cmdd mr.im, m.eor            '  /* EOR #$ss IMM */
CASE &H69: cmdd mr.im, m.adc            '  /* ADC #$ss IMM */
CASE &HA0: CMDR mr.im, REG.y: CMDR m.fl, REG.y     '  /* LDY #$ss IMM */
CASE &HA2: CMDR mr.im, REG.x: CMDR m.fl, REG.x     '  /* LDX #$ss IMM */
CASE &HA9: CMDR mr.im, REG.A: CMDR m.fl, REG.A     '  /* LDA #$ss IMM */
CASE &HC0: CMDR mr.im, I: M.CMP REG.y, I     '  /* CPY #$ss IMM */
CASE &HC9: CMDR mr.im, I: M.CMP REG.A, I     '  /* CMP #$ss IMM */
CASE &HE0: CMDR mr.im, I: M.CMP REG.x, I    '  /* CPX #$ss IMM */

CASE &HE9: cmdd mr.im, m.sbc            '  /* SBC #$ss IMM */

CASE &H15: cmdd mr.zx, m.ora           '  /* ORA $ss,x ZP,x */
CASE &H16: CMDR mm.zx, m.asl                '  /* ASL $ss,x ZP,x */
CASE &H35: cmdd mr.zx, m.and            '  /* AND $ss,x ZP,x */
CASE &H36: CMDR mm.zx, M.ROL                '  /* ROL $ss,x ZP,x */
CASE &H55: cmdd mr.zx, m.eor          '  /* EOR $ss,x ZP,x */
CASE &H56: CMDR mm.zx, M.LSR                '  /* LSR $ss,x ZP,x */
CASE &H75: cmdd mr.zx, m.adc            '  /* ADC $ss,x ZP,x */
CASE &H76: CMDR mm.zx, M.ROR                '  /* ROR $ss,x ZP,x */
CASE &H94: CMDR mw.zx, REG.y                 '  /* STY $ss,x ZP,x */
CASE &H95: CMDR mw.zx, REG.A                 '  /* STA $ss,x ZP,x */
CASE &H96: CMDR mw.zy, REG.x                 '  /* STX $ss,y ZP,y */
CASE &HB4: CMDR mr.zx, REG.y: CMDR m.fl, REG.y     '  /* LDY $ss,x ZP,x */
CASE &HB5: CMDR mr.zx, REG.A: CMDR m.fl, REG.A     '  /* LDA $ss,x ZP,x */
CASE &HB6: CMDR mr.zy, REG.x: CMDR m.fl, REG.x     '  /* LDX $ss,y ZP,y */
CASE &HD5: CMDR mr.zx, I: M.CMP REG.A, I     '  /* CMP $ss,x ZP,x */
CASE &HD6: CMDR mm.zx, M.DEC                '  /* DEC $ss,x ZP,x */
CASE &HF5: cmdd mr.zx, m.sbc          '  /* SBC $ss,x ZP,x */
CASE &HF6: CMDR mm.zx, m.inc                '  /* INC $ss,x ZP,x */
CASE &H19: cmdd mr.ay, m.ora            '  /* ORA $ssss,y ABS,y */
CASE &H1D: cmdd mr.ax, m.ora            '  /* ORA $ssss,x ABS,x */
CASE &H1E: CMDR mm.ax, m.asl                '  /* ASL $ssss,x ABS,x */
CASE &H39: cmdd mr.ay, m.and            '  /* AND $ssss,y ABS,y */
CASE &H3D: cmdd mr.ax, m.and            '  /* AND $ssss,x ABS,x */
CASE &H3E: CMDR mm.ax, M.ROL                '  /* ROL $ssss,x ABS,x */
CASE &H59: cmdd mr.ay, m.eor            '  /* EOR $ssss,y ABS,y */
CASE &H5D: cmdd mr.ax, m.eor            '  /* EOR $ssss,x ABS,x */
CASE &H5E: CMDR mm.ax, M.LSR                '  /* LSR $ssss,x ABS,x */
CASE &H79: cmdd mr.ay, m.adc            '  /* ADC $ssss,y ABS,y */
CASE &H7D: cmdd mr.ax, m.adc            '  /* ADC $ssss,x ABS,x */
CASE &H7E: CMDR mm.ax, M.ROR                '  /* ROR $ssss,x ABS,x */
CASE &H99: CMDR mw.ay, REG.A                 '  /* STA $ssss,y ABS,y */
CASE &H9D: CMDR mw.ax, REG.A                 '  /* STA $ssss,x ABS,x */
CASE &HB9: CMDR mr.ay, REG.A: CMDR m.fl, REG.A     '  /* LDA $ssss,y ABS,y */
CASE &HBC: CMDR mr.ax, REG.y: CMDR m.fl, REG.y     '  /* LDY $ssss,x ABS,x */
CASE &HBD: CMDR mr.ax, REG.A: CMDR m.fl, REG.A     '  /* LDA $ssss,x ABS,x */
CASE &HBE: CMDR mr.ay, REG.x: CMDR m.fl, REG.x     '  /* LDX $ssss,y ABS,y */
CASE &HD9: CMDR mr.ay, I: M.CMP REG.A, I     '  /* CMP $ssss,y ABS,y */
CASE &HDD: CMDR mr.ax, I: M.CMP REG.A, I     '  /* CMP $ssss,x ABS,x */
CASE &HDE: CMDR mm.ax, M.DEC                '  /* DEC $ssss,x ABS,x */
CASE &HF9: cmdd mr.ay, m.sbc            '  /* SBC $ssss,y ABS,y */
CASE &HFD: cmdd mr.ax, m.sbc            '  /* SBC $ssss,x ABS,x */
CASE &HFE: CMDR mm.ax, m.inc                '  /* INC $ssss,x ABS,x */
CASE &H1: cmdd mr.ix, m.ora             '  /* ORA ($ss,x) INDEXINDIR */
CASE &H11: cmdd mr.iy, m.ora            '  /* ORA ($ss),y INDIRINDEX */
CASE &H21: cmdd mr.ix, m.and            '  /* AND ($ss,x) INDEXINDIR */
CASE &H31: cmdd mr.iy, m.and            '  /* AND ($ss),y INDIRINDEX */
CASE &H41: cmdd mr.ix, m.eor            '  /* EOR ($ss,x) INDEXINDIR */
CASE &H51: cmdd mr.iy, m.eor            '  /* EOR ($ss),y INDIRINDEX */
CASE &H61: cmdd mr.ix, m.adc            '  /* ADC ($ss,x) INDEXINDIR */
CASE &H71: cmdd mr.iy, m.adc            '  /* ADC ($ss),y INDIRINDEX */
CASE &H81: CMDR mw.ix, REG.A                 '  /* STA ($ss,x) INDEXINDIR */
CASE &H91: CMDR mw.iy, REG.A                 '  /* STA ($ss),y INDIRINDEX */
CASE &HA1: CMDR mr.ix, REG.A: CMDR m.fl, REG.A     '  /* LDA ($ss,x) INDEXINDIR */
CASE &HB1: CMDR mr.iy, REG.A: CMDR m.fl, REG.A     '  /* LDA ($ss),y INDIRINDEX */
CASE &HC1: CMDR mr.ix, I: M.CMP REG.A, I     '  /* CMP ($ss,x) INDEXINDIR */
CASE &HD1: CMDR mr.iy, I: M.CMP REG.A, I     '  /* CMP ($ss),y INDIRINDEX */
CASE &HE1: cmdd mr.ix, m.sbc            '  /* SBC ($ss,x) INDEXINDIR */
CASE &HF1: cmdd mr.iy, m.sbc            '  /* SBC ($ss),y INDIRINDEX */
CASE &HA: CMDR m.asl, REG.A                 '  /* ASL a ACC */
CASE &H2A: CMDR M.ROL, REG.A                '  /* ROL a ACC */
CASE &H4A: CMDR M.LSR, REG.A                '  /* LSR a ACC */
CASE &H6A: CMDR M.ROR, REG.A                '  /* ROR a ACC */

CASE ELSE
PRINT
PRINT "ERROR:"; HEX$(word(REG.PC) - 1), HEX$(I): ENDPROG
'default:
'  if(_TrapBadOps) {
'    fprintf
'    ( stderr,
'      "[M6502 %lX] Unrecognized instruction: $%02X at PC=$%04X\n",
'      (unsigned)_User,Op6502(REG.PC.W-1),(word)(REG.PC.W-1)
'    );
'
'    _Trace=1;
'
'  }
'
'  break;
END SELECT

'PRINT
'kk$ = INPUT$(1)

END SUB

SUB ENDPROG ()
VMMEND
END
END SUB

FUNCTION io_read (A&)
'PRINT "io_read "; HEX$(a&); ': END
EXIT FUNCTION
'byte IO_read(word A)
'byte ret

  SELECT CASE A& AND &H1C00
  CASE &H0:    '/* VDC */
    SELECT CASE A& AND 3
    CASE 0:
        ret = io.vdc_status
        io.vdc_status = 0';//&=VDC_InVBlank;//&=~VDC_BSY;
        io_read = ret: EXIT FUNCTION
    CASE 1:
        io_read = 0: EXIT FUNCTION
    CASE 2:
        IF (io.vdc_reg = VRR) THEN
            io_read = vramg(word(io.VDC(MARR)) * 2): EXIT FUNCTION

        ELSE
        io_read = io.VDC(io.vdc_reg).L: EXIT FUNCTION
        END IF
    CASE 3:
        IF (io.vdc_reg = VRR) THEN
            ret = vramg(word(io.VDC(MARR)) * 2 + 1)
            WORDS io.VDC(MARR), word(io.VDC(MARR)) + io.vdc_inc
            io_read = ret: EXIT FUNCTION
        ELSE
        io_read = io.VDC(io.vdc_reg).H: EXIT FUNCTION
        END IF
    END SELECT
    

  CASE &H400: '/* VCE */
    SELECT CASE A& AND 7
    CASE 4: io_read = io.VCE(word(io.vce_reg)).L: EXIT FUNCTION
    CASE 5: io_read = io.VCE(word(io.vce_reg)).H: WORDS io.vce_reg, word(io.vce_reg) + 1: EXIT FUNCTION
    END SELECT
    
'#ifndef FINAL_RELEASE
'  case 0x0800:  /* PSG */
'    switch(A&15){
'    case 0: return io.psg_ch;
'    case 1: return io.psg_volume;
'    case 2: return io.PSG[io.psg_ch][2];
'    case 3: return io.PSG[io.psg_ch][3];
'    case 4: return io.PSG[io.psg_ch][4];
'    case 5: return io.PSG[io.psg_ch][5];
'    CASE 6:
'        {
'            //int   ofs=io.wavofs[io.psg_ch];
'            //io.wavofs[io.psg_ch]=(io.wavofs[io.psg_ch]+1)&31;
'            //return io.wave[io.psg_ch][ofs];
'            int ofs=fixtoi(snd_pos[io.psg_ch]);
'            snd_pos[io.psg_ch]=itofix((fixtoi(snd_pos[io.psg_ch])+1)&31);
'            return io.wave[io.psg_ch][ofs];
'
'        }
'    case 7: return io.PSG[io.psg_ch][7];
'    case 8: return io.psg_lfo_freq;
'    case 9: return io.psg_lfo_ctrl;
'    default: return NODATA;
'    }
'    break;
'#endif
  CASE &HC00:  ' /* timer */
    io_read = io.timer_counter: EXIT FUNCTION

  CASE &H1000:  '/* joypad */

  
  ret = io.JOY(io.joy_counter) XOR &HFF
        IF io.joy_select AND 1 THEN
        ret = ret \ 2 ^ 4
        ELSE
        ret = ret AND 15: io.joy_counter = (io.joy_counter + 1) MOD 5
        END IF
        io_read = ret OR Country: EXIT FUNCTION'; /* country 0:JPN 1=US */


  CASE &H1400: ' /* IRQ */
    SELECT CASE A& AND 15
    CASE 2: io_read = io.irq_mask: EXIT FUNCTION
    CASE 3: ret = io.irq_status: io.irq_status = 0: io_read = ret: EXIT FUNCTION
    END SELECT
    

  CASE &H1800: ' /* CD-ROM extention */
    SELECT CASE A& AND 15
    CASE 3: io.backup = DISABLE: io_read = DISABLE: EXIT FUNCTION'return io.backup = disable
'//  case 0xa:
'//      if (!io.adpcm_firstread) return PCM[io.adpcm_rptr++];
'//      else {io.adpcm_firstread=FALSE; return NODATA;}
    END SELECT
    
    
  END SELECT
    io_read = NODATA


END FUNCTION

SUB io_write (A AS LONG, V)
'PRINT "io_write "; HEX$(a);
EXIT SUB

'A,v
  SELECT CASE A AND &H1C00
  CASE &H0:     '/* VDC */
        SELECT CASE A AND 3
        CASE 0: io.vdc_reg = V AND 31: EXIT SUB:
        CASE 1: EXIT SUB:
        END SELECT
    CASE 2:
       
        SELECT CASE io.vdc_reg
        CASE VWR:
                 
                  
        CASE hdr:
'                        io.screen_w = (V + 1) * 8:
                        
                        

        CASE MWR:
'                        'static byte bgw[]={32,64,128,128}:
'                        'io.bg_h=(V AND &h40)?64:32:
'                        'io.bg_w=bgw[(V>>4) AND 3]:}
'
'
'
        CASE BYR:
            IF scroll = 0 THEN
                                oldScrollX = ScrollX:
                                oldScrollY = ScrollY:
                                oldScrollYDiff = ScrollYDiff:
            END IF
                        io.VDC(BYR).L = V:
                        scroll = 1:
                                ScrollYDiff = scanline - 1:
                        EXIT SUB:
        CASE BXR:
            IF scroll = 0 THEN
                                oldScrollX = ScrollX:
                                oldScrollY = ScrollY:
                                oldScrollYDiff = ScrollYDiff:
            END IF
                        io.VDC(BXR).L = V:
                        scroll = 1:
                        EXIT SUB:


        END SELECT
                io.VDC(io.vdc_reg).L = V:
                EXIT SUB:
    CASE 3:

        SELECT CASE io.vdc_reg
        CASE VWR:
                 
                        VRAMp word(io.VDC(MAWR)) * 2, io.VDC_ratch:
                        VRAMp word(io.VDC(MAWR)) * 2 + 1, V
                        'vchanges(io.VDC(MAWR).W / 64) = 1:
                        'io.VDC[MAWR].W+=io.vdc_inc:
                        io.VDC_ratch = 0:
                        EXIT SUB:
        CASE VDW:
                        
                        io.VDC(VDW).H = V:
                        'io.screen_h = (io.VDC(VDW).W AND 511) + 1:
                        'MaxLine = io.screen_h - 1:
                        
                        EXIT SUB:
        CASE LENR:
                        
                        io.VDC(LENR).H = V:
                        
            '/* VRAM to VRAM DMA */
            'memcpy(VRAM+io.VDC[DISTR].W*2,VRAM+io.VDC[SOUR].W*2,
            '                    (io.VDC[LENR].W+1)*2):
            '            memset(vchange+io.VDC[DISTR].W/16,1,(io.VDC[LENR].W+1)/16):
            '            memset(vchange+io.VDC[DISTR].W/64,1,(io.VDC[LENR].W+1)/64):
'                        io.VDC[DISTR].W += io.VDC[LENR].W+1:
'                        io.VDC[SOUR].W += io.VDC[LENR].W+1:
'                        io.vdc_status|=VDC_DMAfinish:
'                        EXIT SUB:
        CASE CR:
'                        static byte incsize[]={1,32,64,128}:
'                        io.vdc_inc = incsize[(V>>3) AND 3]:
                        
            

        CASE hdr:
            
            
                        
        CASE BYR:
'            IF (scroll = 0) THEN
'                                oldScrollX = ScrollX:
'                                oldScrollY = ScrollY:
'                                oldScrollYDiff = ScrollYDiff:
'            END IF
'                        io.VDC(BYR).B.h = V AND 1:
'                        scroll = 1:
'                                ScrollYDiff = scanline - 1:
'
                        EXIT SUB:
        CASE SATB:
'                        io.VDC(SATB).B.h = V:
'
'
'                        io.vdc_satb = 1:
'                        io.vdc_status AND =~VDC_SATBfinish:
'                        EXIT SUB:
        CASE BXR:
'            IF (scroll = 0) THEN
'                                oldScrollX = ScrollX:
'                                oldScrollY = ScrollY:
'                                oldScrollYDiff = ScrollYDiff:
'            END IF
 '                       io.VDC(BXR).B.h = V AND 3:
'                        scroll = 1:
'                        EXIT SUB:


  '      END SELECT
                
'                io.VDC(io.vdc_reg).B.h = V:
'                EXIT SUB:
    END SELECT


  CASE &H400:   '/* VCE */
        SELECT CASE (A AND 7)
        CASE 0:
                
        CASE 2: io.vce_reg.L = V: EXIT SUB:
        CASE 3: io.vce_reg.H = V AND 1: EXIT SUB:
        CASE 4: io.VCE(word(io.vce_reg)).L = V:
'
'                 byte c: int i,n:
                 N = word(io.vce_reg)
                 c = word(io.VCE(N)) \ 2 ^ 1
         IF N = 0 THEN
                FOR II = O TO 255 STEP 16: Pal(II) = c: NEXT II
'                        for(i=0:i<256:i+=16) Pal[i]=c:
         ELSE IF (N AND 15) THEN Pal(N) = c:
        END IF


                EXIT SUB:
    CASE 5:
                io.VCE(word(io.vce_reg)).H = V:
        
'                 byte c: int i,n:
                 N = word(io.vce_reg)
                 c = word(io.VCE(N)) \ 2 ^ 1
        IF N = 0 THEN
        FOR II = 0 TO 255 STEP 16: Pal(II) = c: NEXT II
'                        'for(i=0:i<256:i+=16) Pal[i]=c:
             ELSE IF (N AND 15) THEN Pal(N) = c:
        END IF
                WORDS io.vce_reg, (word(io.vce_reg) + 1) AND &H1FF:
                EXIT SUB

        CASE 1:
        CASE 6:
        CASE 7:
    END SELECT
 


  CASE &HC00:   '/* timer */
        
        SELECT CASE A AND 1
        CASE 0: io.timer_reload = V AND 127: EXIT SUB:
    CASE 1:
'                V AND =1:
'                if (V  AND  AND  !io.timer_start)
'                        io.timer_counter = io.timer_reload:
'                io.timer_start = V:
'                EXIT SUB:
    END SELECT
        

  CASE &H1000: ' /* joypad */

'                io.joy_select = V AND 1:
'                if (V AND 2) io.joy_counter = 0:
'                EXIT SUB:

  CASE &H1400:  '/* IRQ */
        SELECT CASE A AND 15
        'CASE 2: io.irq_mask = V:
        'case 3: io.irq_status= (io.irq_status AND ~TIRQ)|(V AND &hF8): exit sub:
    END SELECT
        

  CASE &H1800: ' /* CD-ROM extention */
        SELECT CASE A AND 15
'        CASE 7: io.backup = ENABLE: EXIT SUB:
'
'        CASE 9: io.adpcm_ptr.B.h = V: EXIT SUB:
        'case &ha: PCM[io.adpcm_wptr++] = V: exit sub:
        CASE &HD:
'                if (V AND 4) io.adpcm_wptr = io.adpcm_ptr.W:
'                else { io.adpcm_rptr = io.adpcm_ptr.W: io.adpcm_firstread = TRUE: }
                EXIT SUB:
'*/
   END SELECT
        
  END SELECT


END SUB

SUB loadpce (f%)

    fs& = LOF(f%)
    hdr& = fs& AND &H1FFF
    fsize& = fs& AND NOT (&H1FFF)

    ROM& = allocvmm&(fs&)


    'popram& = allocvmm&(&H10000) 'byte
    ram& = allocvmm&(32768)      'byte
    Vram& = allocvmm&(&H10000)   'byte
    ioarea& = allocvmm&(&H2000)  'byte


    DO UNTIL adr& > fs&     'load rom
    d$ = INPUT$(32767, f%)
    WRVMM ROM& + adr&, d$
    d$ = ""
    adr& = adr& + 32767
    LOOP

    lockvmm ROM&, ram& - 1
    ROM& = ROM& + hdr&


    ROM.SIZE = fsize& \ &H2000
    rommask = 1
    

WHILE (rommask < ROM.SIZE)
    rommask = rommask * 2 ^ 1
    WEND
    rommask = rommask - 1
    

    FOR I = 0 TO &HF7

    
        IF (ROM.SIZE = &H30) THEN
        
            SELECT CASE (I AND &H70)
            
            
            
            CASE &H50, &H10, &H0:
                

            
            ROMMAP&(I) = ROM& + (I AND rommask) * 8192&
            
            CASE &H60, &H20:
                
                 

                 ROMMAP&(I) = ROM& + ((I - &H20) AND rommask) * 8192&
            
            CASE &H70, &H30:

                ROMMAP&(I) = ROM& + ((I - &H10) AND rommask) * 8192&
                
            CASE &H40:
                'rommap&(I) = rom& + ((I - &H20) AND rommask) * 8192&

            
            ROMMAP&(I) = ROM& + ((I - &H20) AND rommask) * 8192&
            END SELECT
        
        ELSE


     ROMMAP&(I) = ROM& + (I AND rommask) * 8192&'* &H2000
    'rommap&(i) = rom& + (i AND rommask) * &H2000
       END IF
    NEXT I


    ROMMAP&(&HF8) = ram&
    ROMMAP&(&HF9) = ram& + &H2000
    ROMMAP&(&HFA) = ram& + &H4000
    ROMMAP&(&HFB) = ram& + &H6000
    ROMMAP&(&HFF) = ioarea&' //NULL; /* NULL = I/O area */









END SUB

SUB M.CMP (rg1, rg2)

  


  WORDS K, rg1 - rg2
  


  

  IF K.H THEN REG.p = REG.p AND cn.flag ELSE REG.p = REG.p OR c.flag
  

  'ZF = NF = K.L
  REG.ZF = K.L
  REG.NF = K.L

END SUB

SUB M.JR ()

'get code please
'op6502i is offset
I = op6502i(REG.PC)
I = I + (I > 127) * 256
WORDS REG.PC, word(REG.PC) + I + 1
CYCLE& = CYCLE& + 2
END SUB

SUB M.LDWORD (rg AS PCC)
A& = word(REG.PC)
rg.L = op6502(A&)
rg.H = op6502(A& + 1)
WORDS REG.PC, A& + 2
END SUB

FUNCTION MCZp ()
MCZp = nop6502(REG.PC) + zp


END FUNCTION

FUNCTION MCZx ()
'error:op6502 isn't byte
MCZx = nop6502(REG.PC) + REG.x + zp

END FUNCTION

FUNCTION MCZY ()
'op6502 isn't byte
MCZY = nop6502(REG.PC) + REG.y + zp
END FUNCTION

FUNCTION nop6502 (rg AS PCC)
a1& = word(rg)
A& = a1&

p = A& \ 2 ^ 13
A& = page&(p) + A&

A& = rdvmmb(A&)
'PRINT HEX$(a&); " ";
nop6502 = A&
A& = a1&
A& = A& + 1
WORDS rg, A&
END FUNCTION

FUNCTION notb (A%)
notb = NOT (A%) AND &HFF
END FUNCTION

FUNCTION op6502 (a1&)
A& = a1&
IF A& < 0 THEN A& = 65536 + A&
'page = a& \ 2 ^ 13
p = A& \ 2 ^ 13
A& = page&(p) + A&

'IF a& >= 16384 AND a& < 20480 THEN a& = a& - 16384
'IF a& >= 24576 AND a& < 28672 THEN a& = a& - 24576
'IF a& >= 32768 AND a& < 36864 THEN a& = a& - 32768
'IF a& >= 40960 AND a& < 45056 THEN a& = a& - 40960
'IF a& >= 49152 AND a& < 53284 THEN a& = a& - 49152
'IF a& >= 57344 AND a& < 61440 THEN a& = a& - 57344
'IF a& < 24576 AND a& >= 20480 THEN a& = a& - 16384
'IF a& < 32768 AND a& >= 28672 THEN a& = a& - 24576
'IF a& < 40960 AND a& >= 36864 THEN a& = a& - 32768
'IF a& < 49152 AND a& >= 45056 THEN a& = a& - 40960
'IF a& < 57344 AND a& >= 53284 THEN a& = a& - 49152
'IF a& < 65536 AND a& >= 61440 THEN a& = a& - 57344

A& = rdvmmb(A&)
'PRINT HEX$(a&); " ";
op6502 = A&


END FUNCTION

FUNCTION op6502i (rg AS PCC)
A& = word(rg)
op6502i = op6502(A&)
END FUNCTION

FUNCTION OP6502W& (A&)
'error h,l order?

a1% = op6502(A&)'l
a2% = op6502(A& + 1)'h
OP6502W& = a1% + a2% * 2 ^ 8

'OP6502W = CVI(CHR$(A1%) + CHR$(a2%))
'word& = CVL(CHR$(RG.l) + CHR$(RG.h) + MKI$(0))

END FUNCTION

FUNCTION Rd6502 (A&)
'PRINT "Rd6502("; HEX$(A&); ")";
p = A& \ 2 ^ 13
IF page&(p) <> ioarea& THEN
adr& = page&(p) + A&
Rd6502 = rdvmmb(adr&)
ELSE
Rd6502 = io_read(A&)
END IF



END FUNCTION

FUNCTION RdRAM% (A&)
RdRAM% = rdvmmb(ram& + A&)
END FUNCTION

SUB REGINC (rg AS PCC)
A& = word(rg) + 1
WORDS rg, A&

END SUB

SUB RESET6502 ()
  REG.MPR(7) = &H0: BANK.SET 7, &H0

   REG.MPR(6) = &H5: BANK.SET 6, &H5

   REG.MPR(5) = &H4: BANK.SET 5, &H4

   REG.MPR(4) = &H3: BANK.SET 4, &H3

   REG.MPR(3) = &H2: BANK.SET 3, &H2

   REG.MPR(2) = &H1: BANK.SET 2, &H1

   REG.MPR(1) = &HF8: BANK.SET 1, &HF8   'ram

   REG.MPR(0) = &HFF: BANK.SET 0, &HFF   'io area
  REG.A = 0: REG.x = 0: REG.y = 0
  REG.p = I.FLAG

  REG.NF = 0: REG.VF = 0

  REG.ZF = &HFF
  REG.S = &HFF

  REG.PC.L = op6502(VEC.RESET)
  REG.PC.H = op6502(VEC.RESET + 1)

  ta.L = op6502(vec.timer)
  ta.H = op6502(vec.timer + 1)


REG.ICount = REG.IPeriod
  REG.IRequest = INT.NONE
  REG.AfterCLI = 0
  '//_CycleCount=0;
  '(int)(R->User)=0;
  REG.USER = 0
END SUB

SUB RUN6502 ()
instr.init
DIM A AS regg
RESET6502

A = REG
A.PC = ta


TS! = TIMER - .01
DO

I = nop6502(REG.PC)
CYCLE& = CYCLE& + CYCLES(I)
CODES I


'SWAP a, reg: SWAP c&, cycle&  'needed to execute timer irq




LOOP
END SUB

SUB T_INIT (SRC&, DIST&, LENGTH&)
A& = word(REG.PC)
SRC& = OP6502W&(A&): A& = A& + 2
DIST& = OP6502W&(A&): A& = A& + 2
LENGTH& = OP6502W&(A&): A& = A& + 2
WORDS REG.PC, A&
'cycle = length& * 6
CYCLE& = CYCLE& + LENGTH& * 6
END SUB

FUNCTION vramg (A%)
vramg = rdvmmb(Vram& + A%)

END FUNCTION

SUB VRAMp (A%, b%)
WRVMMB Vram& + A%, b%
END SUB

FUNCTION word& (rg AS PCC)
'A% = CVI(CHR$(RG.L) + CHR$(RG.H))
'WORD& = CVL(MKI$(A%) + MKI$(0))

word& = rg.L + rg.H * 2 ^ 8
'word& = CVL(CHR$(RG.l) + CHR$(RG.h) + MKI$(0))



END FUNCTION

SUB WORDS (rg AS PCC, a1&)
'A% = CVI(MKL$(A&))
'RG.L = ASC(MKI$(A%))
'RG.H = ASC(MID$(MKI$(A%), 2))
A& = a1&

IF A& < 0 THEN A& = 65536 + A&
A& = A& AND &HFFFF
rg.L = A& AND &HFF
'RG.L = ASC(MKL$(A&))
rg.H = A& \ 2 ^ 8

'RG.H = ASC(MID$(MKL$(A&), 2))


END SUB

SUB Wr6502 (A&, V)
'PRINT "Wr6502("; HEX$(A&); ")";
p = A& \ 2 ^ 13
IF page&(p) <> ioarea& THEN
WRVMMB page&(p) + A&, V
ELSE
io_write A&, V
END IF
END SUB

SUB wrRAM (A&, b%)
'PRINT "WrRAM("; HEX$(A&); ")";
WRVMMB A& + ram&, b%
END SUB

