DECLARE SUB ENDPROG ()
DECLARE SUB VMMEND ()
DECLARE SUB initvmm (SIZE%)
DECLARE SUB lockvmm (A&, b&)
DECLARE SUB wrvmmb (A&, b%)
DECLARE FUNCTION vramg% (A%)
DECLARE SUB VRAMp (A%, b%)
DECLARE SUB MOVLEN (S&, D&, L&)
DECLARE SUB cmdd (cmd1%, CMD2%)
DECLARE FUNCTION cmdrr% (cmd%)
DECLARE FUNCTION notb% (A%)
DECLARE SUB cmdc (cmd%, rg AS ANY)
DECLARE SUB T_INIT (src&, DIST&, LENGTH&)
DECLARE FUNCTION rdvmmb% (A&)
DECLARE SUB loadpce (f%)
DECLARE FUNCTION allocvmm& (SIZE&)
DECLARE SUB wrvmm (adr&, D$)
DECLARE FUNCTION io_read% (A&)
DECLARE SUB REGINC (rg AS ANY)
DECLARE SUB instr.init ()
DECLARE FUNCTION opcode$ (I AS INTEGER)
DECLARE FUNCTION op6502i% (rg AS ANY)
DECLARE SUB BANK.SET (A%, b%)
DECLARE SUB CODES (I%)
DECLARE SUB io_write (A&, b%)
DECLARE SUB M.LDWORD (rg AS ANY)
DECLARE FUNCTION MCZp% ()
DECLARE FUNCTION MCZx% ()
DECLARE FUNCTION MCZY% ()
DECLARE FUNCTION nop6502% (rg AS ANY)
DECLARE FUNCTION op6502% (A&)
DECLARE FUNCTION OP6502W& (A&)
DECLARE FUNCTION RDVMMW& (A&)
DECLARE FUNCTION Rd6502% (A&)
DECLARE FUNCTION RdRAM% (A&)
DECLARE SUB RESET6502 ()
DECLARE SUB RUN6502 ()
DECLARE FUNCTION word& (rg AS ANY)
DECLARE SUB WORDS (rg AS ANY, A&)
DECLARE SUB Wr6502 (A&, b%)
DECLARE SUB wrRAM (A&, b%)
DECLARE SUB cmdr (cmd%, rg%)
DECLARE SUB M.CMP (rg1%, rg2%)
DECLARE SUB M.JR ()
DEFINT A-Z




'TYPE bb  'change this around for lsb fists, last
'L AS INTEGER
'H AS INTEGER
'END TYPE


'TYPE PCC
' W AS INTEGER
' B AS bb
'END TYPE

TYPE PCC
 L AS INTEGER
 H AS INTEGER
END TYPE

TYPE regg
 p AS INTEGER        'one byte register
 A AS INTEGER        '
 x AS INTEGER        '
 y AS INTEGER        '
 S AS INTEGER        '
 pc AS PCC           'word
 NF AS INTEGER 'one byte flag (last set)
 VF AS INTEGER '
 ZF AS INTEGER '
 MPR(7) AS INTEGER   'memory mapping registers pagr<->mmap (byte)
 IRequest AS INTEGER
 ICount AS INTEGER
 IBackup AS INTEGER
 AfterCLI AS INTEGER
 IPeriod AS INTEGER
 USER AS INTEGER
END TYPE

TYPE ioo
 VDC(32) AS PCC              'pair
 VCE(&H200) AS PCC
 vce_reg AS PCC
 'vdc
 vdc_inc AS LONG             'word
 vdc_raster_count AS LONG
 vdc_reg AS INTEGER          'byte
 vdc_status AS INTEGER
 VDC_ratch AS INTEGER
 vce_ratch AS INTEGER
 vdc_satb AS INTEGER
 vdc_pendvsync AS INTEGER
 bg_h AS INTEGER             'integer
 bg_w AS INTEGER
 scroll_y AS INTEGER
 minline AS INTEGER
 MaxLine AS INTEGER
 'joypad
 JOY(16) AS INTEGER          'byte
 joy_select AS INTEGER
 joy_counter AS INTEGER
 'psg
  PSG(6, 8) AS INTEGER
  wave(6, 32) AS INTEGER
  wavofs(6) AS INTEGER

  '// PSG STRUCTURE
  '// 0 : dda_out
  '// 2 : freq (lo byte)  In reality it's a divisor
  '// 3 : freq (hi byte)
  '// 4 : dda_ctrl
  '//     000XXXXX
  '//     ^^  ^
  '//     ||  ch. vol
  '//     ||
  '//     |direct access (everything at byte 0)
  '//     |
  '//    enable
  '// 5 : pan (left vol = hi nibble, right vol = low nibble)
  '// 7 : noise_ctrl
  psg_ch AS INTEGER         'byte
  psg_volume AS INTEGER
  psg_lfo_freq AS INTEGER
  psg_lfo_ctrl AS INTEGER
  '/* TIMER */
  timer_reload AS INTEGER  'byte
  timer_start AS INTEGER
  timer_counter AS INTEGER
  '/* IRQ */
    irq_mask AS INTEGER    'byte
    irq_status AS INTEGER
  '/* CDROM extention */
   backup AS INTEGER          'integer
   adpcm_firstread AS INTEGER 'integwer
   adpcm AS PCC               'pair
   adpcm_rptr AS LONG         'word
   adpcm_wptr AS LONG
 END TYPE





'byte = unsigned char (1)
'word = unsigned short (2)
'offset = signed char

'UNION pair
' word w
' int b {byte l,h}
'end type
' n
' n.w
' n.b (n.b.l,n.b.h)


                       '       /* 6502 status flags:         */
CONST c.flag = &H1     '       /* 1: Carry occured           */
                       '       /* notb c.flag
CONST Z.FLAG = &H2     '       /* 1: Result is zero          */
CONST I.flag = &H4     '       /* 1: Interrupts disabled     */
CONST D.flag = &H8     '       /* 1: Decimal mode            */
CONST b.flag = &H10    '       /* Break [0 on stk after int] */
CONST T.flag = &H20    '       /* Memory Operation Flag      */
CONST V.FLAG = &H40    '       /* 1: Overflow occured        */
CONST N.FLAG = &H80    '       /* 1: Result is negative      */


CONST cn.flag = NOT c.flag AND &HFF
CONST DN.FLAG = NOT D.flag AND &HFF
CONST IN.FLAG = NOT I.flag AND &HFF
CONST Tn.flag = NOT T.flag AND &HFF



CONST byt = &HFF       '       /* byte
CONST wrd = &HFFFF     '       /* word

'                      '       /* Loop6502() returns:        */
CONST INT.NONE = 0     '       /* No interrupt required      */
CONST INT.IRQ = 1      '       /* Standard IRQ interrupt     */
CONST INT.NMI = 2      '       /* Non-maskable interrupt     */
CONST INT.QUIT = 3     '       /* Exit the emulation         */

CONST INT.TIMER = 4
CONST INT.IRQ2 = 8
CONST VEC.RESET = &HFFFE
CONST VER.NMI = &HFFFC
CONST vec.timer = &HFFFA
CONST VEC.IRQ = &HFFF8
CONST VER.IRQ2 = &HFFF6
CONST VEC.BRK = &HFFFE
CONST zp = 0              'stack page
CONST sp = &H100          'zero page





DIM SHARED reg AS regg, K AS PCC, j AS PCC, CYCLES%(255), I, LASTSTR, II
DIM SHARED CYCLE&, page&(7), ROMMAP&(255), Vram&, ram&, popram&, ROM&, ioarea&, io AS ioo
DIM SHARED ta AS PCC, COUNTER&, ts!, Pal(512)
DIM SHARED JUMPSTA(255) AS PCC, JS, JSS, JUMPSTAA(255)
DIM SHARED CMDSET1(255), CMDSET2(255), cmd1(255), CMD2(255), cmr1(255), CMr2(255)


CONST FILE1 = "neutop1.pce", file2 = "bonk3.pce", FILE3 = "BOMB94.PCE", file4 = "WONDRBOY.PCE", FILE5 = "SF2.PCE"
OPEN FILE3 FOR BINARY ACCESS READ AS #1
CLS
initvmm 2048 * 4
loadpce 1

RESTORE cycledata
FOR II = 0 TO 255: READ CYCLES%(II): NEXT II
RESTORE CMDDSETDATA
FOR II = 0 TO 255: READ CMDSET1(II), CMDSET2(II)
NEXT II
RESTORE CMDDDATA
FOR II = 0 TO 255: READ cmd1(II), CMD2(II)
NEXT II
RESTORE CMDrDATA
FOR II = 0 TO 255: READ cmr1(II), CMr2(II)
NEXT II



CLS
 RUN6502
ENDPROG



cycledata:
'static byte Cycles[256] =
DATA     8,7,3, 4,6,4,6,7,3,2,2,0,7,5,7,6
DATA     2,7,7, 4,6,4,6,7,2,5,2,0,7,5,7,6
DATA     7,7,3, 4,4,4,6,7,3,2,2,0,5,5,7,6
DATA     2,7,7, 0,4,4,6,7,2,5,2,0,5,5,7,6
DATA     7,7,3, 4,8,4,6,7,3,2,2,0,4,5,7,6
DATA     2,7,7, 5,0,4,6,7,2,5,3,0,0,5,7,6
DATA     7,7,2, 0,4,4,6,7,3,2,2,0,7,5,7,6
DATA     2,7,7,17,4,4,6,7,2,5,3,0,7,5,7,6
DATA     4,7,2, 7,4,4,4,7,2,2,2,0,5,5,5,6
DATA     2,7,7, 8,4,4,4,7,2,5,2,0,5,5,5,6
DATA     2,7,2, 7,4,4,4,7,2,2,2,0,5,5,5,6
DATA     2,7,7, 8,4,4,4,7,2,5,2,0,5,5,5,6
DATA     2,7,2,17,4,4,6,7,2,2,2,0,5,5,7,6
DATA     2,7,7,17,0,4,6,7,2,5,3,0,0,5,7,6
DATA     2,7,0,17,4,4,6,7,2,2,2,0,5,5,7,6
DATA     2,7,7,17,2,4,6,7,2,5,3,0,0,5,7,0
 

CONST M.NUL = 0, m.inc = 1, M.DEC = 2, M.ROR = 3, M.ROL = 4, M.LSR = 5, m.asl = 6, TRB = 7, TSB = 8
CONST m.adc = 9, m.and = 10, m.andx = 11, m.bit = 12, m.eor = 13, m.eorx = 14
CONST m.fl = 15, m.ora = 16, m.orax = 17, m.pop = 18, m.push = 19, M.RMB = 20
CONST mm.zx = 21, MM.Zp = 22, mm.ax = 23, MM.Ab = 24
CONST mr.ab = 25, mr.ax = 26, mr.ay = 27, mr.id = 28, mr.im = 29, mr.ix = 30, mr.iy = 31, mr.zp = 32, mr.zx = 33, mr.zy = 34
CONST mw.ab = 35, mw.ax = 36, mw.ay = 37, mw.ix = 38, mw.iy = 39, mw.zp = 40, mw.zx = 41, mw.zy = 42
CONST m.sbc = 43
CONST M.SMB = 44
CONST m.adcx = 45
CONST mc.ab = 46, mc.ax = 47, mc.ay = 48, mc.id = 49, mc.ix = 50, mc.iy = 51, mc.zp = 52, mc.zx = 53, mc.zy = 54
CONST m.pop.p = 55, m.push.p = 56
'148KHZ with DEBUG OFF
'152KHZ with CMDDSETDATA
'25MHZ MAX SPEED (LONG INC)

CMDDSETDATA: 'SET(F4) COMMANDS(0-FF):CMDD CMD1,CMD2  00,00 = NULL
DATA 00,00, 30,17, 00,00, 00,00, 00,00, 32,17, 00,00, 00,00, 00,00, 29,17
DATA 00,00, 00,00, 00,00, 25,17, 00,00, 00,00, 00,00, 31,17, 28,17, 00,00
DATA 00,00, 33,17, 00,00, 00,00, 00,00, 27,17, 00,00, 00,00, 00,00, 26,17
DATA 00,00, 00,00, 00,00, 30,11, 00,00, 00,00, 00,00, 32,11, 00,00, 00,00
DATA 00,00, 29,11, 00,00, 00,00, 00,00, 25,11, 00,00, 00,00, 00,00, 31,11
DATA 28,11, 00,00, 00,00, 33,11, 00,00, 00,00, 00,00, 27,11, 00,00, 00,00
DATA 00,00, 26,11, 00,00, 00,00, 00,00, 30,14, 00,00, 00,00, 00,00, 32,14
DATA 00,00, 00,00, 00,00, 29,14, 00,00, 00,00, 00,00, 25,14, 00,00, 00,00
DATA 00,00, 31,14, 28,14, 00,00, 00,00, 33,14, 00,00, 00,00, 00,00, 27,14
DATA 00,00, 00,00, 00,00, 26,14, 00,00, 00,00, 00,00, 30,45, 00,00, 00,00
DATA 00,00, 32,45, 00,00, 00,00, 00,00, 29,45, 00,00, 00,00, 00,00, 25,45
DATA 00,00, 00,00, 00,00, 31,45, 28,45, 00,00, 00,00, 33,45, 00,00, 00,00
DATA 00,00, 27,45, 00,00, 00,00, 00,00, 26,45, 00,00, 00,00, 00,00, 00,00
DATA 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00
DATA 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00
DATA 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00
DATA 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00
DATA 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00
DATA 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00
DATA 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00
DATA 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00
DATA 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00
DATA 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00
DATA 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00
DATA 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00
DATA 00,00, 00,00, 00,00, 00,00, 00,00, 00,00

CMDDDATA:
DATA 00,00, 30,16, 00,00, 00,00, 00,00, 32,16, 00,00, 00,00, 00,00, 29,16
DATA 00,00, 00,00, 00,00, 25,16, 00,00, 00,00, 00,00, 31,16, 28,16, 00,00
DATA 00,00, 33,16, 00,00, 00,00, 00,00, 27,16, 00,00, 00,00, 00,00, 26,16
DATA 00,00, 00,00, 00,00, 30,10, 00,00, 00,00, 32,12, 32,10, 00,00, 00,00
DATA 00,00, 29,10, 00,00, 00,00, 25,12, 25,10, 00,00, 00,00, 00,00, 31,10
DATA 28,10, 00,00, 33,12, 33,10, 00,00, 00,00, 00,00, 27,10, 00,00, 00,00
DATA 26,12, 26,10, 00,00, 00,00, 00,00, 30,13, 00,00, 00,00, 00,00, 32,13
DATA 00,00, 00,00, 00,00, 29,13, 00,00, 00,00, 00,00, 25,13, 00,00, 00,00
DATA 00,00, 31,13, 28,13, 00,00, 00,00, 33,13, 00,00, 00,00, 00,00, 27,13
DATA 00,00, 00,00, 00,00, 26,13, 00,00, 00,00, 00,00, 30,09, 00,00, 00,00
DATA 00,00, 32,09, 00,00, 00,00, 00,00, 29,09, 00,00, 00,00, 00,00, 25,09
DATA 00,00, 00,00, 00,00, 31,09, 28,09, 00,00, 00,00, 33,09, 00,00, 00,00
DATA 00,00, 27,09, 00,00, 00,00, 00,00, 26,09, 00,00, 00,00, 00,00, 00,00
DATA 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 29,12, 00,00, 00,00
DATA 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00
DATA 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00
DATA 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00
DATA 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00
DATA 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00
DATA 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00
DATA 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00
DATA 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00
DATA 00,00, 00,00, 00,00, 00,00, 00,00, 30,43, 00,00, 00,00, 00,00, 32,43
DATA 00,00, 00,00, 00,00, 29,43, 00,00, 00,00, 00,00, 25,43, 00,00, 00,00
DATA 00,00, 31,43, 28,43, 00,00, 00,00, 33,43, 00,00, 00,00, 00,00, 27,43
DATA 00,00, 00,00, 00,00, 26,43, 00,00, 00,00

CMDrDATA:
DATA 00,00, 00,00, 00,00, 00,00, 22,08, 00,00, 22,06, 20,01, 00,00, 00,00
DATA 00,00, 00,00, 24,08, 00,00, 24,06, 00,00, 00,00, 00,00, 00,00, 00,00
DATA 22,07, 00,00, 21,06, 20,02, 00,00, 00,00, 00,00, 00,00, 24,07, 00,00
DATA 23,06, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 22,04, 20,04
DATA 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 24,04, 00,00, 00,00, 00,00
DATA 00,00, 00,00, 00,00, 00,00, 21,04, 20,08, 00,00, 00,00, 00,00, 00,00
DATA 00,00, 00,00, 23,04, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00
DATA 22,05, 20,16, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 24,05, 00,00
DATA 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 21,05, 20,32, 00,00, 00,00
DATA 00,00, 00,00, 00,00, 00,00, 23,05, 00,00, 00,00, 00,00, 00,00, 00,00
DATA 40,00, 00,00, 22,03, 20,64, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00
DATA 24,03, 00,00, 00,00, 00,00, 00,00, 00,00, 41,00, 00,00, 21,03, 20,128
DATA 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 23,03, 00,00, 00,00, 00,00
DATA 00,00, 00,00, 00,00, 00,00, 00,00, 44,01, 00,00, 00,00, 00,00, 00,00
DATA 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00
DATA 00,00, 44,02, 00,00, 00,00, 00,00, 00,00, 35,00, 00,00, 36,00, 00,00
DATA 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 44,04, 00,00, 00,00
DATA 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00
DATA 00,00, 00,00, 00,00, 44,08, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00
DATA 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 22,02, 44,16
DATA 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 24,02, 00,00, 00,00, 00,00
DATA 00,00, 00,00, 00,00, 00,00, 21,02, 44,32, 00,00, 00,00, 00,00, 00,00
DATA 00,00, 00,00, 23,02, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00
DATA 22,01, 44,64, 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 24,01, 00,00
DATA 00,00, 00,00, 00,00, 00,00, 00,00, 00,00, 21,01, 44,128, 00,00, 00,00
DATA 00,00, 00,00, 00,00, 00,00, 23,01, 00,00

SUB BANK.SET (p, V)

IF ROMMAP&(V) = ioarea& THEN
page&(p) = ioarea&
ELSE

page&(p) = ROMMAP&(V) - p * 8192&


END IF
END SUB

SUB cmdc (cmd, rg AS PCC)
SELECT CASE cmd
CASE 0: PRINT "error cmdc": ENDPROG

CASE mc.ab
   M.LDWORD rg
CASE mc.ax
  M.LDWORD rg
  WORDS rg, word(rg) + reg.x

CASE mc.ay
  M.LDWORD rg
  WORDS rg, word(rg) + reg.y

CASE mc.id
  WORDS K, MCZp()
  rg.L = RdRAM(word(K))
  rg.H = RdRAM(word(K) + 1)
CASE mc.ix
  WORDS K, MCZx()
  rg.L = RdRAM(word(K))
  rg.H = RdRAM(word(K) + 1)
CASE mc.iy
  WORDS K, MCZp()
  rg.L = RdRAM(word(K)): rg.H = RdRAM(word(K) + 1)
  WORDS rg, word(rg) + reg.y
CASE mc.zp
  rg.L = nop6502(reg.pc)
  rg.H = zp \ 2 ^ 8
CASE mc.zx
  rg.L = nop6502(reg.pc) + reg.x
  rg.H = zp \ 2 ^ 8
CASE mc.zy
  rg.L = nop6502(reg.pc) + reg.y
  rg.H = zp \ 2 ^ 8
CASE ELSE
  PRINT "Invalid CmdC"; cmd: ENDPROG
END SELECT


END SUB

SUB cmdd (cmd1, CMD2)
cmdr cmd1, I
cmdr CMD2, I
END SUB

SUB cmdr (cmd, rg)

SELECT CASE cmd
CASE M.NUL:
PRINT "error: CmdRg Null "; HEX$(LASTSTR): ENDPROG
CASE m.adc 'm.adc

  IF (reg.p AND D.flag) THEN

  K.L = (reg.A AND &HF) + (rg AND &HF) + (reg.p AND c.flag)
  K.H = (reg.A \ 2 ^ 4) + (rg \ 2 ^ 4)
    IF (K.L > 9) THEN K.L = K.L + 6: K.H = K.H + 1
    IF (K.H > 9) THEN K.H = K.H + 6
    reg.A = ((K.L AND &HF) OR (K.H * 2 ^ 4)) AND &HFF

    IF K.H > 15 THEN reg.p = reg.p OR c.flag ELSE reg.p = reg.p AND cn.flag
    
    
    'ZF = NF = A
    reg.ZF = reg.A
    reg.NF = reg.A
                CYCLE& = CYCLE& + 1

  ELSE

    WORDS K, reg.A + rg + (reg.p AND c.flag)
    IF K.H THEN reg.p = reg.p OR c.flag:  ELSE reg.p = reg.p AND cn.flag
    
    'ZF=NF=K.L
    reg.ZF = (notb(reg.A XOR rg) AND (reg.A XOR K.L)) \ 2 ^ 1
    reg.ZF = K.L
    reg.NF = K.L
    reg.A = K.L
   END IF
CASE m.adcx
 'MX = AdrRAM(reg.X + ZP)
  MX = RdRAM(reg.x + zp)
  IF (reg.p AND D.flag) THEN

    K.L = (MX AND &HF) + (rg AND &HF) + (reg.p AND c.flag)
    K.H = (MX \ 2 ^ 4) + (rg \ 2 ^ 4)';/*+(K.l>>4);*/ \
    IF (K.L > 9) THEN K.L = K.L + 6: K.H = K.H + 1
    IF (K.H > 9) THEN K.H = K.H + 6
    MX = ((K.L AND &HF) OR (K.H * 2 ^ 4)) AND &HFF

    IF K.H > 15 THEN reg.p = reg.p OR c.flag ELSE reg.p = reg.p AND cn.flag
    'ZF = NF = A
    reg.ZF = MX
    reg.NF = MX


    CYCLE& = CYCLE& + 1

  ELSE

    WORDS K, MX + rg + (reg.p AND c.flag)
    
    IF K.H THEN reg.p = reg.p OR c.flag ELSE reg.p = reg.p AND cn.flag
    reg.VF = (notb(MX XOR rg) AND (MX XOR K.L)) \ 2 ^ 1
    reg.ZF = K.L
    reg.NF = K.L

    MX = K.L

 END IF
 'AdrRAM(reg.X + ZP) = MX
  wrRAM reg.x + zp, MX

CASE m.and
  reg.A = reg.A AND rg
  cmdr m.fl, reg.A
CASE m.andx
   'AdrRAM(reg.x + zp) = AdrRAM(reg.x + zp) AND RG
   wrRAM reg.x + zp, RdRAM(reg.x + zp) AND rg
   cmdr m.fl, RdRAM(reg.x + zp)

CASE m.asl
   reg.p = reg.p AND cn.flag
   reg.p = reg.p OR rg \ 2 ^ 7
   rg = (rg * 2 ^ 1) AND &HFF
   cmdr m.fl, rg

CASE m.bit
  reg.NF = rg
  reg.VF = rg
  reg.ZF = rg AND reg.A
CASE m.inc
  rg = rg + 1
  cmdr m.fl, rg

CASE M.DEC
  rg = rg - 1
  cmdr m.fl, rg


CASE M.ROR
  
  K.L = (rg \ 2 ^ 1) OR (reg.p * 2 ^ 7)
  reg.p = reg.p AND cn.flag
  reg.p = reg.p OR (rg AND c.flag)
  'rg = k.l     'to fix possible overflow
  cmdr m.fl, K.L
  rg = K.L
CASE M.ROL
  K.L = (rg * 2 ^ 1) OR (reg.p AND c.flag)
  reg.p = reg.p AND cn.flag
  reg.p = reg.p OR (rg \ 2 ^ 7)
  'rg = k.l to fix possible overflow
  cmdr m.fl, K.L
  rg = K.L
CASE M.LSR
  reg.p = reg.p AND cn.flag
  reg.p = reg.p OR (rg AND c.flag)
  rg = rg \ 2 ^ 1
  cmdr m.fl, rg

CASE TRB

  'NF=VF=RG
  reg.NF = rg
  reg.VF = rg
  rg = rg AND notb(reg.A)
  reg.ZF = rg

CASE TSB:
  'NF=VF=RG
  reg.NF = rg
  reg.VF = rg
  rg = rg OR reg.A
  reg.ZF = rg
CASE m.eor
  reg.A = reg.A XOR rg
  cmdr m.fl, reg.A
CASE m.eorx
  'AdrRAM(reg.x + zp) = AdrRAM(reg.x + zp) XOR RG
  wrRAM reg.x + zp, RdRAM(reg.x + zp) XOR rg
  cmdr m.fl, RdRAM(reg.x + zp)
CASE m.fl
  'ZF=NF=RG


  rg = rg AND &HFF  'flow control if needed 0 -> ff -> 0
  reg.ZF = rg
  reg.NF = rg
CASE m.ora
  reg.A = reg.A OR rg
  cmdr m.fl, reg.A
CASE m.orax
  'AdrRAM(reg.x + zp) = AdrRAM(reg.x + zp) OR RG
  wrRAM reg.x + zp, RdRAM(reg.x + zp) OR rg
  cmdr m.fl, RdRAM(reg.x + zp)
CASE m.pop
  reg.S = (reg.S + 1) AND &HFF      'does this fix overflow
  rg = RdRAM(sp + reg.S)
CASE m.push
  wrRAM sp + reg.S, rg
  reg.S = (reg.S - 1) AND &HFF      'does this fix overflow
CASE m.pop.p
'NF=VF=RG
cmdr m.pop, rg
reg.NF = rg
reg.VF = rg
IF rg AND Z.FLAG THEN tmp = 0 ELSE tmp = 1
reg.ZF = tmp
CASE m.push.p
IF reg.ZF THEN tmp = 0 ELSE tmp = Z.FLAG
cmdr m.push, ((rg) AND notb(N.FLAG OR V.FLAG OR Z.FLAG)) OR (reg.NF AND N.FLAG) OR (reg.VF AND V.FLAG) OR tmp

CASE M.RMB
  'AdrRAM(MCZp()) = AdrRAM(MCZp()) AND NOT (N)
  wrRAM MCZp(), RdRAM(MCZp()) AND notb(rg)
CASE m.sbc
  '/* Warning! C_FLAG is inverted before SBC and after it */
    IF (reg.p AND D.flag) THEN

      K.L = ((reg.A AND &HF) - (rg AND &HF) - (notb(reg.p) AND c.flag)) AND &HFF
      IF (K.L AND &H10) THEN K.L = K.L - 6
      K.H = ((reg.A \ 2 ^ 4) - (rg \ 2 ^ 4) + ((K.L AND &H10) = &H10)) AND &HFF
      IF (K.H AND &H10) THEN K.H = K.H - 6
      reg.A = (K.L AND &HF) OR (K.H * 2 ^ 4) AND &HFF

      IF K.H AND &H10 THEN reg.p = reg.p AND cn.flag ELSE reg.p = reg.p OR c.flag

                  CYCLE& = CYCLE& + 1

    ELSE

      WORDS K, reg.A - rg - (notb(reg.p) AND c.flag)
      IF K.H THEN reg.p = reg.p AND cn.flag ELSE reg.p = reg.p OR c.flag
      

      reg.VF = ((reg.A XOR rg) AND (reg.A XOR K.L)) \ 2 ^ 1
      reg.ZF = K.L
      reg.NF = K.L
    END IF
CASE M.SMB
  'AdrRAM(MCZp()) = AdrRAM(MCZp()) OR N
  wrRAM MCZp(), RdRAM(MCZp()) OR rg
CASE MM.Ab
  cmdc mc.ab, j

  I = Rd6502(word(j))
  

  cmdr rg, I
  Wr6502 word(j), I
CASE mm.ax
  cmdc mc.ax, j
  I = Rd6502(word(j))
  cmdr rg, I
  Wr6502 word(j), I
CASE MM.Zp
  WORDS j, MCZp()
  I = RdRAM(word(j))
  cmdr rg, I
  wrRAM word(j), I
CASE mm.zx
  WORDS j, MCZx()
  I = RdRAM(word(j))
  cmdr rg, I
  wrRAM word(j), I

CASE mr.ab
 cmdc mc.ab, j
 rg = Rd6502(word(j))

CASE mr.ax
  cmdc mc.ax, j
  rg = Rd6502(word(j))
CASE mr.ay
  cmdc mc.ay, j
  rg = Rd6502(word(j))
CASE mr.id
  cmdc mc.id, j
  rg = Rd6502(word(j))
CASE mr.im
  rg = nop6502(reg.pc)

CASE mr.ix
  cmdc mc.ix, j
  rg = Rd6502(word(j))
CASE mr.iy
  cmdc mc.iy, j
  rg = Rd6502(word(j))
CASE mr.zp
  rg = RdRAM(MCZp())
CASE mr.zx
  rg = RdRAM(MCZx())
CASE mr.zy
  rg = RdRAM(MCZY())
CASE mw.ab
  cmdc mc.ab, j
  Wr6502 word(j), rg

CASE mw.ax
  cmdc mc.ax, j
  Wr6502 word(j), rg
CASE mw.ay
  cmdc mc.ay, j
  Wr6502 word(j), rg
CASE mw.ix
  cmdc mc.ix, j
  Wr6502 word(j), rg
CASE mw.iy
  cmdc mc.iy, j
  Wr6502 word(j), rg
CASE mw.zp
  wrRAM MCZp(), rg
CASE mw.zx
  wrRAM MCZx(), rg
CASE mw.zy
  wrRAM MCZY(), rg



CASE ELSE
PRINT "error: CmdRg not found(" + HEX$(cmd) + ")": ENDPROG
END SELECT
IF (rg AND byt) <> rg THEN PRINT "Error:byte overflow"; rg: ENDPROG



END SUB

FUNCTION cmdrr (cmd)
cmdr cmd, I
cmdrr = I
END FUNCTION

SUB CODES (I)
COUNTER& = COUNTER& + 1
LASTSTR = I
'PRINT "PC="; HEX$(word(reg.pc) - 1); " A="; HEX$(reg.a); " X="; HEX$(reg.x); " Y="; HEX$(reg.y); " S="; HEX$(reg.S); " P="; HEX$(reg.p);
'PRINT " zf="; HEX$(reg.ZF); " vf="; HEX$(reg.VF); " nf="; HEX$(reg.NF); " ";
'PRINT CYCLE& / (TIMER - ts!);
'PRINT counter&;
'PRINT cycle&;
'PRINT opcode$(I); " "; 'HEX$(I), cycle&
'PRINT
'KK$ = INPUT$(1)

'LINE INPUT #3, f$
'PRINT f$

SELECT CASE I
CASE &HD4'/* CSH set clock highspeed */
CASE &H54'/* CSL set clock lowspeed */

CASE &H44: '/* BSR * REL */   'FIXED
           cmdr m.push, reg.pc.H
           cmdr m.push, reg.pc.L
           'I = op6502i(reg.pc)
           'I = I + (I > 127) * 256
           'WORDS reg.pc, word(reg.pc) + I + 1
           


CASE &H80: '/* BRA * REL */
          I = op6502i(reg.pc)
          I = I + (I > 127) * 256
          WORDS reg.pc, word(reg.pc) + I + 1
          
CASE &H7C: '/* JMP ($ssss,x) */
        M.LDWORD K: WORDS K, word(K) + reg.x
        reg.pc.L = op6502i(K)
        reg.pc.H = op6502(word(K) + 1)
        
CASE &HDA: cmdr m.push, reg.x  '  /* PHX */
CASE &H5A: cmdr m.push, reg.y '               /* PHY */
CASE &HFA: cmdr m.pop, reg.x: cmdr m.fl, reg.x '    /* PLX */
CASE &H7A: cmdr m.pop, reg.y: cmdr m.fl, reg.y'      /* PLY */

CASE &H62: reg.A = 0' /* CLA */
CASE &H82: reg.x = 0' /* CLX */
CASE &HC2: reg.y = 0' /* CLY */

CASE &H2:  I = reg.x: reg.x = reg.y: reg.y = I'  /* SXY */
CASE &H22: I = reg.A: reg.A = reg.x: reg.x = I'  /* SAX */
CASE &H42: I = reg.A: reg.A = reg.y: reg.y = I'  /* SAY */

CASE &H3A: cmdr M.DEC, reg.A                  ' /* DEC A */
CASE &H1A: cmdr m.inc, reg.A                  ' /* INC A */



CASE &HD2: cmdr mr.id, I: M.CMP reg.A, I       '/* CMP ($ss) INDIR */
CASE &HB2: cmdr mr.id, reg.A: cmdr m.fl, reg.A '/* LDA ($ss) INDIR */
CASE &H92: cmdc mc.id, j: Wr6502 word(j), reg.A'/* STA ($ss) INDIR */



CASE &HF4: ' /* SET */
        I = op6502i(reg.pc)
        CYCLE& = CYCLE& + CYCLES(I) + 3
        cmdd CMDSET1(I), CMDSET2(I)  'IF ERROR, TAKE BACK OFF CYCLES(I)


CASE &H3: io_write 0, nop6502(reg.pc)  '/* ST0 */
CASE &H13: io_write 2, nop6502(reg.pc) '/* ST1 */
CASE &H23: io_write 3, nop6502(reg.pc) '/* ST2 */

CASE &H43: '/* TMAi */
        I = nop6502(reg.pc)
          FOR II = 0 TO 7
              IF (I AND 2 ^ II) THEN EXIT FOR
          NEXT II
          reg.A = reg.MPR(II)
CASE &H53: '/* TAMi */

        I = nop6502(reg.pc)
         FOR II = 0 TO 7
              IF I AND 2 ^ II THEN
                        reg.MPR(II) = reg.A
                        BANK.SET II, reg.A
              'EXIT FOR
              END IF
         NEXT II

CASE &HC3: ' /* TDD */
        T_INIT src&, DIST&, LENGTH&
        DO
        Wr6502 DIST&, Rd6502(src&)
        DIST& = DIST& - 1
        src& = src& - 1
        LENGTH& = LENGTH& - 1
        LOOP WHILE LENGTH&

CASE &H73: ' /* TII */
        T_INIT src&, DIST&, LENGTH&
        DO
             Wr6502 DIST&, Rd6502(src&)
             DIST& = DIST& + 1
             src& = src& + 1
             LENGTH& = LENGTH& - 1
        LOOP WHILE LENGTH&


CASE &HE3: ' /* TIA */
        T_INIT src&, DIST&, LENGTH&
        DO
                Wr6502 DIST&, Rd6502(src&)
                src& = src& + 1
                ' if (!(--length)):break
                LENGTH& = LENGTH& - 1
                IF LENGTH& = 0 THEN EXIT DO
                Wr6502 DIST& + 1, Rd6502(src&)
                src& = src& + 1
                lenght& = LENGTH& - 1
        LOOP WHILE LENGTH&


CASE &HF3: ' /* TAI */

        T_INIT src&, DIST&, LENGTH&
         DO
                Wr6502 DIST&, Rd6502(src&)
                DIST& = DIST& + 1
                LENGTH& = LENGTH& - 1
               IF LENGTH& = 0 THEN EXIT DO
               Wr6502 DIST&, Rd6502(src& + 1)
               DIST& = DIST& + 1
               LENGTH& = LENGTH& - 1
         LOOP WHILE LENGTH&
        

CASE &HD3: ' /* TIN */
        T_INIT src&, DIST&, LENGTH&
        DO
                Wr6502 DIST&, Rd6502(src&)
                src& = src& + 1
        LENGTH& = LENGTH& - 1
        LOOP WHILE LENGTH&


CASE &H83: '/* TST #$ss,$ss IMM,ZP */
        I = nop6502(reg.pc): II = RdRAM(MCZp())
        reg.NF = II
        reg.VF = II: reg.ZF = I AND II

CASE &HA3: '/* TST #$ss,$ss,x IMM,ZP,x */
        I = nop6502(reg.pc): II = RdRAM(MCZx())
        reg.NF = II
        reg.VF = II: reg.ZF = I AND II
CASE &H93: '/* TST #$ss,$ssss IMM,ABS */
        I = nop6502(reg.pc): cmdr mr.ab, II
        reg.NF = II
        reg.VF = II: reg.ZF = I AND II

CASE &HB3: '/* TST #$ss,$ssss,x IMM,ABS,x */
        I = nop6502(reg.pc): cmdr mr.ax, II
        reg.NF = II
        reg.VF = II: reg.ZF = I AND II

'SBC
 
CASE &H10: IF (reg.NF AND N.FLAG) THEN REGINC reg.pc ELSE M.JR  '/* BPL * REL */
CASE &H30: IF (reg.NF AND N.FLAG) THEN M.JR ELSE REGINC reg.pc  '/* BMI * REL */
CASE &HD0: IF reg.ZF = 0 THEN REGINC reg.pc ELSE M.JR      '/* BNE * REL */
CASE &HF0: IF reg.ZF = 0 THEN M.JR ELSE REGINC reg.pc     '/* BEQ * REL */
CASE &H90: IF (reg.p AND c.flag) THEN REGINC reg.pc ELSE M.JR '/* BCC * REL */
CASE &HB0: IF (reg.p AND c.flag) THEN M.JR ELSE REGINC reg.pc '/* BCS * REL */
CASE &H50: IF (reg.VF AND V.FLAG) THEN REGINC reg.pc ELSE M.JR'/* BVC * REL */
CASE &H70: IF (reg.VF AND V.FLAG) THEN M.JR ELSE REGINC reg.pc '/* BVS * REL */


CASE &H40: '/* RTI */

  I = reg.p


  cmdr m.pop.p, reg.p

  IF ((reg.IRequest <> INT.NONE) AND (I AND I.flag) <> 0 AND NOT (reg.p AND I.flag) <> 0) THEN
     REGAfterCLI = 1
    reg.IBackup = reg.ICount
    reg.ICount = 0
    END IF
    cmdr m.pop, reg.pc.L
    cmdr m.pop, reg.pc.H



CASE &H60: '/* RTS */
  cmdr m.pop, reg.pc.L: cmdr m.pop, reg.pc.H: REGINC reg.pc
  'JS = JS - 1
  'REGINC JUMPSTA(JS)
  'PRINT HEX$(word(JUMPSTA(JS)));

CASE &H20: '/* JSR $ssss ABS */
  
  K.L = nop6502(reg.pc)
  K.H = op6502i(reg.pc)
  'JUMPSTA(JS) = REG.PC
  cmdr m.push, reg.pc.H
  cmdr m.push, reg.pc.L
  reg.pc = K
  'JS = JS + 1
  'JSS = JSS + 1
CASE &H4C: M.LDWORD K: reg.pc = K'/* JMP $ssss ABS */

CASE &H6C: '/* JMP ($ssss) ABDINDIR */
  M.LDWORD K
  reg.pc.L = nop6502(K)
  reg.pc.H = op6502i(K)


CASE &H0: '/* BRK */
  REGINC reg.pc
  cmdr m.push, reg.pc.H: cmdr m.push, reg.pc.L
  cmdr m.push.p, reg.p AND Tn.flag OR (b.flag)
  reg.p = (reg.p OR I.flag) AND DN.FLAG
  K = reg.pc
  reg.pc.L = op6502(VEC.BRK)
  reg.pc.H = op6502(VEC.BRK + 1)
  PRINT ERR, "BRK instruction " + HEX$(word(K) - 1)
  ENDPROG



CASE &H58: '/* CLI */
  IF ((reg.IRequest <> INT.NONE) AND (reg.p AND I.flag) <> 0) THEN
  
    reg.AfterCLI = 1
    reg.IBackup = reg.ICount
    reg.ICount = 0

  END IF
  reg.p = reg.p AND IN.FLAG



CASE &H28: '/* PLP */
  cmdr m.pop.p, I

  IF ((reg.IRequest <> INT.NONE) AND ((I XOR reg.p) AND notb(I) AND I.flag) <> 0) THEN

    reg.AfterCLI = 1
    reg.IBackup = reg.ICount
    reg.ICount = 0

  END IF
  reg.p = I



CASE &H8: cmdr m.push.p, reg.p AND Tn.flag OR b.flag'     /* PHP */
CASE &H18: reg.p = reg.p AND cn.flag          '     /* CLC */
CASE &HB8: reg.VF = 0                              '     /* CLV */
CASE &HD8: reg.p = reg.p AND DN.FLAG          '     /* CLD */
CASE &H38: reg.p = reg.p OR c.flag                 '     /* SEC */
CASE &HF8: reg.p = reg.p OR D.flag                 '     /* SED */
CASE &H78: reg.p = reg.p OR I.flag                 '     /* SEI */
CASE &H48: cmdr m.push, reg.A          '             /* PHA */
CASE &H68: cmdr m.pop, reg.A: cmdr m.fl, reg.A       '     /* PLA */
CASE &H98: reg.A = reg.y: cmdr m.fl, reg.A     '     /* TYA */

'can i use cmdr m.inc, reg.y ?
CASE &HA8: reg.y = reg.A: cmdr m.fl, reg.y     '     /* TAY */
CASE &HC8: reg.y = reg.y + 1: cmdr m.fl, reg.y '     /* INY */
CASE &H88: reg.y = reg.y - 1: cmdr m.fl, reg.y '     /* DEY */
CASE &H8A: reg.A = reg.x: cmdr m.fl, reg.A     '     /* TXA */
CASE &HAA: reg.x = reg.A: cmdr m.fl, reg.x     '     /* TAX */
CASE &HE8: reg.x = reg.x + 1: cmdr m.fl, reg.x '     /* INX */
CASE &HCA: reg.x = reg.x - 1: cmdr m.fl, reg.x '     /* DEX */
CASE &HEA:  '                                  /* NOP */
CASE &H9A: reg.S = reg.x                 '     /* TXS */
CASE &HBA: reg.x = reg.S: cmdr m.fl, reg.x     '     /* TSX */



CASE &H84: cmdr mw.zp, reg.y                 '  /* STY $ss ZP */
CASE &H85: cmdr mw.zp, reg.A                 '  /* STA $ss ZP */
CASE &H86: cmdr mw.zp, reg.x                 '  /* STX $ss ZP */
CASE &HA4: cmdr mr.zp, reg.y: cmdr m.fl, reg.y    '  /* LDY $ss ZP */
CASE &HA5: cmdr mr.zp, reg.A: cmdr m.fl, reg.A    '  /* LDA $ss ZP */
CASE &HA6: cmdr mr.zp, reg.x: cmdr m.fl, reg.x     '  /* LDX $ss ZP */
CASE &HC4: cmdr mr.zp, I: M.CMP reg.y, I     '  /* CPY $ss ZP */
CASE &HC5: cmdr mr.zp, I: M.CMP reg.A, I     '  /* CMP $ss ZP */
CASE &HE4: cmdr mr.zp, I: M.CMP reg.x, I    '  /* CPX $ss ZP */
CASE &H8C: cmdr mw.ab, reg.y                 '  /* STY $ssss ABS */
CASE &H8D: cmdr mw.ab, reg.A                '  /* STA $ssss ABS */
CASE &H8E: cmdr mw.ab, reg.x                '  /* STX $ssss ABS */
CASE &HAC: cmdr mr.ab, reg.y: cmdr m.fl, reg.y     '  /* LDY $ssss ABS */
CASE &HAD: cmdr mr.ab, reg.A: cmdr m.fl, reg.A    '  /* LDA $ssss ABS */
CASE &HAE: cmdr mr.ab, reg.x: cmdr m.fl, reg.x     '  /* LDX $ssss ABS */
CASE &HCC: cmdr mr.ab, I: M.CMP reg.y, I     '  /* CPY $ssss ABS */
CASE &HCD: cmdr mr.ab, I: M.CMP reg.A, I     '  /* CMP $ssss ABS */
CASE &HEC: cmdr mr.ab, I: M.CMP reg.x, I    '  /* CPX $ssss ABS */
CASE &HA0: cmdr mr.im, reg.y: cmdr m.fl, reg.y     '  /* LDY #$ss IMM */
CASE &HA2: cmdr mr.im, reg.x: cmdr m.fl, reg.x     '  /* LDX #$ss IMM */
CASE &HA9: cmdr mr.im, reg.A: cmdr m.fl, reg.A     '  /* LDA #$ss IMM */
CASE &HC0: cmdr mr.im, I: M.CMP reg.y, I     '  /* CPY #$ss IMM */
CASE &HC9: cmdr mr.im, I: M.CMP reg.A, I     '  /* CMP #$ss IMM */
CASE &HE0: cmdr mr.im, I: M.CMP reg.x, I    '  /* CPX #$ss IMM */
CASE &H94: cmdr mw.zx, reg.y                 '  /* STY $ss,x ZP,x */
CASE &H95: cmdr mw.zx, reg.A                 '  /* STA $ss,x ZP,x */
CASE &H96: cmdr mw.zy, reg.x                 '  /* STX $ss,y ZP,y */
CASE &HB4: cmdr mr.zx, reg.y: cmdr m.fl, reg.y     '  /* LDY $ss,x ZP,x */
CASE &HB5: cmdr mr.zx, reg.A: cmdr m.fl, reg.A     '  /* LDA $ss,x ZP,x */
CASE &HB6: cmdr mr.zy, reg.x: cmdr m.fl, reg.x     '  /* LDX $ss,y ZP,y */
CASE &HD5: cmdr mr.zx, I: M.CMP reg.A, I     '  /* CMP $ss,x ZP,x */



CASE &H99: cmdr mw.ay, reg.A                 '  /* STA $ssss,y ABS,y */
CASE &H9D: cmdr mw.ax, reg.A                 '  /* STA $ssss,x ABS,x */
CASE &HB9: cmdr mr.ay, reg.A: cmdr m.fl, reg.A     '  /* LDA $ssss,y ABS,y */
CASE &HBC: cmdr mr.ax, reg.y: cmdr m.fl, reg.y     '  /* LDY $ssss,x ABS,x */
CASE &HBD: cmdr mr.ax, reg.A: cmdr m.fl, reg.A     '  /* LDA $ssss,x ABS,x */
CASE &HBE: cmdr mr.ay, reg.x: cmdr m.fl, reg.x     '  /* LDX $ssss,y ABS,y */
CASE &HD9: cmdr mr.ay, I: M.CMP reg.A, I     '  /* CMP $ssss,y ABS,y */
CASE &HDD: cmdr mr.ax, I: M.CMP reg.A, I     '  /* CMP $ssss,x ABS,x */
CASE &H81: cmdr mw.ix, reg.A                 '  /* STA ($ss,x) INDEXINDIR */
CASE &H91: cmdr mw.iy, reg.A                 '  /* STA ($ss),y INDIRINDEX */
CASE &HA1: cmdr mr.ix, reg.A: cmdr m.fl, reg.A     '  /* LDA ($ss,x) INDEXINDIR */
CASE &HB1: cmdr mr.iy, reg.A: cmdr m.fl, reg.A     '  /* LDA ($ss),y INDIRINDEX */
CASE &HC1: cmdr mr.ix, I: M.CMP reg.A, I     '  /* CMP ($ss,x) INDEXINDIR */
CASE &HD1: cmdr mr.iy, I: M.CMP reg.A, I     '  /* CMP ($ss),y INDIRINDEX */


CASE &HA:  cmdr m.asl, reg.A                 '  /* ASL a ACC */
CASE &H2A: cmdr M.ROL, reg.A                '  /* ROL a ACC */
CASE &H4A: cmdr M.LSR, reg.A                '  /* LSR a ACC */
CASE &H6A: cmdr M.ROR, reg.A                '  /* ROR a ACC */
CASE IS = ((cmd1(I) <> 0) AND I): cmdd cmd1(I), CMD2(I)
CASE IS = ((cmr1(I) <> 0) AND I): cmdr cmr1(I), CMr2(I)
CASE IS = (II OR &HF) '/* BBRi/BBSi
IF ((RdRAM(MCZp()) AND 2 ^ (I \ 2 ^ 4)) <> 0) AND (I < &H80) THEN REGINC reg.pc ELSE M.JR'BBRI, BBSI
CASE ELSE
  

'  IF (I AND &H87) = &H87 THEN CMDR M.SMB, 2 ^ (I \ 2 ^ 4)
 ' IF (I AND &H7) = &H7 THEN CMDR M.RMB, 2 ^ (I \ 2 ^ 4)
tt! = TIMER
PRINT CYCLE& / (tt! - ts!), COUNTER& / (tt! - ts!), tt! - ts!
PRINT CYCLE&, COUNTER&
PRINT
PRINT "ERROR:"; HEX$(word(reg.pc) - 1), HEX$(I): ENDPROG
'default:
'  if(_TrapBadOps) {
'    fprintf
'    ( stderr,
'      "[M6502 %lX] Unrecognized instruction: $%02X at PC=$%04X\n",
'      (unsigned)_User,Op6502(REG.PC.W-1),(word)(REG.PC.W-1)
'    );
'
'    _Trace=1;
'
'  }
'
'  break;
END SELECT

'PRINT
'kk$ = INPUT$(1)
NEXTCODES:
END SUB

SUB ENDPROG ()
VMMEND
END
END SUB

FUNCTION io_read (A&)
'PRINT "io_read "; HEX$(a&); ': END
EXIT FUNCTION
'byte IO_read(word A)
'byte ret

  SELECT CASE A& AND &H1C00
  CASE &H0:    '/* VDC */
    SELECT CASE A& AND 3
    CASE 0:
        ret = io.vdc_status
        io.vdc_status = 0';//&=VDC_InVBlank;//&=~VDC_BSY;
        io_read = ret: EXIT FUNCTION
    CASE 1:
        io_read = 0: EXIT FUNCTION
    CASE 2:
        IF (io.vdc_reg = VRR) THEN
            io_read = vramg(word(io.VDC(MARR)) * 2): EXIT FUNCTION

        ELSE
        io_read = io.VDC(io.vdc_reg).L: EXIT FUNCTION
        END IF
    CASE 3:
        IF (io.vdc_reg = VRR) THEN
            ret = vramg(word(io.VDC(MARR)) * 2 + 1)
            WORDS io.VDC(MARR), word(io.VDC(MARR)) + io.vdc_inc
            io_read = ret: EXIT FUNCTION
        ELSE
        io_read = io.VDC(io.vdc_reg).H: EXIT FUNCTION
        END IF
    END SELECT
    

  CASE &H400: '/* VCE */
    SELECT CASE A& AND 7
    CASE 4: io_read = io.VCE(word(io.vce_reg)).L: EXIT FUNCTION
    CASE 5: io_read = io.VCE(word(io.vce_reg)).H: WORDS io.vce_reg, word(io.vce_reg) + 1: EXIT FUNCTION
    END SELECT
    
'#ifndef FINAL_RELEASE
'  case 0x0800:  /* PSG */
'    switch(A&15){
'    case 0: return io.psg_ch;
'    case 1: return io.psg_volume;
'    case 2: return io.PSG[io.psg_ch][2];
'    case 3: return io.PSG[io.psg_ch][3];
'    case 4: return io.PSG[io.psg_ch][4];
'    case 5: return io.PSG[io.psg_ch][5];
'    CASE 6:
'        {
'            //int   ofs=io.wavofs[io.psg_ch];
'            //io.wavofs[io.psg_ch]=(io.wavofs[io.psg_ch]+1)&31;
'            //return io.wave[io.psg_ch][ofs];
'            int ofs=fixtoi(snd_pos[io.psg_ch]);
'            snd_pos[io.psg_ch]=itofix((fixtoi(snd_pos[io.psg_ch])+1)&31);
'            return io.wave[io.psg_ch][ofs];
'
'        }
'    case 7: return io.PSG[io.psg_ch][7];
'    case 8: return io.psg_lfo_freq;
'    case 9: return io.psg_lfo_ctrl;
'    default: return NODATA;
'    }
'    break;
'#endif
  CASE &HC00:  ' /* timer */
    io_read = io.timer_counter: EXIT FUNCTION

  CASE &H1000:  '/* joypad */

  
  ret = io.JOY(io.joy_counter) XOR &HFF
        IF io.joy_select AND 1 THEN
        ret = ret \ 2 ^ 4
        ELSE
        ret = ret AND 15: io.joy_counter = (io.joy_counter + 1) MOD 5
        END IF
        io_read = ret OR Country: EXIT FUNCTION'; /* country 0:JPN 1=US */


  CASE &H1400: ' /* IRQ */
    SELECT CASE A& AND 15
    CASE 2: io_read = io.irq_mask: EXIT FUNCTION
    CASE 3: ret = io.irq_status: io.irq_status = 0: io_read = ret: EXIT FUNCTION
    END SELECT
    

  CASE &H1800: ' /* CD-ROM extention */
    SELECT CASE A& AND 15
    CASE 3: io.backup = DISABLE: io_read = DISABLE: EXIT FUNCTION'return io.backup = disable
'//  case 0xa:
'//      if (!io.adpcm_firstread) return PCM[io.adpcm_rptr++];
'//      else {io.adpcm_firstread=FALSE; return NODATA;}
    END SELECT
    
    
  END SELECT
    io_read = NODATA


END FUNCTION

SUB io_write (A AS LONG, V)
'PRINT "io_write "; HEX$(a);
EXIT SUB

'A,v
  SELECT CASE A AND &H1C00
  CASE &H0:     '/* VDC */
        SELECT CASE A AND 3
        CASE 0: io.vdc_reg = V AND 31: EXIT SUB:
        CASE 1: EXIT SUB:
        END SELECT
    CASE 2:
       
        SELECT CASE io.vdc_reg
        CASE VWR:
                 
                  
        CASE hdr:
'                        io.screen_w = (V + 1) * 8:
                        
                        

        CASE MWR:
'                        'static byte bgw[]={32,64,128,128}:
'                        'io.bg_h=(V AND &h40)?64:32:
'                        'io.bg_w=bgw[(V>>4) AND 3]:}
'
'
'
        CASE BYR:
            IF scroll = 0 THEN
                                oldScrollX = ScrollX:
                                oldScrollY = ScrollY:
                                oldScrollYDiff = ScrollYDiff:
            END IF
                        io.VDC(BYR).L = V:
                        scroll = 1:
                                ScrollYDiff = scanline - 1:
                        EXIT SUB:
        CASE BXR:
            IF scroll = 0 THEN
                                oldScrollX = ScrollX:
                                oldScrollY = ScrollY:
                                oldScrollYDiff = ScrollYDiff:
            END IF
                        io.VDC(BXR).L = V:
                        scroll = 1:
                        EXIT SUB:


        END SELECT
                io.VDC(io.vdc_reg).L = V:
                EXIT SUB:
    CASE 3:

        SELECT CASE io.vdc_reg
        CASE VWR:
                 
                        VRAMp word(io.VDC(MAWR)) * 2, io.VDC_ratch:
                        VRAMp word(io.VDC(MAWR)) * 2 + 1, V
                        'vchanges(io.VDC(MAWR).W / 64) = 1:
                        'io.VDC[MAWR].W+=io.vdc_inc:
                        io.VDC_ratch = 0:
                        EXIT SUB:
        CASE VDW:
                        
                        io.VDC(VDW).H = V:
                        'io.screen_h = (io.VDC(VDW).W AND 511) + 1:
                        'MaxLine = io.screen_h - 1:
                        
                        EXIT SUB:
        CASE LENR:
                        
                        io.VDC(LENR).H = V:
                        
            '/* VRAM to VRAM DMA */
            'memcpy(VRAM+io.VDC[DISTR].W*2,VRAM+io.VDC[SOUR].W*2,
            '                    (io.VDC[LENR].W+1)*2):
            '            memset(vchange+io.VDC[DISTR].W/16,1,(io.VDC[LENR].W+1)/16):
            '            memset(vchange+io.VDC[DISTR].W/64,1,(io.VDC[LENR].W+1)/64):
'                        io.VDC[DISTR].W += io.VDC[LENR].W+1:
'                        io.VDC[SOUR].W += io.VDC[LENR].W+1:
'                        io.vdc_status|=VDC_DMAfinish:
'                        EXIT SUB:
        CASE CR:
'                        static byte incsize[]={1,32,64,128}:
'                        io.vdc_inc = incsize[(V>>3) AND 3]:
                        
            

        CASE hdr:
            
            
                        
        CASE BYR:
'            IF (scroll = 0) THEN
'                                oldScrollX = ScrollX:
'                                oldScrollY = ScrollY:
'                                oldScrollYDiff = ScrollYDiff:
'            END IF
'                        io.VDC(BYR).B.h = V AND 1:
'                        scroll = 1:
'                                ScrollYDiff = scanline - 1:
'
                        EXIT SUB:
        CASE SATB:
'                        io.VDC(SATB).B.h = V:
'
'
'                        io.vdc_satb = 1:
'                        io.vdc_status AND =~VDC_SATBfinish:
'                        EXIT SUB:
        CASE BXR:
'            IF (scroll = 0) THEN
'                                oldScrollX = ScrollX:
'                                oldScrollY = ScrollY:
'                                oldScrollYDiff = ScrollYDiff:
'            END IF
 '                       io.VDC(BXR).B.h = V AND 3:
'                        scroll = 1:
'                        EXIT SUB:


  '      END SELECT
                
'                io.VDC(io.vdc_reg).B.h = V:
'                EXIT SUB:
    END SELECT


  CASE &H400:   '/* VCE */
        SELECT CASE (A AND 7)
        CASE 0:
                
        CASE 2: io.vce_reg.L = V: EXIT SUB:
        CASE 3: io.vce_reg.H = V AND 1: EXIT SUB:
        CASE 4: io.VCE(word(io.vce_reg)).L = V:
'
'                 byte c: int i,n:
                 N = word(io.vce_reg)
                 c = word(io.VCE(N)) \ 2 ^ 1
         IF N = 0 THEN
                FOR II = O TO 255 STEP 16: Pal(II) = c: NEXT II
'                        for(i=0:i<256:i+=16) Pal[i]=c:
         ELSE IF (N AND 15) THEN Pal(N) = c:
        END IF


                EXIT SUB:
    CASE 5:
                io.VCE(word(io.vce_reg)).H = V:
        
'                 byte c: int i,n:
                 N = word(io.vce_reg)
                 c = word(io.VCE(N)) \ 2 ^ 1
        IF N = 0 THEN
        FOR II = 0 TO 255 STEP 16: Pal(II) = c: NEXT II
'                        'for(i=0:i<256:i+=16) Pal[i]=c:
             ELSE IF (N AND 15) THEN Pal(N) = c:
        END IF
                WORDS io.vce_reg, (word(io.vce_reg) + 1) AND &H1FF:
                EXIT SUB

        CASE 1:
        CASE 6:
        CASE 7:
    END SELECT
 


  CASE &HC00:   '/* timer */
        
        SELECT CASE A AND 1
        CASE 0: io.timer_reload = V AND 127: EXIT SUB:
    CASE 1:
'                V AND =1:
'                if (V  AND  AND  !io.timer_start)
'                        io.timer_counter = io.timer_reload:
'                io.timer_start = V:
'                EXIT SUB:
    END SELECT
        

  CASE &H1000: ' /* joypad */

'                io.joy_select = V AND 1:
'                if (V AND 2) io.joy_counter = 0:
'                EXIT SUB:

  CASE &H1400:  '/* IRQ */
        SELECT CASE A AND 15
        'CASE 2: io.irq_mask = V:
        'case 3: io.irq_status= (io.irq_status AND ~TIRQ)|(V AND &hF8): exit sub:
    END SELECT
        

  CASE &H1800: ' /* CD-ROM extention */
        SELECT CASE A AND 15
'        CASE 7: io.backup = ENABLE: EXIT SUB:
'
'        CASE 9: io.adpcm_ptr.B.h = V: EXIT SUB:
        'case &ha: PCM[io.adpcm_wptr++] = V: exit sub:
        CASE &HD:
'                if (V AND 4) io.adpcm_wptr = io.adpcm_ptr.W:
'                else { io.adpcm_rptr = io.adpcm_ptr.W: io.adpcm_firstread = TRUE: }
                EXIT SUB:
'*/
   END SELECT
        
  END SELECT


END SUB

SUB loadpce (f%)

    fs& = LOF(f%)
    hdr& = fs& AND &H1FFF
    fsize& = fs& AND NOT (&H1FFF)

    ROM& = allocvmm&(fs&)


    'popram& = allocvmm&(&H10000) 'byte
    ram& = allocvmm&(32768)      'byte
    Vram& = allocvmm&(&H10000)   'byte
    ioarea& = allocvmm&(&H2000)  'byte


    DO UNTIL adr& > fs&     'load rom
    D$ = INPUT$(32767, f%)
    wrvmm ROM& + adr&, D$
    D$ = ""
    adr& = adr& + 32767
    LOOP

    lockvmm ROM&, ram& - 1
    ROM& = ROM& + hdr&


    ROM.SIZE = fsize& \ &H2000
    rommask = 1
    

WHILE (rommask < ROM.SIZE)
    rommask = rommask * 2 ^ 1
    WEND
    rommask = rommask - 1
    

    FOR I = 0 TO &HF7

    
        IF (ROM.SIZE = &H30) THEN
        
            SELECT CASE (I AND &H70)
            
            
            
            CASE &H50, &H10, &H0:
                

            
            ROMMAP&(I) = ROM& + (I AND rommask) * 8192&
            
            CASE &H60, &H20:
                
                 

                 ROMMAP&(I) = ROM& + ((I - &H20) AND rommask) * 8192&
            
            CASE &H70, &H30:

                ROMMAP&(I) = ROM& + ((I - &H10) AND rommask) * 8192&
                
            CASE &H40:
                'rommap&(I) = rom& + ((I - &H20) AND rommask) * 8192&

            
            ROMMAP&(I) = ROM& + ((I - &H20) AND rommask) * 8192&
            END SELECT
        
        ELSE


     ROMMAP&(I) = ROM& + (I AND rommask) * 8192&'* &H2000
    'rommap&(i) = rom& + (i AND rommask) * &H2000
       END IF
    NEXT I


    ROMMAP&(&HF8) = ram&
    ROMMAP&(&HF9) = ram& + &H2000
    ROMMAP&(&HFA) = ram& + &H4000
    ROMMAP&(&HFB) = ram& + &H6000
    ROMMAP&(&HFF) = ioarea&' //NULL; /* NULL = I/O area */









END SUB

SUB M.CMP (rg1, rg2)
  WORDS K, rg1 - rg2
  IF K.H THEN reg.p = reg.p AND cn.flag ELSE reg.p = reg.p OR c.flag
  reg.ZF = K.L
  reg.NF = K.L
END SUB

SUB M.JR ()
'op6502i is offset
I = op6502i(reg.pc)
I = I + (I > 127) * 256
WORDS reg.pc, word(reg.pc) + I + 1
CYCLE& = CYCLE& + 2
END SUB

SUB M.LDWORD (rg AS PCC)
A& = word(reg.pc)
rg.L = op6502(A&)
rg.H = op6502(A& + 1)
WORDS reg.pc, A& + 2
END SUB

FUNCTION MCZp ()
MCZp = nop6502(reg.pc) + zp


END FUNCTION

FUNCTION MCZx ()
'error:op6502 isn't byte
MCZx = nop6502(reg.pc) + reg.x + zp

END FUNCTION

FUNCTION MCZY ()
'op6502 isn't byte
MCZY = nop6502(reg.pc) + reg.y + zp
END FUNCTION

FUNCTION nop6502 (rg AS PCC)
a1& = word(rg)
A& = a1&

p = A& \ 2 ^ 13
A& = page&(p) + A&

A& = rdvmmb(A&)
'PRINT HEX$(a&); " ";
nop6502 = A&
A& = a1&
A& = A& + 1
WORDS rg, A&
END FUNCTION

FUNCTION notb (A%)
notb = NOT (A%) AND &HFF
END FUNCTION

FUNCTION op6502 (a1&)
A& = a1&
IF A& < 0 THEN A& = 65536 + A&
'page = a& \ 2 ^ 13
p = A& \ 2 ^ 13
A& = page&(p) + A&

'IF a& >= 16384 AND a& < 20480 THEN a& = a& - 16384
'IF a& >= 24576 AND a& < 28672 THEN a& = a& - 24576
'IF a& >= 32768 AND a& < 36864 THEN a& = a& - 32768
'IF a& >= 40960 AND a& < 45056 THEN a& = a& - 40960
'IF a& >= 49152 AND a& < 53284 THEN a& = a& - 49152
'IF a& >= 57344 AND a& < 61440 THEN a& = a& - 57344
'IF a& < 24576 AND a& >= 20480 THEN a& = a& - 16384
'IF a& < 32768 AND a& >= 28672 THEN a& = a& - 24576
'IF a& < 40960 AND a& >= 36864 THEN a& = a& - 32768
'IF a& < 49152 AND a& >= 45056 THEN a& = a& - 40960
'IF a& < 57344 AND a& >= 53284 THEN a& = a& - 49152
'IF a& < 65536 AND a& >= 61440 THEN a& = a& - 57344

A& = rdvmmb(A&)
'PRINT HEX$(a&); " ";
op6502 = A&


END FUNCTION

FUNCTION op6502i (rg AS PCC)
A& = word(rg)
op6502i = op6502(A&)
END FUNCTION

FUNCTION OP6502W& (A&)
'error h,l order?
'a1% = op6502(A&)'l
'a2% = op6502(A& + 1)'h
'OP6502W& = a1% + a2% * 2 ^ 8
p = A& \ 2 ^ 13
OP6502W& = RDVMMW(page&(p) + A&)


END FUNCTION

FUNCTION Rd6502 (A&)
'PRINT "Rd6502("; HEX$(A&); ")";
p = A& \ 2 ^ 13
IF page&(p) <> ioarea& THEN
adr& = page&(p) + A&
Rd6502 = rdvmmb(adr&)
ELSE
Rd6502 = io_read(A&)
END IF



END FUNCTION

FUNCTION RdRAM% (A&)
RdRAM% = rdvmmb(ram& + A&)
END FUNCTION

SUB REGINC (rg AS PCC)
A& = word(rg) + 1
WORDS rg, A&

END SUB

SUB RESET6502 ()
  reg.MPR(7) = &H0: BANK.SET 7, &H0

   reg.MPR(6) = &H5: BANK.SET 6, &H5

   reg.MPR(5) = &H4: BANK.SET 5, &H4

   reg.MPR(4) = &H3: BANK.SET 4, &H3

   reg.MPR(3) = &H2: BANK.SET 3, &H2

   reg.MPR(2) = &H1: BANK.SET 2, &H1

   reg.MPR(1) = &HF8: BANK.SET 1, &HF8   'ram

   reg.MPR(0) = &HFF: BANK.SET 0, &HFF   'io area
  reg.A = 0: reg.x = 0: reg.y = 0
  reg.p = I.flag

  reg.NF = 0: reg.VF = 0

  reg.ZF = &HFF
  reg.S = &HFF

  reg.pc.L = op6502(VEC.RESET)
  reg.pc.H = op6502(VEC.RESET + 1)

  ta.L = op6502(vec.timer)
  ta.H = op6502(vec.timer + 1)


reg.ICount = reg.IPeriod
  reg.IRequest = INT.NONE
  reg.AfterCLI = 0
  '//_CycleCount=0;
  '(int)(R->User)=0;
  reg.USER = 0
END SUB

SUB RUN6502 ()
instr.init
DIM A AS regg
RESET6502

A = reg
A.pc = ta


ts! = TIMER - .01
DO

I = nop6502(reg.pc)
CYCLE& = CYCLE& + CYCLES(I)
CODES I


'SWAP a, reg: SWAP c&, cycle&  'needed to execute timer irq




LOOP
END SUB

SUB T_INIT (src&, DIST&, LENGTH&)
A& = word(reg.pc)
src& = OP6502W&(A&): A& = A& + 2
DIST& = OP6502W&(A&): A& = A& + 2
LENGTH& = OP6502W&(A&): A& = A& + 2
WORDS reg.pc, A&
'cycle = length& * 6
CYCLE& = CYCLE& + LENGTH& * 6
END SUB

FUNCTION vramg (A%)
vramg = rdvmmb(Vram& + A%)

END FUNCTION

SUB VRAMp (A%, b%)
wrvmmb Vram& + A%, b%
END SUB

FUNCTION word& (rg AS PCC)
'A% = CVI(CHR$(RG.L) + CHR$(RG.H))
'WORD& = CVL(MKI$(A%) + MKI$(0))

word& = rg.L + rg.H * 2 ^ 8
'word& = CVL(CHR$(RG.l) + CHR$(RG.h) + MKI$(0))



END FUNCTION

SUB WORDS (rg AS PCC, a1&)
A& = a1&
IF A& < 0 THEN A& = 65536 + A&
A& = A& AND &HFFFF
rg.L = A& AND &HFF
rg.H = A& \ 2 ^ 8
END SUB

SUB Wr6502 (A&, V)
'PRINT "Wr6502("; HEX$(A&); ")";
p = A& \ 2 ^ 13
IF page&(p) <> ioarea& THEN
wrvmmb page&(p) + A&, V
ELSE
io_write A&, V
END IF
END SUB

SUB wrRAM (A&, b%)
'PRINT "WrRAM("; HEX$(A&); ")";
wrvmmb A& + ram&, b%
END SUB

